Package: FGNet
Type: Package
Title: Functional Gene Networks derived from biological enrichment
        analyses
Description: Build and visualize functional gene and term networks from clustering of enrichment analyses in multiple annotation spaces. The package includes a graphical user interface (GUI) and functions to perform the functional enrichment analysis through DAVID, GeneTerm Linker, gage (GSEA) and topGO.
Version: 3.44.0
Date: 2022-04-08
Author: Sara Aibar, Celia Fontanillo, Conrad Droste and Javier De Las Rivas.
Maintainer: Sara Aibar <saibar@usal.es>
Depends: R (>= 4.2.0)
VignetteBuilder: knitr
Imports: igraph (>= 0.6), hwriter, R.utils, XML, plotrix, reshape2,
        RColorBrewer, png, methods, stats, utils, graphics, grDevices
Suggests: RCurl, gage, topGO, GO.db, reactome.db, RUnit, BiocGenerics,
        org.Sc.sgd.db, knitr, rmarkdown, AnnotationDbi, BiocManager
License: GPL (>= 2)
URL: http://www.cicancer.org
LazyLoad: yes
biocViews: Annotation, GO, Pathways, GeneSetEnrichment, Network,
        Visualization, FunctionalGenomics, NetworkEnrichment,
        Clustering
git_url: https://git.bioconductor.org/packages/FGNet
git_branch: RELEASE_3_22
git_last_commit: 30b9e81
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 03:57:23 UTC; biocbuild

# ... further argumets to pass to "read.csv"
# termSep: Splits multiple terms in "cell"/line
# termCatCol termIDCol: are pasted to term description, if only one term per line
format_results <- function(fileName, newFileName=NULL, clusterCol=NULL, geneCol=NULL, geneSep=NULL, termDescCol=NULL, termIDCol=NULL, termCatCol=NULL, termCat=NULL, termSep=NULL, tool="Imported text file", simplifyGage=TRUE, ...)
{
    rawResults <- fileName
    if(is.character(fileName) && file.exists(fileName)) rawResults <- read.csv(fileName, ...)
    
    # Format genes
    if(!is.null(geneSep)) rawResults[,geneCol] <- sapply(rawResults[,geneCol], function(x) paste(unlist(strsplit(as.character(x),split=geneSep)), collapse=","))
    if(!is.null(geneCol)) colnames(rawResults)[colnames(rawResults)==geneCol] <- "Genes" 
    
    # Format terms
    # Option A) One term per row, add ID or Category
    termInfo <- !all(is.null(termIDCol), is.null(termCatCol), is.null(termCat))
    if(!is.null(termSep) && termInfo) stop("Term ID and term category can only be used if there is only one term per row/gene-term set (termInfo=NULL).")
    if(!is.null(termCatCol) && !is.null(termCat)) stop("Please provide either termCatCol (column name) or termCat (a common value for all terms).")
    if(!is.null(termCat))
    {
        rawResults <- cbind(rawResults, TermCat=rep(termCat, nrow(rawResults)))
        termCatCol <- "TermCat"
    }
    tempTerm <- NULL
    if(!is.null(termCatCol))
    {
        tempTerm <- paste(rawResults[,termCatCol], ":", sep="")  # (avoid GO:GO:0000... )
        tempTerm[grep("GO:", rawResults[,termIDCol], fixed=TRUE)]<-""
    }
    if(!is.null(termIDCol)) tempTerm <- paste(tempTerm, rawResults[,termIDCol], ":", sep="")  
    if(!is.null(termDescCol)) 
    {
        tempTerm <- paste(tempTerm, rawResults[,termDescCol], sep="")
        if("Terms" %in% colnames(rawResults)) colnames(rawResults)[which(colnames(rawResults)=="Terms")] <- "Terms_raw"
        rawResults <- cbind(rawResults, Terms=tempTerm)
    }    
    # Option B) Several terms per row
    if(!is.null(termSep)) 
    {
        rawResults[,termDescCol] <- sapply(rawResults[,termDescCol], function(x) paste(unlist(strsplit(as.character(x),split=termSep)), collapse=","))
        if(!is.null(termDescCol)) colnames(rawResults)[colnames(rawResults)==termDescCol] <- "Terms" 
    }
    
    # Rename clusters
    if(!is.null(clusterCol)) colnames(rawResults)[colnames(rawResults)==clusterCol] <- "Cluster" 

    if(is.null(newFileName)) 
    {
        splitedFN <- strsplit(fileName,".", fixed=TRUE)[[1]]
        fName <- paste(splitedFN[1:(length(splitedFN)-1)], collapse=".")
        fExt <- NULL
        if(length(splitedFN)>1) fExt <- paste(".", splitedFN[length(splitedFN)], sep="")
        newFileName <- paste(fName, "_formatted", fExt, sep="")
    }

    write.table(rawResults, file=newFileName, quote=FALSE, sep="\t", row.names=FALSE)
    
    invisible(readGeneTermSets(newFileName, tool=tool, simplifyGage=simplifyGage))
}

    
# David global constants/variables (to avoid reconnect to webservice)
# newDavidVars <- function()
# { 
#     object <- new.env(parent=globalenv()) 
#     
#     # Constants:
#     object[["dav_DefaultAnnots"]] <- c("GOTERM_BP_ALL", "GOTERM_MF_ALL", "GOTERM_CC_ALL","INTERPRO") 
#     object[["dav_DefaultId"]] <- "ENSEMBL_GENE_ID"
#     
#     # Modified when selecting API or WS (global variables to avoid reconnect):
#     object[["DAV_GeneIds"]] <- NULL
#     object[["dav_wsGeneIds"]] <- NULL 
#     object[["dav_wsAnnots"]] <- NULL
#     
#     class(object) <- 'DavidVars'
#     return(object) 
# }  

tabFEA_fill <- function(mainWindow, statusbar, geneList)
{    
    tabFEA <- RGtk2::gtkHBox(FALSE,3)
    
    ##########################
    # jobName (added at the end)
    frameJobName <- RGtk2::gtkFrame("Job name")
    RGtk2::gtkFrameSetShadowType(frameJobName, GtkShadowType["none"])
    jobNameText <- RGtk2::gtkEntryNew()
    jobNameText$setWidthChars(25)
    jobNameText$SetTooltipText("New folder or file name")
    frameJobName$add(jobNameText)
    
    # Org info (used in GAGE and topGO)
    # allOrgs: also used in GAGE tab
    data("organisms", envir = environment())
    organisms<- get("organisms", envir  = environment())
    availableOrgs <- installed.packages()[,1]
    availableOrgs <- unique(availableOrgs[grep("org.*.db", availableOrgs)])
    orgInstalled <- rep(" - Not installed", nrow(organisms))
    orgInstalled[which(organisms[,"orgPackage"] %in% availableOrgs)] <- ""
    allOrgs <- list()
    allOrgs[["ID"]] <- setNames(1:nrow(organisms)-1, rownames(organisms))
    allOrgs[["Descr"]] <- setNames(allOrgs[["ID"]], paste(organisms[,"Name"], " (", organisms[,"orgPackage"], ")", orgInstalled, sep=""))
    
    ##################################################
    ##### 1. Box Left (genes area...)
    box.Left <- RGtk2::gtkVBoxNew(FALSE, 10)
    
    ##### a) Genes TEXT field
    #table.Left <- gtkTable(rows=20,columns=1)
    geneListFrame <- RGtk2::gtkFrameNew("Gene list (one per line)")
    RGtk2::gtkFrameSetShadowType(geneListFrame, GtkShadowType["none"])
    geneListArea <- gtkVBox(FALSE,3)
    
    # Scrolled area:
    genesScroll <- RGtk2::gtkScrolledWindow()
    genesScroll$setPolicy("automatic", "automatic")
    genesScroll$setShadowType("in")
    
    # Text field
    genesText <- RGtk2::gtkTextViewNewWithBuffer()
    genesText$grabFocus()
    genesText$modifyFont(pangoFontDescriptionFromString(", monospace"))
    genesScroll$add(genesText)
    genesScroll$"tooltip-text" <- "One gene per line."
    geneListArea$packStart(genesScroll, expand=TRUE)
    
    # Add genes from argument to field
    if(!is.null(geneList))
    {
        genesBuffer <- RGtk2::gtkTextBufferNew()
        if(is.null(names(geneList))) RGtk2::gtkTextBufferSetText(genesBuffer, paste(geneList,collapse="\n"))
        if(!is.null(names(geneList))) RGtk2::gtkTextBufferSetText(genesBuffer, paste(names(geneList),collapse="\n"))
        RGtk2::gtkTextViewSetBuffer(genesText, genesBuffer)
    }
    
    buttonLoadGenes <- RGtk2::gtkButton("Load from file")
    buttonLoadGenes$name <- "buttonLoadGenes"
    buttonLoadGenes$"tooltip-text" <- "Text file containing the gene list (one gene per line)."
    RGtk2::gSignalConnect(buttonLoadGenes, "clicked", loadFileDialog, data=list(parentWindow=mainWindow, genesText=genesText))
    
    geneListArea$packStart(buttonLoadGenes, expand=FALSE)
    
    geneListFrame$add(geneListArea)
    box.Left$packStart(geneListFrame)
    
    ##### b) Expression Set area  (replace gene list)
    esetBox <- RGtk2::gtkVBoxNew(homogeneous=FALSE, spacing=0)
    
    # refSamples
    refSamplesFrame <- RGtk2::gtkFrame("Reference samples      ")
    RGtk2::gtkFrameSetShadowType(refSamplesFrame, GtkShadowType["none"])
    refSamplesScroll <- RGtk2::gtkScrolledWindow()
    refSamplesScroll$setPolicy("automatic", "automatic")
    refSamplesScroll$setShadowType("none")
    refSamplesView <- RGtk2::gtkViewportNew()
    refSamplesBox <- RGtk2::gtkVBoxNew(FALSE, 0)   
    # Fill... (button)
    refSamplesView$add(refSamplesBox)
    refSamplesScroll$add(refSamplesView)
    refSamplesFrame$add(refSamplesScroll)
    esetBox$packStart(refSamplesFrame, expand = TRUE) 
    
    # compSamples
    compSamplesFrame <- RGtk2::gtkFrame("Compare samples")
    gtkFrameSetShadowType(compSamplesFrame, GtkShadowType["none"])
    compSamplesScroll <- RGtk2::gtkScrolledWindow()
    compSamplesScroll$setPolicy("automatic", "automatic")
    compSamplesScroll$setShadowType("none")
    compSamplesView <- RGtk2::gtkViewportNew()
    compSamplesBox <- RGtk2::gtkVBoxNew(FALSE, 0)   
    # Fill... (button)
    compSamplesView$add(compSamplesBox)
    compSamplesScroll$add(compSamplesView)
    compSamplesFrame$add(compSamplesScroll)
    esetBox$packStart(compSamplesFrame, expand = TRUE) 
    
    ### BUTTON
    # File
    esetTxt <- gtkEntryNew()
    esetBox$packStart(esetTxt)
    esetTxt$visible <- FALSE
    # Button load
    esetButton <- RGtk2::gtkButton("Select eSet")
    esetButton$"tooltip-text" <- ".RData file with ExpressionSet"
    esetButton$name <- "esetButton"
    #esetH1Box <- gtkHBoxNew(homogeneous=FALSE, spacing=0)
    #esetH1Box$packStart(esetButton, expand=FALSE)
    esetBox$packStart(esetButton, expand=FALSE)
    
    esetBox$visible <- FALSE
    box.Left$packStart(esetBox, expand=TRUE)
    
    tabFEA$packStart(box.Left, FALSE, FALSE, 10)
    
    ##################################################
    ##### 2. Tools tabs
    box.Right <- RGtk2::gtkVBoxNew(FALSE, 5)
    tabFEA$add(box.Right)
    
    tabsTools <- RGtk2::gtkNotebookNew()
    tabsTools$name<-"tabsTools"
    tabsTools$setTabPos("top")
    
    # Add tool tabs to New query tab:
    frame.Tools <- RGtk2::gtkFrameNew("Functional Enrichment Analysis tool")
    gtkFrameSetShadowType(frame.Tools, GtkShadowType["none"])
    box.Right$add(frame.Tools)
    
    ### ### ### ### ### ### ### 
    # Gene Term Linker tab  (tabGTL)
    tabGTL <- tabGTL_fill(mainWindow)
    
    ### ### ### ### ### ### ### 
    ### DAVID tab  (tabDavid)
    davidVars <- newDavidVars() # DAVID variables
    tabDavid <- tabDavid_fill(mainWindow, davidVars)
    
    # (tabTopGo)
    tabTopGo <- tabTopGo_fill(mainWindow, allOrgs)

    # (tabGage)
    tabGage <- tabGage_fill(mainWindow, allOrgs)
    
    # (tabOther)
    rawResults <<- NULL
    tabOther <- tabOther_fill(mainWindow=mainWindow,jobNameText=jobNameText)
    
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    RGtk2::gtkNotebookInsertPage(tabsTools, tabDavid$tabDavid, position = FEA_tools["DAVID","ID"],  tab.label = gtkLabelNew("DAVID"))
    RGtk2::gtkNotebookInsertPage(tabsTools, tabGTL$tabGTL, position = FEA_tools["GeneTerm Linker","ID"], tab.label = gtkLabelNew("GeneTerm Linker"))
    RGtk2::gtkNotebookInsertPage(tabsTools, tabTopGo$tabTopGo, position = FEA_tools["topGO","ID"], tab.label = gtkLabelNew("topGO"))
    RGtk2::gtkNotebookInsertPage(tabsTools, tabGage$tabGage, position = FEA_tools["gage","ID"], tab.label = gtkLabelNew("GAGE"))
    RGtk2::gtkNotebookInsertPage(tabsTools, tabOther$tabOther, position = FEA_tools["Imported text file","ID"], tab.label = gtkLabelNew("Other"))  # TO DO

    frame.Tools$add(tabsTools)
    box.Right$packStart(frameJobName, expand=FALSE)
    
    buttonSubmit <- RGtk2::gtkButton("Submit")
    buttonSubmit$"tooltip-text" <- "Submit Functional Enrichment Analysis query"
    box.Right$packStart(buttonSubmit, expand=FALSE, FALSE, 2) #tabDavid$packStart(buttonSubmit_david,  expand = FALSE, FALSE, 10)
        

    ##############################
    # signalConnects
    
    # Tab switch
    # "switch-page" The "switch-page" signal is emitted when the notebook page is changed. Note the page parameter is a GPointer and not usable within PyGTK. Use the page_num parameter to retrieve the new current page using the get_nth_page() method.
    # "change-current-page" signal is emitted when the page forward or page backward request is issued.
    RGtk2::gSignalConnect(tabsTools,"switch-page", actDeactGenes, data=list(geneListFrame=geneListFrame, esetBox=esetBox)) 

    # Load eset
    RGtk2::gSignalConnect(esetButton, "clicked", loadFileDialog, data=list(parentWindow=mainWindow, esetTxt=esetTxt, refSamplesBox=refSamplesBox, compSamplesBox=compSamplesBox))    

    #######################################################################
    #  ready
    fields <- list(genesText=genesText, esetTxt=esetTxt, refSamplesBox=refSamplesBox, compSamplesBox=compSamplesBox, jobNameText=jobNameText, buttonSubmit=buttonSubmit, tabsTools=tabsTools)
    return(list(tabFEA=tabFEA, commonFields=fields, toolTabs=list(tabGTL=tabGTL, tabDavid=tabDavid, tabTopGo=tabTopGo, tabGage=tabGage, tabOther=tabOther)))
    #######################################################################
}

### Functions: 
# getResults_gtLinker
# format_gtLinker (private)

# jobName <- "3907019_gtLinker_"
format_gtLinker <- function(jobName, organism)
{
    ############## READ Files ##############
    # Read metagroups
    globalMetagroups <- read.table(paste(jobName, "global_overview.txt", sep=""),skip=2, header=FALSE, sep="\t", quote = "")
    colnames(globalMetagroups) <- c("Size","Diameter","Similarity","Silhouette Width","Genes","nGenes","nref_list","pValue","Terms")
    nMetaGroups <- dim(globalMetagroups)[1]
    #write.table(globalMetagroups, file="...")
    
    # Read gene-term sets
    tablaGeneTermSets <- NULL
    for(mg in rownames(globalMetagroups)) 
    {
        metagrupo <-  read.table(paste(jobName, "metagroup_", mg, ".txt", sep=""),skip=1, header=FALSE, sep="\t", quote = "")
        tablaGeneTermSets <- rbind(tablaGeneTermSets,cbind(cbind(gtSet=paste(mg, sep=""), metagrupo))) #, cbind(gtSet=paste("Mg", mg,"_gtSet", 1:dim(metagrupo)[1], sep=""), metagrupo))
    }
    colnames(tablaGeneTermSets) <- c("Metagroup", "Genes","nGenes","nref_list","pValue","Terms")
    
    ############## Basic format (global metagroups and gsets) ###################
    # Remove brackets 
    for(col in c("nGenes", "nref_list"))
    {
        globalMetagroups[, col] <- as.numeric(sapply(strsplit(as.character(globalMetagroups[, "nGenes"]), split="(", fixed=TRUE), function(x) x[1]))
        tablaGeneTermSets[, col] <- as.numeric(sapply(strsplit(as.character(tablaGeneTermSets[, "nGenes"]), split="(", fixed=TRUE), function(x) x[1]))
    }
    
    # Format kegg, add org prefix...
    data("organisms", envir = environment())
    organisms <- get("organisms", envir  = environment())
    if(is.null(organism))
    {
        organism <- "map"    
    }else{
        # organism <- organisms[capitalize(tolower(organism)), "keggPrefix"]
    }
    # globalMetagroups$Terms <- gsub("Kegg:", paste("KEGG:", organism, sep=""), globalMetagroups$Terms)
    # tablaGeneTermSets$Terms <- gsub("Kegg:", paste("KEGG:", organism, sep=""), tablaGeneTermSets$Terms)
    # Interpro
    globalMetagroups$Terms <- gsub("IPR", paste("IPR:", sep=""), globalMetagroups$Terms)
    tablaGeneTermSets$Terms <- gsub("IPR", paste("IPR:", sep=""), tablaGeneTermSets$Terms)
    
    ############## Format metagroups table ###################
    globalMetagroups <- cbind(Metagroup=1:nrow(globalMetagroups),globalMetagroups)    
    globalMetagroups$Terms <- sapply(globalMetagroups$Terms, function(gts)
            {
                paste(sapply(strsplit(gts,";", fixed=TRUE)[[1]], function(term)
                {
                    term <-strsplit(term, ":")[[1]]
                    capitalize(paste(paste(term[3:length(term)], collapse=" "), " (",paste(term[1:2], collapse=":"),")",sep=""))
                
                }),collapse=";")
            })
        
    ############## SAVE ###################
    fileNameMetagroups <- paste(jobName, "formatted_metagroups.txt", sep="")
    fileNameGeneTermSets <- paste(jobName, "formatted_gtSets.txt", sep="")
    
    if(!file.exists(file.path(fileNameMetagroups)))
    {
        write.table(globalMetagroups, file=fileNameMetagroups, quote=FALSE, row.names=FALSE, sep="\t")
        write.table(tablaGeneTermSets, file=fileNameGeneTermSets, quote=FALSE, row.names=FALSE, sep="\t")
        message(paste("Metagroups and Gene-term sets tables saved as ", fileNameMetagroups, " and ",fileNameGeneTermSets,".", sep=""))
    }
    
    ret <- list(metagroups=globalMetagroups, geneTermSets=tablaGeneTermSets, fileName=fileNameMetagroups)
}


# jobID <- 3907019
# results <- fea_gtLinker_getResults(jobID)
fea_gtLinker_getResults <- function(jobID=NULL, organism=NULL, jobName=NULL, alreadyDownloaded=FALSE, keepTrying=FALSE, serverWeb="http://gtlinker.cnb.csic.es", serverWS="http://gtlinker.cnb.csic.es:8182") 
{
    if(!loadInstPkg("RCurl")) stop("Package 'RCurl' is required to get the FEA results from GeneTerm Linker server.")

    # Check arguments
    if(is.numeric(jobID)) jobID <- as.character(jobID)
    if(!is.character(jobID) && !alreadyDownloaded) stop("jobID not valid.")
    if(is.null(jobID) && is.null(jobName)) stop("jobID or jobName are required.")
    
    if(!is.null(jobName) && !is.character(jobName)) stop("jobName should be character.")
    if(!is.logical(alreadyDownloaded)) stop("alreadyDownloaded should be TRUE or FALSE.")
    if(!is.logical(keepTrying)) stop("keepTrying should be TRUE or FALSE.")
    if(!is.character(serverWeb)) stop("Web server URL not valid.")
    if(!alreadyDownloaded && !url.exists(serverWeb)) stop("Either the web server URL is wrong or the server is down.")
    
    ###############################
    # Prepare jobName / folder
    if(is.null(jobName)) jobName <- paste(jobID,"_gtLinker", sep="")
    folder <- jobName
    jobName <- paste(jobName, "_", sep="")
    
    # Create folder
    if((!file.exists(file.path(folder))))
    {
        dir.create(file.path(folder))    
    }
    currWD <- getwd()
    setwd(folder)
    
    ##########################################################
    # Connect to server and download results
    ##########################################################
    if(!is.null(jobID) && !alreadyDownloaded)
    {
        jobReady <- FALSE
        firstAttempt <- TRUE
        count <- 0
        status_envelope_body <- paste('<status xmlns="urn:gtLinkerWS">',
                                       '<job_id xsi:type="xsd:string">',jobID ,'</job_id></status>', sep="") 
        
        ###############################
        # Check wether the job is ready and wait if necessary
        ###############################
        #     status(jobID)
        #       0: the job has finished succesfully
        #       1: the job has not finished yet (inc. the job does not exist!)
        #      -1: there has been an error 
        #     
        #     info(jobID) # Provides any error messages there might have been during the analisys.
        while(!jobReady)
        {
            reply <- SOAPQuery(status_envelope_body, serverWS)
                        
            # Ready
            if(reply$statusResponse == 0) 
            {
                jobReady <- TRUE
                if(!firstAttempt) Sys.sleep(5) # To allow the server producing the files 
            }
            
            # Error
            if(reply$statusResponse == -1)
            {
                info_envelope_body <- paste('<info xmlns="urn:gtLinkerWS">',
                                             '<job_id xsi:type="xsd:string">',jobID ,'</job_id></info>', sep="")
                reply <- SOAPQuery(info_envelope_body, serverWS)$infoResponse
                stop(paste("Message from server: ", reply, sep=""))
            }
            # if(reply == -1)  stop("Error connecting to the server.")
            
            # Still analyzing:
            if(!keepTrying) break()
            if(reply$statusResponse == 1) 
            {
                count <- count + 1
                firstAttempt <- FALSE
                if(count == 10) keepTrying <- FALSE
                Sys.sleep(10) 
            }
        }
        
        ###############################
        # Download results (jobID)
        ###############################
        if(!jobReady) 
        {
            warning("The analysis has not finished yet or the jobID does not exist.")
            setwd(currWD)
            return(NULL)
        } else  # jobReady
        {
            # Download files
            downAttempt <- tryCatch({
                # Download global_hash
                inputFileName <- paste(jobName,"global_overview.txt", sep="")  
                fileURL <- paste(serverWeb, "/jobs/",jobID,"/global_hash", sep="")
                if(!url.exists(fileURL)) warning("Server/URL does not seem to be correct, trying anyway...")
                download.file(url=fileURL, destfile=inputFileName)
                
                # Download Metagroups
                nMetaGroups <- nrow(read.table(inputFileName,skip=2, header=FALSE, sep="\t", quote = ""))
                for (mg in 1:nMetaGroups) download.file(quiet=TRUE, url=paste(serverWeb, "/jobs/",jobID,"/", mg-1,"_hash", sep=""), destfile=paste(jobName,"metagroup_", mg,".txt", sep=""))
                
                message(paste("Results downloaded to folder '", folder, "'", sep=""))
            }, error = function(e) {
                message(e)
                setwd(currWD)
                return(e$message)
            })
            if(!is.null(downAttempt)) 
            {
                setwd(currWD)
                return(downAttempt)
            }
        }
    }# End download
    
    queryArgs <- list(queryArgsAsCharacter(match.call()))
    save(queryArgs, file="queryArgs.RData")
    ret <- c(queryArgs=queryArgs, format_gtLinker(jobName, organism))
    setwd(currWD)
    
    invisible(ret)
}

# getMGTerms # used by createHTML y getTerms
# clDescriptions # used by getMGTerms

# Returns a list with the metagroup term names and links
getMGTerms <- function(globalMetagroups, grType)
{    
    mgTerms<- sapply(globalMetagroups$Terms, function(x) strsplit(as.character(x), split=";"))
    names(mgTerms)<-paste(grType,rownames(globalMetagroups), sep=" ")
    
    termsDescriptions <- list()
    for(mgName in names(mgTerms))
    {
        descripciones <- clDescriptions(mgTerms[[mgName]])
        
        descripciones <- descripciones[order(descripciones[,"TermDescription"]),, drop=FALSE]
        termsDescriptions[[mgName]] <- descripciones
    }
    return(termsDescriptions)
}


clDescriptions <- function(terms)  #org=NULL,
{
    termsIDs <- regexpr("\\(([[:alnum:]]+:[[:alnum:]]+[0-9]+)\\)$", terms)
    termsIDs <- substr(terms, termsIDs + 1, termsIDs + attr(termsIDs, "match.length") - 2)
    
    termsTable <- cbind(Term=terms, TermID=termsIDs)
    rownames(termsTable) <- termsTable[,"Term"]
    termsTable <- cbind(termsTable[,"TermID",drop=FALSE], TermDescription= apply(termsTable, 1, function(x) gsub(paste(" (",x[2],")",sep=""),"", x[1], fixed=TRUE)))
    termsTable <- cbind(termsTable, Annotation=sapply(strsplit(termsTable[,"TermID"],":", fixed=TRUE), function(x) x[1]))
    
    # Get term links      
    if(all(termsTable[,"TermID"]==""))
    {
        links <- rep(NA, length(termsTable[,"TermID"]))
    }else
    {
        links <- sapply(sapply(termsTable[,"TermID"], function(y) strsplit(y, split=":")), function(x)
        {  
            # Link (Only for Kegg and Interpro)
            link <- NA
            if(length(x)>0)
            {
                # Interpro
                # David:         IPR:000719:Protein kinase, core
                # gtLinker:     IPR:000980:SH2 motif
                if(toupper(x[1])=="IPR")                                             # TO DO REVISAR!!! NEW VERSION!!
                {
                    link <- paste("http://www.ebi.ac.uk/interpro/entry/IPR", x[2], sep="")
                }
                            
                # # Kegg        
                # if(toupper(x[1])=="KEGG")
                # {
                #     # KEGG:hsa03320:PPAR signaling pathway
                #     org <- substring(x[2], 1, 3)
                #     keggID <- substring(x[2], 4, nchar(x[2]))
                #     if(keggID %in% names(keggPlots))
                #     {
                #         link <- keggPlots[keggID]
                #     }else
                #     {
                #         link <- paste("http://www.genome.jp/kegg-bin/show_pathway?org_name=", org, "&mapno=", keggID, sep="")
                #     }
                # }
                
                # SMART (Appears in david even if it was not explicitly requested)
                # David:            SM00181:EGF
                if(toupper(x[1])=="SM0") link <- paste("http://smart.embl.de/smart/do_annotation.pl?DOMAIN=", x[1], sep="")            
                
                # REACTOME
                if(toupper(x[1])=="REACT") link <- paste("http://www.reactome.org/content/detail/", x[2], sep="")    
            }
            return (link)
        })
    }
    
    termsTable <- cbind(termsTable, Link=links)

    return(termsTable)
}

# Distances: Binary
# Clustering: Single
clustersDistance <- function(incidenceMatices, mgCols=NULL, clustMethod="average")
{        
    if("metagroupsMatrix" %in% names(incidenceMatices)) metagroupGenesMatrix <- incidenceMatices$metagroupsMatrix
    if("clustersMatrix" %in% names(incidenceMatices)) metagroupGenesMatrix <- incidenceMatices$clustersMatrix

    mxDistancias <- NULL
    if(dim(metagroupGenesMatrix)[2]>2)    
    {
        distancias <- dist(t(metagroupGenesMatrix), method="binary")
        mxDistancias <- as.matrix(distancias)    
        clustering <- hclust(distancias, method=clustMethod)
        
        # Prepare layout
        nf <- layout(cbind(c(1,2),c(0,3)), widths=c(9,1), heights=c(3,8), TRUE)
        #layout.show(nf)
        
        # Plot dendogram
        par(mar = c(0,3,1,1))
         plot(clustering,  ann=FALSE, axes=FALSE)
        
        #Recolocar:
        mxDistancias <- mxDistancias[clustering$order, rev(clustering$order)]
        
        # Plot "image"        
        minDist <- unique(sort(mxDistancias))[2] #[1] = 0        
        if(minDist > 0)
        {
            cero <- which(mxDistancias == 0)
            uno  <- which(mxDistancias == 1)
            
            mxPlot <- (mxDistancias-(minDist))+0.12            
            mxPlot <- mxPlot/(max(mxPlot)/0.9)
            mxPlot <- trunc(mxPlot*10)
            
            mxPlot[cero] <- 0
            mxPlot[uno] <- 10
            
        } else mxPlot <- mxDistancias
        
        par(mar = c(3,3,1,1))
        
        if (TRUE) #library(RColorBrewer, logical.return=TRUE))
        {
            colPalette<- rev(brewer.pal(11, "RdBu"))
        }else
        {
            colPalette <- heat.colors(11)
        }
        image(mxPlot, col=colPalette, axes=FALSE)
        box()

        if(!is.null(mgCols))
        {   
            siz<-(1/(ncol(mxPlot)-1))/2
            barplot(c(0,rep(siz*.3,ncol(mxPlot))), add=TRUE, col=c("white",mgCols[rev(colnames(mxDistancias))]), border=FALSE, axes=FALSE, width=c(-siz,rep(siz*2,ncol(mxPlot))),space=0, offset=1+(siz*2)+(-siz+.01), xlim=c(-0.5,1), xpd=TRUE)
        }

        axis(1, at=seq(0,1, by=1/(length(colnames(mxPlot))-1)), labels = rownames(mxPlot))
        axis(2, at=seq(0,1, by=1/(length(colnames(mxPlot))-1)), labels = colnames(mxPlot))

        # Leyenda
        levs <- unique(sort(mxPlot))
        labs <- sapply(lapply(levs, function(x) which(mxPlot %in% x)), function(x) round(mean(mxDistancias[x]), digits=2))
        par(mar = c(3,1,15,0.5))
        image(t(as.matrix(levs)),  col=colPalette, axes=FALSE)
        box()
        axis(2, at=seq(0,1, by=1/(length(levs)-1)), labels= labs, cex.axis=0.8)
        
        # Reset layout
        nf <- layout(matrix(1), widths=1, heights=1, TRUE)
        #layout.show(nf)
        par(mar = c(1,1,1,1))
        #par(mar= c(5, 4, 4, 2) + 0.1)  #- reset to default
        
        mxDistancias <- mxDistancias[,rev(colnames(mxDistancias))]
    }
    return(mxDistancias)
}

# usage:
# if(!loadInstPkg("gage")) stop("Package ... is not available.")
# if(!loadInstPkg("gage", parentWindow=argsList$parentWindow)) stop("Package gage is not available.")
# 
loadInstPkg <- function(pkgName, parentWindow=NULL)
{
    ret <- FALSE
    
    if(!pkgName %in% rownames(installed.packages()))
    {
        #if(interactive() && any(grepl("RGtk2", unlist(sessionInfo()))))
        if(!is.null(parentWindow))
        {
            # GUI dialog
            dialog <- RGtk2::gtkDialogNewWithButtons("Package installation required", parentWindow,
                                              c("modal", "destroy-with-parent"), 
                                              "gtk-yes", RGtk2::GtkResponseType["yes"], 
                                              "gtk-no", RGtk2::GtkResponseType["no"],
                                              show=TRUE)
            dialog[["vbox"]]$add(RGtk2::gtkLabel(paste("Install package '", pkgName,"'?", sep="")))
            response <- dialog$run() 
            dialog$destroy()
            
            if(response == RGtk2::GtkResponseType["yes"]) response <- "y"
        }else
        { 
            # Console
            response <- readline(paste("Package '",pkgName, "' is required but not installed. Install now? (y/n) \n", sep=""))
        }
        
        if(grepl("y", tolower(response)))
        {
            tryCatch({
                if (!requireNamespace("BiocManager", quietly=TRUE))
                    install.packages("BiocManager")
                BiocManager::install(pkgName)
            }, error = function(e) {
                stop(paste("It is not possible to install the package. Check your internet connection.", e, sep="\n"))
            })
            ret <- TRUE
        }
    }
    
    # pos = "package:base"  # to "mask as little as possible"
    ret <- suppressWarnings(library(pkgName, character.only=TRUE, logical.return=TRUE, quietly=TRUE, pos = "package:base")) # TRUE/FALSE
    
    return(ret)
}

#################################################################################
### Fills tabGTL
#################################################################################

tabGTL_fill <- function(mainWindow)
{
    ########################################################################
    # Fill tab
    tabGTL <- RGtk2::gtkVBox(homogeneous=FALSE, spacing=3)
        
    # Organism
    comboOrg <- RGtk2::gtkComboBoxNewText()
    GtL_org <- as.character(0:1)
    names(GtL_org) <- c("Hs","Sc")
    GtL_org_full <- c("Homo sapiens","Saccharomyces cerevisiae")
    names(GtL_org_full) <- c("Hs","Sc")
    
    for (ch in GtL_org_full) RGtk2::gtkComboBoxAppendText(comboOrg, ch)
    comboOrg$setActive(GtL_org["Hs"])
    RGtk2::gtkComboBoxSetTitle(comboOrg, "Org")
    frameOrg <- RGtk2::gtkFrame("Organism")
    RGtk2::gtkFrameSetShadowType(frameOrg, GtkShadowType["none"])
    frameOrg$add(comboOrg)
    tabGTL$packStart(frameOrg, expand=FALSE)
    
    # Annotations
    GtL_annots <- c("GO_Biological_Process","GO_Molecular_Function", "GO_Cellular_Component", "InterPro_Motifs")
    frameAnnots <- RGtk2::gtkFrame("Annotations")
    annotsArea <- RGtk2::gtkVBoxNew(homogeneous=FALSE, spacing=0)
    frameAnnots$add(annotsArea)
    checkAnnotsGtL<-list()
    for(annot in GtL_annots)
    {
      checkAnnotsGtL[[annot]] <- RGtk2::gtkCheckButton(annot)
      checkAnnotsGtL[[annot]]$active <- TRUE
      annotsArea$add(checkAnnotsGtL[[annot]])
    }
    tabGTL$packStart(frameAnnots, expand=FALSE)
    
    # MinSupport
    comboMinSupport <- RGtk2::gtkComboBoxNewText()
    GtL_minSupport <- as.character(0:7)
    names(GtL_minSupport) <- as.character(2:9)
    for (ch in names(GtL_minSupport)) RGtk2::gtkComboBoxAppendText(comboMinSupport, ch) 
    comboMinSupport$setActive(GtL_minSupport["4"])
    comboMinSupport$"tooltip-text" <- "Minimum size of the gene-term set\n(in number of genes)"
    RGtk2::gtkComboBoxSetTitle(comboMinSupport, "MinSuport")
    frameMinSupport <- RGtk2::gtkFrame("Minimum support")
    RGtk2::gtkFrameSetShadowType(frameMinSupport, GtkShadowType["none"])
    frameMinSupport$add(comboMinSupport)
    tabGTL$packStart(frameMinSupport, expand=FALSE)
    #tabGTL$packStart(comboMinSupport)
    
    # serverWeb
    frameServerWeb <- RGtk2::gtkFrame("Server")
    RGtk2::gtkFrameSetShadowType(frameServerWeb, GtkShadowType["none"])
    serverWebText <- RGtk2::gtkEntryNew()
    serverWebText$setWidthChars(25)
    serverWebText$setText("http://gtlinker.cnb.csic.es")
    frameServerWeb$add(serverWebText)
    tabGTL$packStart(frameServerWeb, expand=FALSE)


    fields <- list(comboOrg=comboOrg, GtL_org=GtL_org,
               checkAnnotsGtL=checkAnnotsGtL, GtL_annots=GtL_annots,
               comboMinSupport=comboMinSupport, GtL_minSupport=GtL_minSupport, serverWebText=serverWebText)

    #######################################################################
    ## tabGTL ready    
    return(list(tabGTL=tabGTL, queryArgs=fields))
    #######################################################################
}

# TOP GO
######################################################
# For help/vignette:
# genesUniverse <- refList(refPackage, geneIdType)
# geneID2GO <- buildDatabases(orgPackage, geneIdType)$geneID2GO  # To execute multiple queries...
# http://www.bioconductor.org/packages/release/BiocViews.html#___ChipDb
# 
# # Arguments
# geneList <- c("ADA2", "APC1", "APC11", "APC2", "APC4", "APC5", "APC9", 
#               "CDC16", "CDC23", "CDC26", "CDC27", "CFT1", "CFT2", "DCP1", "DOC1", "FIP1", 
#               "GCN5", "GLC7", "HFI1", "KEM1", "LSM1", "LSM2", "LSM3", "LSM4", "LSM5", 
#               "LSM6", "LSM7", "LSM8", "NGG1", "PAP1", "PAT1", "PFS2", "PTA1", 
#               "PTI1", "REF2", "RNA14", "RPN1", "RPN10", "RPN11", "RPN13", "RPN2", "RPN3",
#               "RPN5", "RPN6", "RPN8", "RPT1", "RPT3", "RPT6", "SGF11", "SGF29", "SGF73",
#               "SPT20", "SPT3", "SPT7", "SPT8", "TRA1", "YSH1", "YTH1")
# annotations=c("GO_BP","GO_MF","GO_CC")
# genesUniverse <- NULL
# organism="Sc"
# geneIdType <- "GENENAME"
# nodeSize <- 5  # 1 (no prune), more stable: 5-10
# pValThr <- 0.01
# 
# geneID2GO=NULL
# refPackage=NULL
# nodeSize=5
# pValThr=0.01
# testStat=NULL
# jobName=NULL
# 
# results <- fea_topGO(geneList, geneIdType=geneIdType, organism="Sc", annotations=annotations, refPackage=refPackage, nodeSize=5, pValThr=0.01, testStat=NULL)

# GO evidence codes:
# (http://www.bioconductor.org/packages/release/bioc/vignettes/annotate/inst/doc/GOusage.pdf)
# "TAS" (traceable author statement, probably the most restrictive)
# http://geneontology.org/page/guide-go-evidence-codes
#
# AnnotationDbi::keys(org.Hs.eg.db, keytype="EVIDENCE")
# "EXP" "IBA" "IC"  "IDA" "IEA" "IEP" "IGI" "IMP" "IPI" "ISS" "NAS" "ND"  "TAS"


fea_topGO <- function(geneList, geneIdType="ENSEMBL", geneLabels=NULL, organism="Hs", annotations=c("GO_BP","GO_MF","GO_CC"), evidence=NULL, genesUniverse=NULL, refPackage=NULL, geneID2GO=NULL, nodeSize=5, pValThr=0.01, testStat=NULL, jobName=NULL)
{
    if(!loadInstPkg("topGO")) stop("Package topGO is not available.")
    if(!loadInstPkg("GO.db")) stop("Package GO.db is for fea_topGO.")
    groupGOTerms(where=.GlobalEnv)

    ###############################
    # Check arguments 
    if(!is.null(nodeSize) && !is.numeric(nodeSize)) stop("nodeSize should be numeric.")
    if(!is.null(pValThr) && !is.numeric(pValThr)) stop("pValThr should be numeric.")
    if(!is.null(jobName) && !is.character(jobName)) stop("jobName should be character.")
    
    ###############################
    # Prepare jobName / folder
    if(is.null(jobName)) jobName <- paste(sample(100000:999999,size=1), "_topGO",sep="")
    folder <- jobName
    
    # Create folder
    if((!file.exists(file.path(folder))))
    {
        dir.create(file.path(folder))        
    }
    currWD <- getwd()
    setwd(folder)
    
    ###############################
    # Get organism package
    data("organisms", envir = environment())
    organisms<- get("organisms", envir  = environment())
    
    if(!is.character(organism)) stop("Organism should be the name of an organism db package or one of the rownames in the following table: data(organisms)")
    if(organism %in% rownames(organisms)) 
    {
        orgPackage <- organisms[organism,"orgPackage"]
    } else 
    {
        orgPackage <- organism
    }

    # Get background list (genes universe)
    if(!is.null(refPackage) && !is.null(genesUniverse)) stop("Please provide either 'genesUniverse' or 'refPackage'.")
    if(is.null(refPackage)) refPackage <- orgPackage
    if(is.null(genesUniverse)) genesUniverse <- refList(refPackage, geneIdType)
    
    # Get GO gene sets
    if(!is.null(orgPackage) && !is.null(geneID2GO)) stop("Please provide either 'orgPackage' or 'geneID2GO'.")
    if(any(!annotations %in% c("GO_BP","GO_MF","GO_CC"))) stop('"annotations" should be "GO_BP", "GO_MF" and/or "GO_CC"')
    if(is.null(geneID2GO)) geneID2GO <- buildGeneSets(orgPackage, geneIdType, annotations=annotations, evidence=evidence)$genes2terms    

    
    # Reshape input list
    recogPercent <- sum(geneList %in% genesUniverse)/length(geneList)
    if(recogPercent<0.9) 
    {
        if(recogPercent < 0.1) stop("There are no genes from the gene list in the genes universe.\nMake sure the arguments 'genesUniverse', 'refPackage', 'organism' and 'geneIdType' are correct.")
        warning(paste("Only ",recogPercent*100, "% of gene ids were recognized.",sep=""))
    }
    inputGeneList <- factor(as.integer(genesUniverse %in% geneList))
    names(inputGeneList) <- genesUniverse
    
    ## topGo
    annotations <- gsub("GO_", "", annotations)
    names(geneID2GO) <- gsub("GO_", "", names(geneID2GO))
    
    GOdata <- list()
    goResTable <- list()
    if(is.null(testStat)) testStat <- new("classicCount", testStatistic=topGO::GOFisherTest, name="Fisher test")
    for(ont in annotations)
    {
        GOdata[[ont]] <- new("topGOdata", ontology=ont, allGenes=inputGeneList, annot=annFUN.gene2GO, gene2GO=geneID2GO[[ont]], nodeSize=nodeSize)
        
        # Get significant terms and build table: 
        resultFisher <- getSigGroups(GOdata[[ont]], testStat)
        goResTable[[ont]] <- GenTable(GOdata[[ont]], classic=resultFisher, ranksOf="classic", topNodes=sum(resultFisher@score<pValThr), numChar=100)
        
        # Check size?
        # Get genes in each term:
        goResTable[[ont]] <- cbind(Ont=ont, goResTable[[ont]], Genes=sapply(goResTable[[ont]]$GO.ID,function(go) 
        {
            gTerm <- genesInTerm(GOdata[[ont]], go)[[1]]
            paste(gTerm[gTerm %in%  sigGenes(GOdata[[ont]])], collapse=",")
        }))    
    }
    geneTermSets <- do.call(rbind,goResTable)
    
    ###############################
    # Adaptar formato
    fileName <- paste(jobName, ".txt", sep="")
    
    
    # Equivalent to format_results(goResTable, newFileName=fileName, clusterCol=NULL, geneCol=NULL, geneSep=NULL, termDescCol="Term", termIDCol="GO.ID", termCatCol=NULL, termCat="GO", termSep=NULL), but deltes extra columns
    colnames(geneTermSets)[which(colnames(geneTermSets)=="Term")] <- "Terms"
    geneTermSets$Terms <- paste(geneTermSets$GO.ID, capitalize(geneTermSets$Terms), sep=":")
    geneTermSets <- geneTermSets[,!colnames(geneTermSets) %in% "GO.ID"] 
    
    # Replace Gene ID?
    geneTermSets <- addGeneLabels(geneTermSets, geneLabels)

    # Save file: 
    ret <- format_results(geneTermSets, newFileName=fileName, tool="topGO")
    queryArgs <- list(queryArgsAsCharacter(match.call()))
    setwd(currWD)
    invisible(c(queryArgs=queryArgs,ret))
}

### Index:
# actDeactGenes
# processGenesField
# processExpressionField
# submitQuery
# loadFileDialog
# readFEAresults

#argsList: geneListFrame, esetBox
actDeactGenes <- function(pointer1, pointer2, newPage, argsList) 
{
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    # tabsTool$GetCurrentPage()  (OLD page)
    curPage <- rownames(FEA_tools)[which(FEA_tools[,"ID"]==newPage)]
    if(curPage %in% c("GeneTerm Linker", "topGO")) #"DAVID", 
    {
        RGtk2::gtkWidgetSetSensitive(argsList$geneListFrame, TRUE)   
        argsList$geneListFrame$visible <- TRUE
        
        RGtk2::gtkWidgetSetSensitive(argsList$esetBox, FALSE)
        argsList$esetBox$visible <- FALSE
    }
    if(curPage %in% c("gage"))
    {
        RGtk2::gtkWidgetSetSensitive(argsList$geneListFrame, FALSE)   
        argsList$geneListFrame$visible <- FALSE
        
        RGtk2::gtkWidgetSetSensitive(argsList$esetBox, TRUE)   
        argsList$esetBox$visible <- TRUE
    }
    if(curPage %in% c("Imported text file"))
    {
        RGtk2::gtkWidgetSetSensitive(argsList$geneListFrame, FALSE)   
        RGtk2::gtkWidgetSetSensitive(argsList$esetBox, FALSE)   
    }
}

processGenesField <- function(genesText)
{
    sepChar <- "\n"
    genesBuffer <- RGtk2::gtkTextViewGetBuffer(genesText)
    
    geneList <- RGtk2::gtkTextBufferGetText(genesBuffer, RGtk2::gtkTextBufferGetStartIter(genesBuffer)$iter, RGtk2::gtkTextBufferGetEndIter(genesBuffer)$iter, include.hidden.chars = TRUE)
    geneList <- unlist(strsplit(geneList, sepChar))
    
    # Clear whitespace
    # geneList <- unlist(strsplit(geneList, " "))
    geneList <- sub(" ", "", geneList)
    
    # Clear empty slots
    geneList <- geneList[geneList!=""]
    
    return(geneList)
}

processExpressionField <- function(expressionText)
{
    genesBuffer <- RGtk2::gtkTextViewGetBuffer(expressionText)
    geneList <- RGtk2::gtkTextBufferGetText(genesBuffer, RGtk2::gtkTextBufferGetStartIter(genesBuffer)$iter, RGtk2::gtkTextBufferGetEndIter(genesBuffer)$iter, include.hidden.chars = TRUE)
    geneList <- unlist(strsplit(geneList, "\n"))
    
    # Clear whitespace
    geneList <- sub(" ", "", geneList)
    
    # Clear empty slots
    geneList <- geneList[geneList!=""]
    
    # Get geneExpr
    geneList <- do.call(rbind,sapply(geneList, function(x) { 
                                                x <- gsub(" ", "\t",x)
                                                strsplit(x, "\t")
                                                }))
    geneList <- setNames(as.numeric(geneList[,2]), geneList[,1])
    
    if(length(geneList)==0) geneList <- NULL
    
    return(geneList)
}

############################################################################################################
# Used by: GUI_tabNetwork_common, GUI_tabFEA_other
# Text field is selected based on button name
# argsList= parentWindow +
# buttonLoadGenes: genesText
# buttonSelectExprFile: expressionText
# buttonSelectFeaResults: feaResultsText, comboFeaTool, expressionText, alreadyDownloadedCheck
# buttonImportFeaResults: feaResultsImportText
# esetButton: esetTxt
# geneSetsButton: geneSetsTxt$setText

loadFileDialog <- function(button, argsList) # button: Not used, but required for signalConnect.
{ 
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    fileName <- ""

    ### File dialog:
    dialog <- RGtk2::gtkFileChooserDialog("Choose File", argsList$parentWindow, "open",
                                   "gtk-open", RGtk2::GtkResponseType["accept"],
                                   "gtk-cancel", RGtk2::GtkResponseType["cancel"])
    
    if(dialog$run() == RGtk2::GtkResponseType["accept"]) 
    {
        fileName <- dialog$getFilename()
        
        # Replace backlash: fileName <- "C:\\blablabla\\blablabla"
        if(grepl("^[a-zA-Z]{1}:\\\\", fileName, fixed=FALSE)) fileName <- gsub("\\", .Platform$file.sep, fileName, fixed=TRUE)
        
        if(button$name == "buttonLoadGenes") 
        {
            ### Read genes...
            geneList <- as.character(unlist(read.table(fileName, sep="\t")[,1]))
            geneList <- paste(geneList,collapse="\n")
            # TO DO: Add file options?
            
            # Add to genes field
            genesBuffer <- RGtk2::gtkTextBufferNew()
            RGtk2::gtkTextBufferSetText(genesBuffer, geneList)
            RGtk2::gtkTextViewSetBuffer(argsList$genesText, genesBuffer)
        }
        if(button$name == "buttonSelectExprFile") 
        {
            ### Read genes...
            geneExpr <- read.table(fileName, sep="\t")
            geneExpr <- paste(paste(geneExpr[,1], geneExpr[,2], sep="\t"), collapse="\n")
            # TO DO: Add file options?
            
            # Add to genes field
            genesBuffer <- RGtk2::gtkTextBufferNew()
            RGtk2::gtkTextBufferSetText(genesBuffer, geneExpr)
            RGtk2::gtkTextViewSetBuffer(argsList$expressionText, genesBuffer)
        }
    
        if(button$name == "buttonSelectFeaResults") 
        {
            argsList$feaResultsText$setText(fileName)
    
            # For GeneTerm Linker
            if(grepl("global_overview.txt",fileName) || grepl("metagroup",fileName))
            {
                data("FEA_tools", envir = environment())
                FEA_tools<- get("FEA_tools", envir  = environment())
        
                argsList$alreadyDownloadedCheck$active <- TRUE
                argsList$comboFeaTool$setActive(as.numeric(FEA_tools["GeneTerm Linker", "ID"]))
            }
            
            ## Cambiar a changed feaResultsText? cuidado ftlinker (jobID)
            feaResults <- readFEAresults(feaResultsText=argsList$feaResultsText, comboFeaTool=argsList$comboFeaTool, expressionText=argsList$expressionText,
                                                                  serverWebReportText=argsList$serverWebReportText, alreadyDownloadedCheck=argsList$alreadyDownloadedCheck, parentWindow=argsList$parentWindow)
        }
        
        if(button$name == "buttonImportFeaResults")
        {
            argsList$fields$feaResultsImportText$setText(fileName)
            processFile(fileName, fieldsList=argsList$fields)
        }
    
        if(button$name == "esetButton")
        {
            argsList$esetTxt$setText(fileName)
            loadEset(fileName, refSamplesBox=argsList$refSamplesBox, compSamplesBox=argsList$compSamplesBox)
        }
        
        if(button$name == "geneSetsButton")
        {
            argsList$geneSetsTxt$setText(fileName)
        }
    }
    dialog$destroy()    
} 

############################################################################################################
# argsList= parentWindow, genesText, tabsTool, jobNameText
# gtLinker: 
# david: jobNameText, comboIdType, annotsArea, emailText, frameEmail, argsText
# gage:
# topgo:
# other:
# Common: tabsSteps, feaResultsText, comboFeaTool, expressionText
submitQuery <- function(button, argsList) # button: Not used, but required for signalConnect.
{     
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    activeTool <- rownames(FEA_tools)[which(FEA_tools[,"ID"]==RGtk2::gtkNotebookGetCurrentPage(argsList$tabFEA$commonFields$tabsTools))]
    geneList <- processGenesField(argsList$tabFEA$commonFields$genesText) 
    eset <- argsList$tabFEA$commonFields$esetTxt$getText()
    
    jobName <- argsList$tabFEA$commonFields$jobNameTex$getText() 
    if(jobName=="") jobName <- NULL    
    
    if(length(geneList)==0 && eset=="" )
    {
        # Dialog
        dialog <- RGtk2::gtkDialogNewWithButtons("Enter genes", argsList$parentWindow,
                                          c("modal", "destroy-with-parent"), 
                                          "gtk-ok", RGtk2::GtkResponseType["accept"],
                                          show=TRUE)
        if(activeTool=="gage") 
        {
            msgTxt <- "Please enter an expression set and select the samples to compare."
            
        } else 
        {
            msgTxt <- "Please enter a gene list."
        }
        dialog[["vbox"]]$add(RGtk2::gtkLabel(msgTxt))
        response <- dialog$run() 
        dialog$destroy()
        
    }else
    {
        msgText <- NULL
        statusTxt <- NULL
        if(activeTool == "Imported text file")
        {
            response <- RGtk2::GtkResponseType["accept"]
        }else
        {
            # Dialog    
            dialog <- RGtk2::gtkDialogNewWithButtons("Submit?", argsList$parentWindow,
                                             c("modal", "destroy-with-parent"), 
                                             "gtk-ok", RGtk2::GtkResponseType["accept"], 
                                             "gtk-cancel", RGtk2::GtkResponseType["reject"],
                                             show=FALSE)
            if(activeTool %in% c("GeneTerm Linker")) dialog[["vbox"]]$add(RGtk2::gtkLabel(paste("Submit query to ", activeTool, " server?", sep=""))) #"DAVID"
               if(activeTool %in% c("topGO", "gage")) dialog[["vbox"]]$add(RGtk2::gtkLabel("Perform analysis?"))
            response <- dialog$run() # showAll()
            dialog$destroy()        
        }    
        
        if (response == RGtk2::GtkResponseType["accept"]) 
        {    
            queryReply <- NULL
            argsList$statusbar$push(argsList$statusbar$getContextId("info"), "Waiting for FEA results...")
            ##### GeneTerm Linker
            if(activeTool =="GeneTerm Linker")
            {
                # Check libraries (ask install through dialog)
                if(!loadInstPkg("RCurl", parentWindow=argsList$parentWindow)) stop("Package 'RCurl' is required to get the FEA results from GeneTerm Linker server.")
                
                queryArgs <- argsList$tabFEA$toolTabs$tabGTL$queryArgs    
                
                ## Get arguments queryArgs <- tabFEA$tabDavid$queryArgs 
                org <- names(queryArgs$GtL_org)[which(queryArgs$GtL_org==queryArgs$comboOrg$getActive())]
                anots <- queryArgs$GtL_annots[sapply(queryArgs$GtL_annots, function(anot) queryArgs$checkAnnotsGtL[[anot]]$active)]
                minSupport <- as.numeric(names(queryArgs$GtL_minSupport)[which(queryArgs$GtL_minSupport==queryArgs$comboMinSupport$getActive())]) 
                serverWeb <- queryArgs$serverWebText$getText()
                serverWS <- paste(serverWeb, ":8182", sep="")
            
                # Submit query
                queryReply <- -1
                queryReply <- tryCatch( 
                {
                    tmpReply <- fea_gtLinker(geneList=geneList, organism=org, annotations=anots, minSupport=minSupport, serverWS = serverWS)
                    tmpReply
                }, error = function(e) 
                {
                    msgText <<- paste("Error in query:\n " ,e, sep="")
                })
                
                if(is.null(msgText)) # No error
                {
                    if(queryReply==-1) msgText <- "There has been an error with the query. \nCheck the parameters and try again.\n"
                    if(queryReply!=-1)
                    {
                        msgText <- paste("Query submited.\nYour job ID is ",queryReply, ". \nIt will be ready in a few minutes.",sep="")
                        if(is.null(jobName)) jobName <- paste(queryReply, "_gtLinker",sep="")
                        statusTxt <- queryReply
                        argsList$serverWebReportText$setText(serverWeb)
                    }
                }
            }else
            {
                if(activeTool == "Imported text file")
                {
                     queryReply <- formatResultsFile(c(argsList$tabFEA$toolTabs$tabOther$fields, list(jobNameText=argsList$tabFEA$commonFields$jobNameText)))
                     msgText <- paste("The file has been formated to use with FGNet \n and saved as '", queryReply$fileName, "'\nYou can now build the functional network.",sep="")
                }
                # if(activeTool =="DAVID")
                # {                    
                #     queryArgs <- argsList$tabFEA$toolTabs$tabDavid$queryArgs    
                # 
                #     ## Get arguments
                #     geneIdType <- queryArgs$davidVars$DAV_GeneIds[queryArgs$comboIdType$getActive()+1]
                # 
                #     annotations <- unlist(sapply(queryArgs$annotsArea$getChildren(), function(anot) if(anot$active) return(anot$label)))
                #     email <- queryArgs$emailText$getText()
                #     if(email=="" || !RGtk2::gtkWidgetGetSensitive(queryArgs$frameEmail)) email <- NULL
                #     
                #     # Check libraries (ask install through dialog)
                #     if(!is.null(email))
                #     {
                #         if(!loadInstPkg("RDAVIDWebService", parentWindow=argsList$parentWindow)) 
                #             stop("Package RDAVIDWebService is required to query DAVID through the webserver. Install the package or set email=NULL to query DAVID through the web API.")
                #     }else{
                #         if(!loadInstPkg("RCurl", parentWindow=argsList$parentWindow)) stop("Package 'RCurl' is required to query DAVID throught the web API. Install it or provide an email to query DAVID through the Web Service.")
                #     }
                #         
                #     argsWS <- eval(parse(text=paste("c(",queryArgs$argsText$getText(), ")", sep="")))
                #     
                #     # Submit query
                #     queryReply <- tryCatch( 
                #     {                        
                #         tmpReply <- fea_david(geneList=geneList, geneIdType=geneIdType, annotations=annotations, email=email, argsWS=argsWS, jobName=jobName)
                #         tmpReply # (invisible returns)
                #     }, error = function(e) 
                #     {
                #         msgText <<- paste("Error in query:\n " ,e, sep="")
                #         NULL
                #     })
                # }
                    
                if(activeTool =="topGO")
                { 
                    # Check libraries (ask install through dialog)
                    if(!loadInstPkg("topGO", parentWindow=argsList$parentWindow)) stop("Package topGO is not available.")
                    if(!loadInstPkg("GO.db", parentWindow=argsList$parentWindow)) stop("Package GO.db is for fea_topGO.")
                    
                    queryArgs <- argsList$tabFEA$toolTabs$tabTopGo$queryArgs
                    
                    ## Get arguments
                    geneIdType <- queryArgs$geneIDsTopGO[queryArgs$comboGeneIdTypeTopGo$getActive()+1]
                    annotations <- names(queryArgs$topGO_annots)[sapply(queryArgs$topGO_annots, function(anot) queryArgs$checkAnnotsTopGo[[anot]]$active)]
                    organism <- names(queryArgs$allOrgs[["ID"]])[which(queryArgs$allOrgs[["ID"]]==queryArgs$comboOrgTopGo$getActive())]
                    evidence  <- rownames(queryArgs$GOEvidenceCodes)[sapply(rownames(queryArgs$GOEvidenceCodes), function(evid) queryArgs$checkEvidenceTopGo[[evid]]$active)]
                    if(length(evidence)==0) evidence <- NULL
                    
                    geneID2GO <- NULL           # geneID2GO <- buildDatabases(orgPackage, geneIdType)$geneID2GO
                    refPackage <- queryArgs$refPackageTxt$getText()
                    if(refPackage=="") refPackage <- NULL
                    genesUniverse <- NULL       # genesUniverse <- refList(refPackage, geneIdType)
                    nodeSize <- as.numeric(queryArgs$nodeSizeTxt$getText())
                    if(is.na(nodeSize)) nodeSize <- NULL
                    pValThr <- as.numeric(queryArgs$pValThrTxt$getText())
                    if(is.na(pValThr)) pValThr <- NULL
                    
                    # Submit query
                    queryReply <- tryCatch( 
                    {   
                        tmpReply <- fea_topGO(geneList=geneList, geneIdType=geneIdType, organism=organism, annotations=annotations, evidence=evidence, genesUniverse=genesUniverse, refPackage=refPackage, geneID2GO=geneID2GO, nodeSize=nodeSize, pValThr=pValThr, testStat=NULL)
                        tmpReply # (invisible returns)
                    }, error = function(e) 
                    {
                        msgText <<- paste("Error in query:\n " ,e, sep="")
                        NULL
                    })
                }    # End topGO
                
                
                if(activeTool =="gage")
                { 
                    # Check libraries (ask install through dialog)
                    if(!loadInstPkg("gage", parentWindow=argsList$parentWindow)) stop("Package 'gage' is not available.")
                    queryArgs <- argsList$tabFEA$toolTabs$tabGage$queryArgs    
                    
                    ## Get arguments
                    eset <- eval(as.name(load(eset)))
                    
                    refSamples <- unlist(sapply(argsList$tabFEA$commonFields$refSamplesBox$getChildren(), function(samp) if(samp$active) return(samp$label)))
                    compSamples <- unlist(sapply(argsList$tabFEA$commonFields$compSamplesBox$getChildren(), function(samp) if(samp$active) return(samp$label)))
                    
                    geneIdType <- queryArgs$geneIDsGage[queryArgs$comboGeneIdTypeGage$getActive()+1]
                    organism <- names(queryArgs$allOrgs[["ID"]])[which(queryArgs$allOrgs[["ID"]]==queryArgs$comboOrgGage$getActive())]
                    
                    annotations <- names(queryArgs$gage_annots)[sapply(queryArgs$gage_annots, function(anot) queryArgs$checkAnnotsGage[[anot]]$active)]
                    if(length(annotations)==0) annotations<-NULL
                    geneSets <- queryArgs$geneSetsTxt$getText()
                    if(geneSets=="") geneSets <- NULL
                    if(!is.null(geneSets))
                    {
                        # http://www.broadinstitute.org/gsea/msigdb/collections.jsp
                        if(grepl(".gmt", geneSets, fixed=TRUE))
                        {
                            geneSets <- readList(geneSets)
                        }else{
                            geneSets <- eval(as.name(load(geneSets)))    
                        }
                    }
                    
                    sameDirection <- queryArgs$sameDirectionCheck$active
                    onlyEssentialTerms <- queryArgs$onlyEssentialTermsCheck$active
                    compareType <- queryArgs$compareTypeTxt$getText()
                    
                    # Submit query
                    queryReply <- tryCatch( 
                    {                                            
                        tmpReply <- fea_gage(eset=eset, refSamples=refSamples, compSamples=compSamples, geneIdType=geneIdType, organism=organism, annotations=annotations, geneSets=geneSets, sameDirection=sameDirection, onlyEssentialTerms=onlyEssentialTerms, compareType=compareType, jobName=jobName)
                        tmpReply # (invisible returns)
                            
                    }, error = function(e) 
                    {
                        msgText <<- paste("Error in query:\n " ,e, sep="")
                        NULL
                    })
                }    # End gage
                
                if(is.null(msgText)) # No error
                {
                    if(is.null(jobName)) jobName <- getJobName(queryReply$fileName)
                                        
                    if(!is.null(queryReply)) 
                    {
                        msgText <- paste("The results from the Functional Analysis have been saved in folder '",jobName, "'.\nYou can now build the functional network.",sep="")
                       
                    }
                    if(is.null(queryReply)) 
                    {
                        # In case there isn't an specific msg from the tool...
                        msgText <- "There has been an error with the query. \nCheck the parameters and try again."
                        queryReply <- NULL
                    }
                }
                statusTxt <- jobName
            }# End queries
            argsList$statusbar$push(argsList$statusbar$getContextId("info"), paste("FEA ready: ", statusTxt, sep=""))
        }
    
        if(!is.null(msgText))
        {
            ############
            # Comun
            # queryReply dialog:
            dialog <- RGtk2::gtkDialogNewWithButtons("Query submited", argsList$parentWindow,
                                              c("modal", "destroy-with-parent"), 
                                              "gtk-ok", RGtk2::GtkResponseType["accept"], 
                                              show=FALSE)
            dialog[["vbox"]]$add(RGtk2::gtkLabel(msgText))
            response <- dialog$run() # showAll()
            dialog$destroy()                

            if(is.numeric(queryReply) && queryReply==-1) queryReply <- NULL # Error 
            
            if(!is.null(queryReply)) # 
            {                
                if(is.list(queryReply)) # (Not GTLinker)
                {
                    if(is.null(jobName)) jobName <- getJobName(queryReply$fileName)
                    feaResults <- queryReply
                    queryReply <- paste(jobName, .Platform$file.sep, jobName, "_feaResults.RData", sep="") 
                    save(feaResults, file=queryReply)
                }
                

                # Go to Network tab and pass values
                RGtk2::gtkNotebookSetCurrentPage(argsList$tabsSteps, argsList$tabID["Network"])
                argsList$feaResultsText$setText(queryReply)
                argsList$comboFeaTool$setActive(FEA_tools[activeTool,"ID"])
                
                if("genesFC" %in% names(feaResults)) 
                {
                    genesFC <- sort(names(feaResults$genesFC))                    

                    expressionBuffer <- RGtk2::gtkTextBufferNew()
                    RGtk2::gtkTextBufferSetText(expressionBuffer,  paste(genesFC,round(feaResults$genesFC[genesFC], digits=3), sep="\t", collapse="\n"))
                    RGtk2::gtkTextViewSetBuffer(argsList$expressionText, expressionBuffer)                    
                }
            }
            msgText <- NULL
        }
    }
}   


############################################################################################################
## Get FEA results
readFEAresults <- function(feaResultsText, comboFeaTool, expressionText, serverWebReportText, alreadyDownloadedCheck, parentWindow)
{
    gtLinkerWsPort <- ":8182"
    
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    fileName <- feaResultsText$getText()
    
    if(grepl(".RData",fileName, fixed=TRUE))
    {
        feaResults <- eval(as.name(load(fileName)))
        if("genesFC" %in% names(feaResults)) 
        {
            genesFC <- sort(names(feaResults$genesFC))                    
            
            expressionBuffer <- RGtk2::gtkTextBufferNew()
            RGtk2::gtkTextBufferSetText(expressionBuffer,  paste(genesFC,round(feaResults$genesFC[genesFC], digits=3), sep="\t", collapse="\n"))
            RGtk2::gtkTextViewSetBuffer(expressionText, expressionBuffer)                    
        }
    }else{
        reportTool <- comboFeaTool$getActive()
        reportTool <- rownames(FEA_tools)[which(as.numeric(FEA_tools[,"ID"])==reportTool)]
        
        if(reportTool == "GeneTerm Linker")
        {
            jobID <- fileName
            alreadyDownloaded <- alreadyDownloadedCheck$active
            serverWeb <- serverWebReportText$getText()
            serverWS <- paste(serverWebReportText$getText(), gtLinkerWsPort, sep="")
            # setwd("..") # GtLinker moves into the folder
            msgText <- NULL
            feaResults <- tryCatch({
                tmpResults <- suppressWarnings(fea_gtLinker_getResults(jobID=jobID, jobName=NULL, alreadyDownloaded=alreadyDownloaded,serverWeb=serverWeb,serverWS=serverWS, keepTrying=FALSE))
                tmpResults
            }, error = function(e) 
            {
                msgText <<- paste("Error in query:\n " ,e, sep="")
                NULL
            })
            if(is.null(feaResults))
            {
                msgText <- "The analysis has not finished yet or the jobID does not exist."
            }
            
            if(!is.null(msgText))
            {
                dialog <- RGtk2::gtkDialogNewWithButtons("FEA not ready", parentWindow,
                                                  c("modal", "destroy-with-parent"), 
                                                  "gtk-ok", RGtk2::GtkResponseType["accept"], 
                                                  show=FALSE)
                dialog[["vbox"]]$add(RGtk2::gtkLabel(msgText))
                response <- dialog$run() 
                dialog$destroy() 
                #stop()
            }else{
                # Save and replace jobID by the downloaded file:
                jobName <- getJobName(feaResults$fileName)
                fileName <- paste(jobName,"_feaResults.RData", sep="")
                fileName <- paste(getwd(), jobName, fileName, sep=.Platform$file.sep)
                save(feaResults, file=fileName)
                feaResultsText$setText(fileName) 
                alreadyDownloadedCheck$active <- TRUE
                
                
                # Add mgs to combo in subnetwork tab
                # subnw:
                #                 clSelectClusterFrame$label <- "Select metagroup"
                #                 clustersId <<- setNames(as.numeric(rownames(feaResults$metagroups))-1, rownames(feaResults$metagroups))
            }
            
        }else
        {
            feaResults <- readGeneTermSets(fileName, tool=reportTool,simplifyGage=FALSE) # geneLabels=NULL?
            
            # subnw:
            #clSelectClusterFrame$label <- paste("Select ", tolower(FEA_tools[reportTool,"GroupType"]), sep="")
            #             if(reportTool %in% c("DAVID","gage", "Imported text file"))
            #             {
            #                 # Add cl to combo in subnetwork tab
            #                 clustersId <<- setNames(0:(length(feaResults$clusters$Cluster)-1), feaResults$clusters$Cluster)
            #             } 
            #             if(reportTool %in% c("topGO"))
            #             {
            #                 # Add cl to combo in subnetwork tab
            #                 clustersId <<- setNames(1:nrow(feaResults)-1, 1:nrow(feaResults))
            #             }
        }
    }
    return(feaResults)
}

################################################################################
### Aux functions
# generateReport

# argsList=
# parentWindow, statusbar, 
# expressionText, comboExpressionPlot,
# commonFields$comboFeaTool, commonFields$feaResultsText, 
# commonFields$thresholdAttributeNetworkText, commonFields$thresholdValueNetworkText, commonFields$thresholdOperatorNetworkText
# plotChecksValues

generateReport <- function(button, argsList) # button: Not used, but required for signalConnect.
{ 
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    inputFile <- argsList$commonFields$feaResultsText$getText()
    reportTool <- argsList$commonFields$comboFeaTool$getActive()
    reportTool <- rownames(FEA_tools)[which(as.numeric(FEA_tools[,"ID"])==reportTool)]
    
    # Recargar siempre? donde poner para q solo cuando cambia?
    feaResults <- readFEAresults(feaResultsText=argsList$commonFields$feaResultsText,comboFeaTool=argsList$commonFields$comboFeaTool, expressionText=argsList$commonFields$expressionText,
                                  serverWebReportText=argsList$commonFields$serverWebReportText,alreadyDownloadedCheck=argsList$commonFields$alreadyDownloadedCheck, parentWindow=argsList$parentWindow)
    
    if(is.null(feaResults) || (reportTool==-1 || inputFile==""))
    {
        # Dialog
        dialog <- RGtk2::gtkDialogNewWithButtons("FEA results required", argsList$parentWindow,
                                          c("modal", "destroy-with-parent"), 
                                          "gtk-ok", RGtk2::GtkResponseType["accept"],
                                          show=TRUE)
        dialog[["vbox"]]$add(RGtk2::gtkLabel("Please provide a file with FEA results to continue."))
        response <- dialog$run() 
        dialog$destroy()
        
    }else
    {
        if(grepl(".RData", inputFile, fixed=TRUE)) 
        {
            load(inputFile)
        }
        
        ###################################################################
        # Get arguments
        # plotKeggPw <- argsList$plotChecksValues[["plotKeggPw"]]$active 
        plotGoTree <- argsList$plotChecksValues[["plotGoTree"]]$active 
        onlyGoLeaves <- argsList$plotChecksValues[["onlyGoLeaves"]]$active # Not for GtLinker. Only david (&other?)
                                                
        geneExpr <- processExpressionField(argsList$commonFields$expressionText)
        plotExpression <- names(argsList$commonFields$exprPlotOptionsID)[which(argsList$commonFields$exprPlotOptionsID==argsList$commonFields$comboExpressionPlot$getActive())]
        
        filterAttribute <- argsList$commonFields$thresholdAttributeNetworkText$getText()  # Only david and gTLinker
        if(filterAttribute=="") filterAttribute <- NULL
        filterThreshold <- argsList$commonFields$thresholdValueNetworkText$getText()
        if(filterThreshold=="") filterThreshold <- 0
        filterOperator <- argsList$commonFields$thresholdOperatorNetworkText$getText() 
        if(filterOperator=="") filterOperator <- NULL
                    
        # Report
        argsList$statusbar$push(argsList$statusbar$getContextId("info"), "Generating report...")


        tryCatch( 
        {
            FGNet_report(feaResults, geneExpr=geneExpr, plotExpression=plotExpression, onlyGoLeaves=onlyGoLeaves, plotGoTree=plotGoTree,
                         filterAttribute=filterAttribute, filterOperator=filterOperator, filterThreshold=filterThreshold)
            argsList$statusbar$push(argsList$statusbar$getContextId("info"), "Report ready.")
        }, error = function (e)
        {
            argsList$statusbar$push(argsList$statusbar$getContextId("info"), "Error generating report. See R console for details.")
            setwd("..")
            stop(e)
        })
        
    }
}

#################################################################################
### Fills Report tab
#################################################################################

tabReport_fill <- function(mainWindow, statusbar, commonFields)
{
    # report_david:
    #   geneLabels=NULL
    
    tabReport <- RGtk2::gtkVBox(FALSE,3)
    
    # plotChecks
    plotChecks <- c("plotGoTree", "onlyGoLeaves")  # onlyGoLeaves (only David/other?) TODO
    plotChecksFrame <- RGtk2::gtkFrame("Plot options")
    plotChecksArea <- RGtk2::gtkVBoxNew(homogeneous=FALSE, spacing=0)
    plotChecksFrame$add(plotChecksArea)
    plotChecksValues <-list()
    for(ck in plotChecks)
    {
        plotChecksValues[[ck]] <- RGtk2::gtkCheckButton(ck)
        plotChecksValues[[ck]]$active <- TRUE
        plotChecksArea$add(plotChecksValues[[ck]])
    }
    tabReport$packStart(plotChecksFrame, expand=FALSE)
    
    # Report tab end
    buttonReport <- RGtk2::gtkButton("Create")
    tabReport$packStart(buttonReport, expand = FALSE, FALSE, 10) 
    RGtk2::gSignalConnect(buttonReport, "clicked", generateReport, data=list(parentWindow=mainWindow, statusbar=statusbar, 
                                                                      commonFields=commonFields, plotChecksValues=plotChecksValues))               
    return(list(tabReport=tabReport, fields=list(plotChecksValues=plotChecksValues)))
}

# organism <- "Sc"
# annotations = c("GO_Biological_Process","GO_Molecular_Function")
# geneList = c("ADA2","APC1","APC11","APC2","APC4","APC5","APC9","CDC16","CDC23","CDC26","CDC27","CFT1","CFT2","DCP1","DOC1","FIP1","GCN5","GLC7","HFI1","KEM1","LSM1","LSM2","LSM3","LSM4","LSM5","LSM6","LSM7","LSM8","MPE1","NGG1","PAP1","PAT1","PFS2","PTA1","PTI1","REF2","RNA14","RPN1","RPN10","RPN11","RPN13","RPN2","RPN3","RPN5","RPN6","RPN8","RPT1","RPT3","RPT6","SGF11","SGF29","SGF73","SPT20","SPT3","SPT7","SPT8","TRA1","YSH1","YTH1")

# organism <- "Hs"
# annotations = c("KEGG_Pathways")
# geneList = c("A2M","ABL1","APBA1","APBB1","APLP1","APLP2","APOE","APP","ATOH1","BRCA1","BRCA2","CDK5R1","CDK5","CDK5R2","DAB1","DLL1","DNMT1","EGFR","ERBB2","ETS1","FOS","FYN","GLI1","GLI2","GLI3","JAG1","KIT","LRP1","LRP8","MAPT","MYC","NOTCH1","NRAS","PAX2","PAX3","PSEN1","PSEN2","PTCH1","RELN","ROBO1","SHC1","SHH","SMO","SRC","TGFB1","TP53","VLDLR","WNT1","WNT2","WNT3")
# serverWS ="http://localhost:8182"

# jobID <- query_gtLinker(organism, geneList, annotations, serverWS=serverWS)
fea_gtLinker <- function(geneList, organism="Hs", annotations=c("GO_Biological_Process","GO_Molecular_Function", "GO_Cellular_Component", "InterPro_Motifs"), minSupport=4, serverWS ="http://gtlinker.cnb.csic.es:8182")
{    
    # Check arguments
    if(!is.character(organism)) stop("Organism should be either 'Hs' (Homo sapiens) or 'Sc' (Saccharomyces cerevisiae). ")
    organism <- capitalize(tolower(organism))
    if (!(organism %in% c("Sc","Hs"))) stop("Organism should be either 'Hs' (Homo sapiens) or 'Sc' (Saccharomyces cerevisiae).")
    
    if(!is.character(geneList)) stop("geneList should be a character vector containing the names of the genes.")
    
    if(!is.character(annotations)) stop()
    annotations <- tolower(annotations)
    allowedAnnotations <- c("GO_Biological_Process","GO_Molecular_Function", "GO_Cellular_Component", "InterPro_Motifs")
    if(!all(annotations %in% tolower(allowedAnnotations))) stop(paste("Available annotations: ", allowedAnnotations, sep=""))        
    # if(!all(annotations %in% allowedAnnotations)) stop(paste("Available annotations: ", allowedAnnotations, sep=""))    
    
    if(!is.numeric(minSupport)) stop("minSupport should be a number.")        
    minSupport <- as.integer(minSupport)
    if(minSupport<2 || minSupport>100) stop("minSupport should be more than 1.")        
    
    if(!is.character(serverWS)) stop("Webservice server url not valid.")
    
    analyze_envelope_body <-     paste('<analyze xmlns="urn:gtLinkerWS">',
                                                                    '<org xsi:type="xsd:string">', organism,'</org>',
                                                                    '<genelist xsi:type="SOAP-ENC:Array" SOAP-ENC:arrayType="xsd:string[', length(geneList),']">',
                                                                    paste('<item xsi:type="xsd:string">', geneList,'</item>', sep="", collapse=""),
                                                                    '</genelist>',
                                                                    '<annotations xsi:type="SOAP-ENC:Array" SOAP-ENC:arrayType="xsd:string[', length(annotations),']">',
                                                                    paste('<item xsi:type="xsd:string">', annotations,'</item>', sep="", collapse=""),
                                                                    '</annotations>',
                                                                    '<minsupport>', minSupport, '</minsupport></analyze>', sep="")
    
    reply <- SOAPQuery(analyze_envelope_body, serverWS)
    
    jobID <- reply$analyzeResponse
    if (jobID=="") jobID <- as.character(-1)
    return(as.character(jobID))
}

# 
# FGNET - DEFAULT (genes-genes with background)
# 
plotFGNet_default <- function(metagroupsMatrix,gtSetsMatrix, vLayout, plotOutput, plotExpression, eWidth, eColor, vColor, vExpr, vSize, vLabelCex, colores, markGroup, trCols, weighted, plotTitle, plotTitleSub, plotLegend, legendPrefix, legendText)
{
    #####################################################################################################
    #################################### Create Matrices  ###############################################
    nGenes <- nrow(metagroupsMatrix)
    nMetagroups <- ncol(metagroupsMatrix)
    # Gene - Gene edges 
    nCommonGTsets <- matrix(ncol=nGenes, nrow=nGenes, data=0)
    rownames(nCommonGTsets) <- rownames(metagroupsMatrix)
    colnames(nCommonGTsets) <- rownames(metagroupsMatrix)
    # Counts
    nCommonMgroups <- nCommonGTsets
    # Fill:
    for(gen1 in rownames(metagroupsMatrix))
        for(gen2 in rownames(metagroupsMatrix))
        {
            if(gen1!=gen2) nCommonMgroups[gen1, gen2] <- sum(metagroupsMatrix[gen1,] + metagroupsMatrix[gen2,]==2)
            if(gen1!=gen2) nCommonGTsets[gen1, gen2] <- sum(gtSetsMatrix[gen1,] + gtSetsMatrix[gen2,]==2)
        }
    
    #####################################################################################################
    ####################################   Create Graph   ###############################################
    # weighted=TRUE The name of the edge attribute will be weight.
    # weighted=NULL (Unweighted graph. The elements of the adjacency matrix give the number of edges between vertices.)
    graphCommonGTsets <- graph.adjacency(nCommonGTsets, weighted=TRUE, mode="undirected", diag=FALSE) 
    graphCommonMgroups <- graph.adjacency(nCommonMgroups, weighted=NULL, mode="undirected", diag=FALSE)
    
    #####################################################################################################
    #########################################  Draw PLOTS  ##############################################
    if(any(plotOutput %in% c("static", "dynamic")))
    {
        ###########################
        # Vertex layout
        # weighted=NULL (Unweighted graph. The elements of the adjacency matrix give the number of edges between vertices.) -> No parece importar para el layout
        vertexLayout <- vLayout
        if(is.null(vertexLayout))
        {
            # Set layout based on the metagroups
            if(nMetagroups>1) 
            {
                # (graphCommonMgroups) NOT weigted: place genes with more mg in common closer
                graph4layout <- graphCommonMgroups
            } else { # If there is only one metagroup, set layout based on the common gene-term sets
                graphCommonMgroups <- NA
                graph4layout <- graphCommonGTsets   
            }        
            
            if(FALSE)
            {
                # Parecido a fruchterman reingold, pero apelotona un poco menos los nodos comunes
                vertexLayout <- layout.kamada.kawai(graph4layout)    
            }else
            {
                # Si son dos grupos separados (no tienen ningun nodo en comun) kamada kawai superpone los dos grupos = MALO
                vertexLayout <- layout.fruchterman.reingold(graph4layout)#,  area=200000, repulserad=200000*vcount(graph4layout))
            }
        }
        
        #######################
        # Edge weight
        if(is.null(eWidth))
        {
            if(weighted && ecount(graphCommonGTsets)>0)
            {
                eWidth <- E(graphCommonGTsets)$weight
                eWidth <- floor((eWidth/max(eWidth))*5)
                if(min(eWidth)<1) eWidth <- eWidth +1
                if(min(eWidth) == max(eWidth)) eWidth <- 1
            }else eWidth <- 1
        }
        
        #######################
        # Plot
        plotFGNet(graph2plot=graphCommonGTsets, plotType="default", plotOutput=plotOutput, plotExpression=plotExpression, vertexLayout=vertexLayout, eWidth=eWidth, eColor=eColor, vColor=vColor,
                  vExpr=vExpr, vSize=vSize, vLabelCex=vLabelCex, colores=colores, markGroup=markGroup, trCols=trCols,
                  plotTitle=plotTitle, plotTitleSub=plotTitleSub, plotLegend=plotLegend, legendPrefix=legendPrefix, legendText=legendText)   
    }

    ret <- list(iGraph=list(commonClusters=graphCommonMgroups, commonGtSets=graphCommonGTsets),
            adjMat=list(commonClusters=nCommonMgroups, commonGtSets=nCommonGTsets))

    return(ret)
}

################################################################################
### Aux functions
# viewFile
# syncTermDescCombos
# fillCombosColumns
# processFile
# formatResultsFile

viewFile <- function(button)
{
    View(rawResults)
}


syncTermDescCombos <- function(combo, colsCombos)
{
    if(combo$getName() == "termDescCol1") colsCombos$termDescCol_B$setActive(colsCombos$termDescCol$getActive())
    if(combo$getName() == "termDescCol2") colsCombos$termDescCol$setActive(colsCombos$termDescCol_B$getActive())
}


fillCombosColumns <- function(colsCombos, rawResults) # used by processFile()
{
    lapply(colsCombos, function(thisCombo){
        thisCombo$getModel()$clear()
        for (colN in c("-", colnames(rawResults))) RGtk2::gtkComboBoxAppendText(thisCombo, colN)
        thisCombo$setActive(-1)
        return(thisCombo)
    })  
}

processFile <- function(fileName, fieldsList) # called by loadFileDialog(buttonImportFeaResults)
{
    if(grepl(".rdata", tolower(fileName), fixed=TRUE))
    {
        ######### load(.RData)
        loadedObjects <- load(fileName)
        # select object: 
        if(length(loadedObjects)>1) stop("Please load an .RData file containing only a data.frame") ### TO DO!!!
        rawResults <<- eval(as.name(loadedObjects))
    }else
    {
        ######### load TEXT file
        # fileName <- "reactPA.txt"

        sep <- names(fieldsList$fieldSepsValueID[which(fieldsList$fieldSepsValueID==fieldsList$txtOptionsSepCombo$getActive())])
        header <- fieldsList$txtOptionsHeaderChk$active
        quote <- fieldsList$txtOptionsQuoteChk$active 
        quote <- ifelse(quote, "\"'", "")

        rawResults <<- read.table(fileName,header=header,sep=sep, quote=quote) 
    }
    if(!is.null(rawResults))
    {
        # set newFileName
        #         splitedFN <- strsplit(fileName,".", fixed=TRUE)[[1]]
        #         fName <- paste(splitedFN[1:(length(splitedFN)-1)], collapse=".")
        #         fExt <- NULL
        #         if(length(splitedFN)>1) fExt <- paste(".", splitedFN[length(splitedFN)], sep="")
        
        if(fieldsList$jobNameText$getText()=="")
        {
            fName <- getJobName(fileName)
            fName <- gsub("_raw","", fName)
            jobName <- paste(fName, "_formatted", sep="")     # , fExt
            fieldsList$jobNameText$setText(jobName)
        }
        
        fillCombosColumns(fieldsList$colsCombos, rawResults)
        RGtk2::gtkWidgetSetSensitive(fieldsList$buttonViewResults,TRUE)
    }
}

formatResultsFile <- function(fieldsList) # called by submitQuery() 
{
    # Text fields
    newFileName <- fieldsList$jobNameText$getText()
    if(newFileName=="") newFileName <- NULL
    geneSep <- fieldsList$geneSepText$getText()
    if(geneSep=="") geneSep<-NULL
    termCat <- fieldsList$termCatText$getText()
    if(termCat=="") termCat<-NULL
    termSep <- fieldsList$termSepText$getText()
    if(termSep=="") termSep<-NULL
    
    # Columns (combo)
    colsValues <- sapply(fieldsList$colsCombos, function(x) x$getActive())
    colsValues[colsValues==-1] <- NA
    colsValues[colsValues==0] <- NA
    colsValues <- setNames(colnames(rawResults)[colsValues], names(colsValues))
    colsValues<-as.list(colsValues)
    colsValues[is.na(colsValues)] <- NULL
    
    fileFormated <- NULL 
    
    # Create folder
    if(!file.exists(file.path(newFileName)))
    {
        dir.create(file.path(newFileName))        
    }
    currWD <- getwd()
    setwd(newFileName)
    
    # Format
    fileFormated <- format_results(rawResults, newFileName=paste(newFileName, ".txt", sep=""), 
                                   clusterCol=colsValues$clusterCol, geneCol=colsValues$geneCol, geneSep=geneSep, termDescCol=colsValues$termDescCol, termIDCol=colsValues$termIDCol, 
                                   termCatCol=colsValues$termCatCol, termCat=termCat, termSep=termSep)
    
    # Return to folder
    setwd(currWD)
    
    return(fileFormated)
}

#################################################################################
### Fills Other tab
#################################################################################
    
tabOther_fill <- function(mainWindow, jobNameText)
{
    tabOther <- RGtk2::gtkVBox(FALSE,2)
    tabOther$packStart(RGtk2::gtkLabelNew("Format external FEA results to use with FGNet"), expand=FALSE)
    
    ############# Text file options
    txtOptionsExpander <- RGtk2::gtkExpander("Text file options")
    txtOptionsExpanderBox <- RGtk2::gtkHBox(FALSE,3)
    txtOptionsHeaderChk <- RGtk2::gtkCheckButton("Header")
    txtOptionsHeaderChk$active <- TRUE
    txtOptionsExpanderBox$packStart(txtOptionsHeaderChk, expand=FALSE)
    txtOptionsQuoteChk <- RGtk2::gtkCheckButton("Quote")
    txtOptionsQuoteChk$active <- TRUE
    txtOptionsExpanderBox$packStart(txtOptionsQuoteChk, expand=FALSE)
    txtOptionsExpanderBox$packStart(RGtk2::gtkLabelNew(" Sep: "), expand=FALSE)
    fieldSepsText <- setNames(1:4-1,c("Space", "Tab",",",";"))
    fieldSepsValueID <- setNames(1:4-1,c(" ", "\t",",",";"))
    txtOptionsSepCombo <- RGtk2::gtkComboBoxNewText()
    for (id in names(fieldSepsText)) RGtk2::gtkComboBoxAppendText(txtOptionsSepCombo, id) 
    txtOptionsSepCombo$setActive(1)
    txtOptionsSepCombo$SetTooltipText('Field separator character.')
    txtOptionsExpanderBox$packStart(txtOptionsSepCombo, expand=FALSE)
    txtOptionsExpander$add(txtOptionsExpanderBox)
    tabOther$packStart(txtOptionsExpander, expand=FALSE)
    
    ############# Select results file
    tabOtherH1Box <- RGtk2::gtkHBox(FALSE,3)
    # File
    framefeaResultsImport <- RGtk2::gtkFrame("Raw FEA results")
    RGtk2::gtkFrameSetShadowType(framefeaResultsImport, GtkShadowType["none"])
    feaResultsImportText <- RGtk2::gtkEntryNew()
    feaResultsImportText$setWidthChars(25)
    feaResultsImportText$"tooltip-text" <- "text file or .RData with data.frame"
    framefeaResultsImport$add(feaResultsImportText)
    tabOtherH1Box$packStart(framefeaResultsImport, expand=TRUE)
    
    # Button View
    frameFEAfileView_other <- RGtk2::gtkFrame("")
    RGtk2::gtkFrameSetShadowType(frameFEAfileView_other, GtkShadowType["none"])
    buttonViewResults <- RGtk2::gtkButton("View")
    buttonViewResults$name <- "buttonViewResults"
    RGtk2::gSignalConnect(buttonViewResults, "clicked", viewFile) 
    frameFEAfileView_other$add(buttonViewResults)
    RGtk2::gtkWidgetSetSensitive(buttonViewResults,FALSE)
    tabOtherH1Box$packStart(frameFEAfileView_other, expand=FALSE)
    
    # Button load
    frameImportFeaResults <- RGtk2::gtkFrame("")
    RGtk2::gtkFrameSetShadowType(frameImportFeaResults, GtkShadowType["none"])
    buttonImportFeaResults <- RGtk2::gtkButton("Select file")
    buttonImportFeaResults$name <- "buttonImportFeaResults"
    frameImportFeaResults$add(buttonImportFeaResults)
    tabOtherH1Box$packStart(frameImportFeaResults, expand=FALSE)
    
    tabOther$packStart(tabOtherH1Box, expand=FALSE)
    
    ############# Format options
    #####  Create fields    
    # geneSep=NULL
    geneSepTextFrame <- RGtk2::gtkFrame() 
    RGtk2::gtkFrameSetShadowType(geneSepTextFrame, GtkShadowType["none"])
    geneSepText <- RGtk2::gtkEntryNew()
    geneSepText$setWidthChars(5)
    geneSepText$SetTooltipText("  ,    ; ")
    geneSepTextFrame$add(geneSepText)
    
    # termSep=NULL
    termSepTextFrame <- RGtk2::gtkFrame()
    RGtk2::gtkFrameSetShadowType(termSepTextFrame, GtkShadowType["none"])
    termSepText <- RGtk2::gtkEntryNew()
    termSepText$setWidthChars(5)
    termSepText$SetTooltipText("  ,    ; ")
    termSepTextFrame$add(termSepText)
    
    # termCat=NULL
    termCatText <- RGtk2::gtkEntryNew()
    termCatText$setWidthChars(10)
    #termCatTextFrame$add(termCatText)
    
    # Select columns for...
    colsID <- c("clusterCol", "geneCol", "termDescCol","termDescCol_B", "termIDCol", "termCatCol")
    colsCombos <- lapply(colsID, function(x) RGtk2::gtkComboBoxNewText())
    names(colsCombos) <- colsID
    
    colsCombos$termDescCol$setName("termDescCol1")
    colsCombos$termDescCol_B$setName("termDescCol2")

    colsFrames <- lapply(colsID, function(x) 
    {
        tmp <- RGtk2::gtkFrame() #(x)
        RGtk2::gtkFrameSetShadowType(tmp, GtkShadowType["none"])
        tmpBox <- RGtk2::gtkHBox(FALSE,3)
        #tmpBox$packStart(colsText[[x]], expand=TRUE)
        tmpBox$packStart(colsCombos[[x]], expand=TRUE)
        tmp$add(tmpBox)
        return(tmp)
    })
    names(colsFrames) <- colsID
    
    #####  Place fields    
    frameFormatOptions <- RGtk2::gtkFrame("Select columns")
    formatOptionsBox <- RGtk2::gtkVBox(FALSE,3)
    
    formatOptionsTable <- RGtk2::gtkTable(rows = 3, columns = 4, homogeneous = FALSE)
    formatOptionsTable$attach(RGtk2::gtkLabel("Cluster"), left.attach=1,2, top.attach=0,1)
    formatOptionsTable$attach(RGtk2::gtkLabel("Genes"), left.attach=2,3, top.attach=0,1)
    formatOptionsTable$attach(RGtk2::gtkLabel("Terms"), left.attach=3,4, top.attach=0,1)
    
    
    formatOptionsTable$attach(colsFrames$clusterCol, left.attach=1,2, top.attach=1,2)
    formatOptionsTable$attach(colsFrames$geneCol, left.attach=2,3, top.attach=1,2)
    formatOptionsTable$attach(colsFrames$termDescCol, left.attach=3,4, top.attach=1,2)
    
    formatOptionsTable$attach(RGtk2::gtkLabel("Sep. char:"), left.attach=1,2, top.attach=2,3)
    formatOptionsTable$attach(geneSepTextFrame, left.attach=2,3, top.attach=2,3)
    formatOptionsTable$attach(termSepTextFrame, left.attach=3,4, top.attach=2,3) 
    
    # Common category
    formatOptionsTable$setColSpacing(0, 5)
    formatOptionsBox$packStart(formatOptionsTable, expand=FALSE)
    frameFormatOptions$add(formatOptionsBox)
    tabOther$packStart(frameFormatOptions, expand=FALSE)
    
    ### Terms alternative:
    formatTermsFrameB <- RGtk2::gtkFrame("Terms - Alternative formatting")
    formatOptionsAltTable <- RGtk2::gtkTable(rows = 3, columns = 3, homogeneous = FALSE)
    formatOptionsAltTable$attach(RGtk2::gtkLabel("Category"), left.attach=0,1, top.attach=0,1)
    formatOptionsAltTable$attach(RGtk2::gtkLabel("ID"), left.attach=1,2, top.attach=0,1) 
    formatOptionsAltTable$attach(RGtk2::gtkLabel("Description"), left.attach=2,3, top.attach=0,1) 
    
    formatOptionsAltTable$attach(colsFrames$termCatCol, left.attach=0,1, top.attach=1,2)
    formatOptionsAltTable$attach(termCatText, left.attach=0,1, top.attach=2,3)
    formatOptionsAltTable$attach(colsFrames$termIDCol, left.attach=1,2, top.attach=1,2) 
    formatOptionsAltTable$attach(colsFrames$termDescCol_B, left.attach=2,3, top.attach=1,2) 
    
    formatTermsFrameB$add(formatOptionsAltTable)
    tabOther$packStart(formatTermsFrameB, expand=FALSE)
    
    fields <- list(txtOptionsHeaderChk=txtOptionsHeaderChk, txtOptionsQuoteChk=txtOptionsQuoteChk, txtOptionsSepCombo=txtOptionsSepCombo, fieldSepsValueID=fieldSepsValueID,
               feaResultsImportText=feaResultsImportText,buttonViewResults=buttonViewResults, buttonImportFeaResults=buttonImportFeaResults,
               colsCombos=colsCombos, colsID=colsID,
               geneSepText=geneSepText, termSepText=termSepText,
               termCatText=termCatText)

    # SignalConnects
    RGtk2::gSignalConnect(buttonImportFeaResults, "clicked", loadFileDialog, data=list(parentWindow=mainWindow, fields=c(fields,list(jobNameText=jobNameText)))) 
    RGtk2::gSignalConnect(colsCombos$termDescCol_B, "changed", syncTermDescCombos, data=colsCombos)
    RGtk2::gSignalConnect(colsCombos$termDescCol, "changed", syncTermDescCombos, data=colsCombos) 
    
    #######################################################################
    ## tabOther ready 
    return(list(tabOther=tabOther, fields=fields))
    #######################################################################
}

# results <- getResults_David (fileName)
format_david <- function(fileName, jobName=NULL, geneLabels=NULL, moveFile=FALSE, downloadFile=TRUE)
{
    # Check arguments
    if(!is.character(fileName)) stop("fileName not valid.")
    if(!is.null(jobName) && !is.character(jobName)) stop("jobName should be character.")

    ###############################
    # Prepare jobName / folder
    isURL <- grepl("https://", fileName)

    if(is.null(jobName))
    {
        if(isURL) jobName <- paste(sample(100000:999999,size=1), "_DavidClustering",sep="")
        if(!isURL) jobName <- sub("_raw", "", getJobName(fileName), fixed=TRUE)
    }
    if(downloadFile) folder <- jobName
    if(!downloadFile) folder <- tempdir()

    # Create folder
    if((!file.exists(file.path(folder))))
    {
        dir.create(file.path(folder))
    }
    currWD <- getwd()
    setwd(folder)

    ###############################
    # Download file
    if(isURL)
    {
        downloadedFileName <- paste(jobName, "_raw.txt", sep="")
        finalReply <- getURL(fileName, ssl.verifypeer = FALSE) # with https...
        write(finalReply, file=downloadedFileName)
        fileName <- downloadedFileName

        if(downloadFile) message(paste("Raw results downloaded and saved as ", fileName,"'", sep=""))
    }else{
        if(!file.exists(fileName))
        {
            setwd(currWD)
            stop("The file does not exist.")
        }
        downloadedFileName <- paste(jobName, "_raw.txt", sep="")
        if(fileName != paste(getwd(),downloadedFileName, sep=.Platform$file.sep)) # Same file, no need to copy
        {
            tmp <- paste(sample(1:9999999,1), ".txt", sep="") # Needed in case origin and destination are the same file (i.e. link)
            file.copy(fileName, tmp, overwrite=TRUE)
            file.copy(tmp, downloadedFileName, overwrite=TRUE)
            file.remove(tmp)
            if(moveFile) file.remove(fileName)
            if(downloadFile) message(paste("Results file copied to '", folder,.Platform$file.sep, downloadedFileName,"'", sep=""))
        }
        fileName <- downloadedFileName
    }

    # Read file & process
    if (!file.exists(fileName))
    {
        setwd(currWD)
        stop("Can't open or download the results file.")
    }    else
    {
        inputFile <- file(fileName, "rt")
        lineas <- readLines(inputFile)
        if(length(lineas)==0) stop("DAVID returned 0 clusters.")

        columns <- c("Cluster", "ClusterEnrichmentScore", strsplit(lineas[2], "\t", fixed=TRUE)[[1]])
        tablaGeneTermSets <- matrix(NA, ncol=length(columns), nrow=0, dimnames=list(c(), columns))
        clusterScore <- NULL
        cluster <- 0

        lineas <- lineas[which(lineas != "")]
        lineas <- lineas[which(lineas != lineas[2])]
        lineas <- strsplit(lineas, "\t", fixed=TRUE)

        for(linea in lineas)
        {
            if(length(linea)==2)
            {
                cluster <- cluster+1
                clusterScore[[cluster]] <- as.numeric(strsplit(linea[2], ": ", fixed="TRUE")[[1]][2])
                names(clusterScore)[cluster] <- cluster
            }
            else
            {
                tablaGeneTermSets <- rbind(tablaGeneTermSets, c(cluster, clusterScore[cluster], linea))
            }
        }
        close(inputFile)
        tablaGeneTermSets <- data.frame(tablaGeneTermSets)

        ##########################
        # Format tablaGeneTermSets
        colnames(tablaGeneTermSets)[which(colnames(tablaGeneTermSets)=="Term")] <- "Terms"
        tablaGeneTermSets$Terms <- sapply(tablaGeneTermSets$Terms, function(x) gsub("~",":",x))
        tablaGeneTermSets$Genes <- sapply(tablaGeneTermSets$Genes, function(x) gsub(" ","",x))

        # Kegg
        # keggs <- which(tablaGeneTermSets[,"Category"] == "KEGG_PATHWAY")
        # if(length(keggs)>0) tablaGeneTermSets[keggs, "Terms"] <- paste("KEGG:", tablaGeneTermSets[keggs, "Terms"], sep="")

        # Reactome
        reactomes <- grep("REACTOME_PATHWAY", tablaGeneTermSets[,"Category"])
        if(length(reactomes)>0)  tablaGeneTermSets[reactomes, "Terms"] <- sub("REACT_", "REACT:", tablaGeneTermSets[reactomes, "Terms"])

        # Interpro
        iprs <- grep("INTERPRO", tablaGeneTermSets[,"Category"])
        if(length(iprs)>0) tablaGeneTermSets[iprs, "Terms"] <- sub("IPR", "IPR:", tablaGeneTermSets[iprs, "Terms"])

        # Not any of these annotations...
        gos <- grep("GOTERM", tablaGeneTermSets[,"Category"])
        otherAnnot <- which(!(1:dim(tablaGeneTermSets)[1] %in% c(gos, iprs, reactomes)))
        if (length(otherAnnot) > 0)
        {
            tablaGeneTermSets[otherAnnot, "Terms"] <- sapply(strsplit(tablaGeneTermSets[otherAnnot, "Terms"], split=":"), function(x) paste(x[-1], " (ID ", x[1], ")", sep=""))
            tablaGeneTermSets[otherAnnot, "Terms"] <- paste(tablaGeneTermSets[otherAnnot, "Category"], tablaGeneTermSets[otherAnnot, "Terms"], sep=":")
        }
        tablaGeneTermSets[, "Terms"] <- gsub(";", ". ", tablaGeneTermSets[, "Terms"])

        # Replace Gene Names?
        tablaGeneTermSets <- addGeneLabels(tablaGeneTermSets, geneLabels)

        # Save formatted file
        fileName <- paste(jobName, "_formatted.txt", sep="")
        write.table(as.matrix(tablaGeneTermSets), file=fileName, quote=FALSE, row.names=FALSE, sep="\t")
    }
    ret <- readGeneTermSets(fileName, tool="DAVID")
    setwd(currWD)
    invisible(ret)
}

# Returns color by order of metagroup (first color = first metagroup in list...)
setColors <- function(namesMg, transparency=0)
{
    nMetagroups <- length(namesMg)
    mgAlpha <- 1-transparency
    if(nMetagroups <5)
    {    
        colores <- c("#FF0000","#FFFF00","#0000FF", "#FF00E6")
        mgAlpha <- as.hexmode(round(mgAlpha*255))
        colores <- paste(colores, mgAlpha, sep="")
        
        colores <- colores[1:nMetagroups]
    }else
    {        
        secondStart <- 0.55
        if(nMetagroups > 8) secondStart <- 0.5

        n1 <- trunc(nMetagroups/2)
        n2 <- length((trunc(nMetagroups/2)+1):nMetagroups)
        
        colores <- rainbow(n1, end=0.3, s=1, v=1, alpha=mgAlpha)
        colores <- c(colores, rainbow(n2, start=secondStart, end=0.85, s=1, v=1, alpha=mgAlpha))
    }
    names(colores) <- namesMg
    
    return(colores)
}

#barplot(rep(1,length(colores)), col=as.character(colores), axes=FALSE)

FGNet_GUI <- function(geneList=NULL)
{
    if(!loadInstPkg("RGtk2")) stop("Package RGtk2 is required to use the GUI.")
    
    # feaResults <<- NULL # Global

    data("FEA_tools", envir = environment())
    FEA_tools <- get("FEA_tools", envir  = environment())
    
    data("groupTypes", envir = environment())
    groupTypes <- get("groupTypes", envir  = environment())
    
    data("organisms", envir = environment())
    organisms <- get("organisms", envir  = environment())
    
    data("GOEvidenceCodes", envir = environment())
    GOEvidenceCodes <- get("GOEvidenceCodes", envir  = environment())
    
    # Crear ventana
    mainWindow <- RGtk2::gtkWindowNew("toplevel", show=FALSE)
    #mainWindow$setDefaultSize(500,768)
    mainWindow$setTitle("Functional Gene Networks")
    mainWindow$setBorderWidth(2)
    
    # Statusbar
    statusbar <- RGtk2::gtkStatusbar()
    statusbar$push(statusbar$getContextId("info"), "Ready.")
    
    # Create tabs
    tabsSteps <- RGtk2::gtkNotebookNew()
    tabsSteps$name<-"tabsSteps"
    tabsSteps$setTabPos("left")
    
    
    ###################################################################################
    ############## Network tab
    tabNetwork <- tabNetwork_fill(mainWindow, statusbar, geneList)
    
    ###################################################################################
    ############## FEA tab
    tabFEA <- tabFEA_fill(mainWindow, statusbar, geneList)
    
    ###################################################################################
    ############## Other tabs
    # (tabCompare)
    # TO DO
    
    # (tabHelp)
    tabHelp <- tabHelp_fill(mainWindow) # TO DO
    
    ###################################################################################
    ############## Add tabs to mainWindow
    tabID <- setNames(0:4, c("FEA", "Network", "Compare", "help")) #"Import",
    RGtk2::gtkNotebookInsertPage(tabsSteps, tabFEA$tabFEA, position = tabID["FEA"], tab.label = RGtk2::gtkLabelNew("1 - FEA    "))
    # RGtk2::gtkNotebookInsertPage(tabsSteps, tabImport, position = tabID["Import"], tab.label = RGtk2::gtkLabelNew("import?"))
    RGtk2::gtkNotebookInsertPage(tabsSteps, tabNetwork$tabNetwork, position = tabID["Network"], tab.label =  RGtk2::gtkLabelNew("2 - Network"))
    # RGtk2::gtkNotebookInsertPage(tabsSteps, tabCompare, position = tabID["Compare"], tab.label = RGtk2::gtkLabelNew("compare?"))
    RGtk2::gtkNotebookInsertPage(tabsSteps, tabHelp$tabHelp, position = tabID["help"], tab.label = RGtk2::gtkLabelNew("Help"))

    box.vMain <- RGtk2::gtkVBoxNew()
    box.vMain$packStart(tabsSteps, expand=TRUE, fill=TRUE, 0)
    box.vMain$packStart(statusbar, expand=FALSE, fill=TRUE, 0)
    

    ###################################################################################
    ############## Signal connects
    # Submit Query:
    RGtk2::gSignalConnect(tabFEA$commonFields$buttonSubmit, "clicked", submitQuery, data=list(parentWindow=mainWindow, statusbar=statusbar, 
                                                                                       feaResultsText=tabNetwork$commonFields$feaResultsText, comboFeaTool=tabNetwork$commonFields$comboFeaTool, expressionText=tabNetwork$commonFields$expressionText,serverWebReportText=tabNetwork$commonFields$serverWebReportText, 
                                                                                       tabsSteps=tabsSteps, tabID=tabID, tabFEA=tabFEA))    
    mainWindow$add(box.vMain)
    mainWindow$show()
}

################################################################################
### Aux functions
# loadEset
# selectLoadGs
# selectNewGs

loadEset <- function(fileName, refSamplesBox, compSamplesBox)
{
    for(samp in refSamplesBox$getChildren()) refSamplesBox$remove(samp) # Vaciar
    for(samp in compSamplesBox$getChildren()) compSamplesBox$remove(samp) # Vaciar
    
    esetFile <- load(fileName)
    
    refSamplesList <- list()
    compSamplesList <- list()
    for(samp in sort(colnames(eval(as.name(esetFile)))))
    {
        refSamplesList[[samp]] <- RGtk2::gtkCheckButton(samp)        
        refSamplesBox$packStart(refSamplesList[[samp]], expand=FALSE)
        
        compSamplesList[[samp]] <- RGtk2::gtkCheckButton(samp) 
        compSamplesBox$packStart(compSamplesList[[samp]], expand=FALSE)
    }
}

selectLoadGs <- function(aux, argsList)
{
    argsList$loadGeneSetsFrame$setVisible(TRUE)
    argsList$newGsBox$setVisible(FALSE)
    
    argsList$frameAnnotsGage$label <- "Select annotations (if available):"
}

selectNewGs <- function(aux, argsList)
{
    save(argsList,file="argsList.Rdata")
    argsList$loadGeneSetsFrame$setVisible(FALSE)
    argsList$newGsBox$setVisible(TRUE)
    
    argsList$frameAnnotsGage$label <- "Annotations:"
}


#################################################################################
### Fills GAGE tab
#################################################################################
    
tabGage_fill <- function(mainWindow, allOrgs)
{
    ########################################################################
    # Fill tab
    tabGage <- RGtk2::gtkVBox(FALSE,0)
    
    ###############
    # geneSets=NULL
    geneSetsFrame <- RGtk2::gtkFrame("Gene sets")
    gageV2Box <- RGtk2::gtkVBoxNew(homogeneous=FALSE, spacing=5)
    
    #### radioFrame Seledt gene set type
    # Radio button
    gsRadioFrame <- RGtk2::gtkFrame("")
    RGtk2::gtkFrameSetShadowType(gsRadioFrame, GtkShadowType["none"])
    gsRadioBoxH <- RGtk2::gtkHBox(FALSE,3)
    gsLoadRadio <- RGtk2::gtkRadioButtonNewWithLabelFromWidget(RGtk2::gtkRadioButton(), "Load")
    gsLoadRadio$"tooltip-text" <- "Load existing gene sets (.gmt or .RData files)"
    gsLoadRadio$active<-TRUE
    gsNewRadio <- RGtk2::gtkRadioButtonNewWithLabelFromWidget(gsLoadRadio, "Create new")
    gsNewRadio$"tooltip-text" <- "Create new gene sets for given IDs and organism."
    
    # gSignalConnect at end
    
    gsRadioBoxH$packStart(gsLoadRadio, FALSE, FALSE, 5)
    gsRadioBoxH$packStart(gsNewRadio, FALSE, FALSE, 5)
    
#     gsRadioFrame$add(gsRadioBoxV)
#     tabGage$packStart(gsRadioFrame, expand=FALSE)
gageV2Box$packStart(gsRadioBoxH, expand = FALSE)

    
    ###############
    # Load gene sets
    # File
    geneSetsH1Box <- RGtk2::gtkHBox(FALSE,3)
    loadGeneSetsFrame <- RGtk2::gtkFrame("Load")
    RGtk2::gtkFrameSetShadowType(loadGeneSetsFrame, GtkShadowType["none"])
    geneSetsTxt <- RGtk2::gtkEntryNew()
    geneSetsH1Box$packStart(geneSetsTxt, expand=TRUE)
    geneSetsTxt$"tooltip-text" <- ".gmt or .RData"
    # Button load
    geneSetsButton <- RGtk2::gtkButton("Select file")
    geneSetsButton$name <- "geneSetsButton"
    geneSetsH1Box$packStart(geneSetsButton, expand=FALSE)
    loadGeneSetsFrame$add(geneSetsH1Box)
    gageV2Box$packStart(loadGeneSetsFrame, expand=FALSE)
    
    #######
    # Hbox - GeneID & spec
    newGsBox <- RGtk2::gtkHBoxNew(homogeneous=FALSE, spacing=0)
    # geneIdType 
    geneIDsGage <- c("ENTREZID")
    frameGeneIdTypeGage <- RGtk2::gtkFrame("Gene ID")
    RGtk2::gtkFrameSetShadowType(frameGeneIdTypeGage, GtkShadowType["none"])
    comboGeneIdTypeGage <- RGtk2::gtkComboBoxNewText()
    for(id in geneIDsGage) RGtk2::gtkComboBoxAppendText(comboGeneIdTypeGage, id)
    comboGeneIdTypeGage$setActive(0)  # CUAL?
    frameGeneIdTypeGage$add(comboGeneIdTypeGage)
    newGsBox$packStart(frameGeneIdTypeGage, expand=TRUE)
    newGsBox$setVisible(FALSE)
    
    # Organisms
    orgGageBox <- RGtk2::gtkHBoxNew(homogeneous=FALSE, spacing=0)
    comboOrgGage <- RGtk2::gtkComboBoxNewText()
    for (ch in names(allOrgs[["Descr"]])) RGtk2::gtkComboBoxAppendText(comboOrgGage, ch)
    comboOrgGage$setActive(allOrgs[["ID"]]["Hs"])
    comboOrgGage$"tooltip-text" <- "Available organisms"
    frameOrgGage <- RGtk2::gtkFrame("Organism")
    RGtk2::gtkFrameSetShadowType(frameOrgGage, GtkShadowType["none"])
    orgGageBox$packStart(comboOrgGage, expand = TRUE)
    # Installed automatically by buildGeneSets
    #     orgGageURL <- RGtk2::gtkLinkButtonNewWithLabel("http://www.bioconductor.org/packages/release/BiocViews.html#___OrgDb", label = "[install]", show = TRUE)
    #     orgGageBox$packStart(orgGageURL, expand = FALSE)
    frameOrgGage$add(orgGageBox)
    newGsBox$packStart(frameOrgGage, expand=TRUE)
    gageV2Box$packStart(newGsBox, expand=FALSE)
    
    # annotations
    #gageV2Box$packStart(RGtk2::gtkLabelNew("*OR*"), expand=FALSE)
    gage_annots <- c("GO Biological Process (BP)","GO Molecular Function (MF)", "GO Cellular Component (CC)", "Reactome pathways")
    names(gage_annots) <- c("GO_BP","GO_MF","GO_CC","REACTOME")
    frameAnnotsGage <- RGtk2::gtkFrame("Select annotations (if available)")
    RGtk2::gtkFrameSetShadowType(frameAnnotsGage, GtkShadowType["none"])
    annotsAreaGage <- RGtk2::gtkVBoxNew(homogeneous=FALSE, spacing=0)
    frameAnnotsGage$add(annotsAreaGage)
    checkAnnotsGage<-list()
    for(annot in gage_annots)
    {
        checkAnnotsGage[[annot]] <- RGtk2::gtkCheckButton(annot)
        checkAnnotsGage[[annot]]$active <- FALSE
        annotsAreaGage$add(checkAnnotsGage[[annot]])
    }
    gageV2Box$packStart(frameAnnotsGage, expand=FALSE)
    
    geneSetsFrame$add(gageV2Box)
    tabGage$packStart(geneSetsFrame, expand=FALSE)
    
    # sameDirection=FALSE, compareType="as.group", onlyEssentialTerms=TRUE
    optionsGageBox <- RGtk2::gtkHBoxNew(homogeneous=FALSE, spacing=0)
    frameCompareTypeGage <- RGtk2::gtkFrame("Compare type")
    RGtk2::gtkFrameSetShadowType(frameCompareTypeGage, GtkShadowType["none"])
    compareTypeTxt <- RGtk2::gtkEntryNew()
    #compareTypeTxt$setWidthChars(25)
    compareTypeTxt$setText("as.group")
    compareTypeTxt$"tooltip-text"<- "- paired: ref and samp are of equal length and one-on-one paired by the original experimental design\n- as.group: group-on-group comparison between ref and samp\n- unpaired: one-on-one comparison between all possible ref and samp combinations\n- 1ongroup: comparison between one samp column at a time VS the average of all ref columns\n(see gage help for details)"
    frameCompareTypeGage$add(compareTypeTxt)
    optionsGageBox$packStart(frameCompareTypeGage, expand=TRUE)
    
    optionsGageCheckBox <- RGtk2::gtkVBoxNew(homogeneous=FALSE, spacing=0)
    sameDirectionCheck <- RGtk2::gtkCheckButton("Same direction (all UP or all DOWN")
    sameDirectionCheck$active <- TRUE
    sameDirectionCheck$"tooltip-text" <- "Should the genes in the gene-set be all UP or all DOWN regulated? \n(if unchecked, it will search for genes altered in any direction)"
    optionsGageCheckBox$packStart(sameDirectionCheck, expand=FALSE)
    
    onlyEssentialTermsCheck <- RGtk2::gtkCheckButton("Only essential terms")
    onlyEssentialTermsCheck$active <- TRUE
    onlyEssentialTermsCheck$"tooltip-text" <- "Keep only essential terms in the clusters?"
    optionsGageCheckBox$packStart(onlyEssentialTermsCheck, expand=FALSE)
    optionsGageBox$packStart(optionsGageCheckBox, expand=TRUE)    
    
    tabGage$packStart(optionsGageBox, expand=FALSE)
    
    fields <- list(comboGeneIdTypeGage=comboGeneIdTypeGage, geneIDsGage=geneIDsGage,
                   comboOrgGage=comboOrgGage, allOrgs=allOrgs,
                   geneSetsTxt=geneSetsTxt, checkAnnotsGage=checkAnnotsGage, gage_annots=gage_annots,
                   compareTypeTxt=compareTypeTxt, sameDirectionCheck=sameDirectionCheck, onlyEssentialTermsCheck=onlyEssentialTermsCheck)
    
    # Signalconnects:
    RGtk2::gSignalConnect(gsLoadRadio, "clicked", selectLoadGs, data=list(parentWindow=mainWindow, loadGeneSetsFrame=loadGeneSetsFrame,newGsBox=newGsBox, frameAnnotsGage=frameAnnotsGage))
    RGtk2::gSignalConnect(gsNewRadio, "clicked", selectNewGs, data=list(parentWindow=mainWindow, loadGeneSetsFrame=loadGeneSetsFrame,newGsBox=newGsBox, frameAnnotsGage=frameAnnotsGage))
    
    RGtk2::gSignalConnect(geneSetsButton, "clicked", loadFileDialog, data=list(parentWindow=mainWindow, geneSetsTxt=fields$geneSetsTxt))
    
    #######################################################################
    ## tabGage ready    
    return(list(tabGage=tabGage, queryArgs=fields))
    #######################################################################
}

#ADD? jobName=NULL,  geneLabels=NULL,
FGNet_report <- function (feaResults, geneExpr=NULL, plotExpression="border", onlyGoLeaves=TRUE, plotGoTree=TRUE, filterAttribute=NULL, filterOperator=NULL, filterThreshold=NULL)
{
    #####################################################################################################
    ####################################   Check arguments   ############################################

    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    # Identify tools and extract arguments
    tool <- "Imported text file"
    queryArgs <- NULL
    jobName <- NULL
    if("queryArgs" %in% names(feaResults))
    {
        tool <- rownames(FEA_tools)[which(FEA_tools[,"Function"]==feaResults$queryArgs$fun)]
        queryArgs <- feaResults$queryArgs
        jobName <- queryArgs$jobName
    }
    
    # if(plotKeggPw)
    # {
    #     if(tool=="GeneTerm Linker")
    #     {
    #         plotKeggPw <- FALSE
    #         warning("Local plots of KEGG pathways are not available for Gene-Term Linker. Links to the website will be used instead.")
    #     }
    # }
    
    # Get info:
    if(is.null(filterAttribute)) 
    {
        filterAttribute <- FEA_tools[tool,"DefaultFilter"]
        if(is.null(filterOperator))   filterOperator <- FEA_tools[tool,"DefaultFiltOperator"]
        if(is.null(filterThreshold))  filterThreshold <- FEA_tools[tool,"DefaultFiltThreshold"]
    }
    
    if(is.null(geneExpr) && ("genesFC" %in% names(feaResults))) geneExpr <- feaResults$genesFC
    
    #####################################################################################################
    ####################################   Common to all tools   ######################################## 
    tablesGenes <- fea2incidMat(feaResults, filterAttribute=filterAttribute, filterOperator=filterOperator, filterThreshold=filterThreshold, key="Genes") 
    tablesTerms <- suppressMessages(fea2incidMat(feaResults, filterAttribute=filterAttribute, filterOperator=filterOperator, filterThreshold=filterThreshold, key="Terms"))
    
    #####################################################################################################
    ####################################   Generate  HTML    ############################################
    ###############################
    # Prepare jobName / folder
    # if(is.null(jobName)) jobName <- paste(sample(100000:999999,size=1), "_", tool,sep="")
    if(is.null(jobName) || jobName=="NULL") jobName <- getJobName(feaResults$fileName)    
    
    # Create folder
    folder <- jobName
    if((!file.exists(file.path(folder))))
    {
        dir.create(file.path(folder))        
    }
    currWD <- getwd()
    setwd(folder)
    
    tryCatch({
        htmlFileName <- paste(currWD, .Platform$file.sep, jobName, ".html", sep="") 
        createHtml(htmlFileName=htmlFileName, feaResults=feaResults, jobName=jobName, tablesGenes=tablesGenes, tablesTerms=tablesTerms,  # Data
                   tool=tool, queryArgs=queryArgs, # Query info
                   filterAttribute=filterAttribute, filterOperator=filterOperator, filterThreshold=filterThreshold, # Filter info
                   geneExpr=geneExpr, plotExpression=plotExpression, onlyGoLeaves=onlyGoLeaves, plotGoTree=plotGoTree)  # HTML options
        setwd(currWD)
    }, error = function(e) {
        setwd(currWD)
        stop(e)
    })
}

################################################################################
### Aux functions
# selectNetworkTool
selectNetworkTool <- function(aux, argsList) 
{
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    data("groupTypes", envir = environment())
    groupTypes<- get("groupTypes", envir  = environment())
    
    reportTool <- rownames(argsList$FEA_tools[which(as.numeric(argsList$FEA_tools[,"ID"])==argsList$comboFeaTool$getActive()),, drop=FALSE])
    grTypes <- tolower(FEA_tools[!is.na(argsList$FEA_tools[,"GroupType"]),"GroupType"]) # for gsub
    subGrType <- unique(grTypes[sapply(grTypes, function(x) grepl(x, argsList$thresholdFrame$label))])
    
    argsList$thresholdFrame$label <- gsub(subGrType, tolower(argsList$FEA_tools[reportTool,"GroupType"]), argsList$thresholdFrame$label)
    argsList$thresholdFrame$"tooltip-text" <- gsub(capitalize(subGrType), argsList$FEA_tools[reportTool,"GroupType"], argsList$thresholdFrame$"tooltip-text")
    
    argsList$thresholdAttributeNetworkText$setText(argsList$FEA_tools[reportTool,"DefaultFilter"])
    if(argsList$thresholdAttributeNetworkText$getText()=="NA") argsList$thresholdAttributeNetworkText$setText("")
    argsList$thresholdOperatorNetworkText$setText(argsList$FEA_tools[reportTool,"DefaultFiltOperator"])
    if(argsList$thresholdOperatorNetworkText$getText()=="NA") argsList$thresholdOperatorNetworkText$setText("")
    argsList$thresholdValueNetworkText$setText(argsList$FEA_tools[reportTool,"DefaultFiltThreshold"])
    if(argsList$thresholdValueNetworkText$getText()=="NA") argsList$thresholdValueNetworkText$setText("")
    #gtkWidgetSetSensitive(thresholdFrame, !is.na(argsList$FEA_tools[reportTool,"DefaultFilter"]))
    
    argsList$legendPrefixText$setText(groupTypes[argsList$FEA_tools[reportTool,"GroupType"], "prefix"])        
    
    if(reportTool == "GeneTerm Linker")
    {        
        argsList$gtLinkerDownloadExpander$Show()
        
        argsList$frameFEAresultsText$label <- "Job ID or file"        
        
        RGtk2::gtkWidgetSetSensitive(argsList$gtLinkerDownloadExpander, TRUE)
        # argsList$plotChecksValues[["plotKeggPw"]]$active <- FALSE
        # RGtk2::gtkWidgetSetSensitive(argsList$plotChecksValues[["plotKeggPw"]], FALSE)
        RGtk2::gtkWidgetSetSensitive(argsList$plotChecksValues[["onlyGoLeaves"]], FALSE)
        
    }else{
        argsList$frameFEAresultsText$label <- "FEA results"
        
        argsList$gtLinkerDownloadExpander$Hide()
        RGtk2::gtkWidgetSetSensitive(argsList$gtLinkerDownloadExpander, FALSE)
        # RGtk2::gtkWidgetSetSensitive(argsList$plotChecksValues[["plotKeggPw"]], TRUE)
        RGtk2::gtkWidgetSetSensitive(argsList$plotChecksValues[["onlyGoLeaves"]], TRUE)
    }    
}

#################################################################################
### Fills network tab
#################################################################################

tabNetwork_fill <- function(mainWindow, statusbar, geneList) 
{
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    ####################################################
    ####### Common
    tabNetwork <- tabNetwork_common_fill(mainWindow, geneList)

    # Create subtabs: 
    tabsNw <- RGtk2::gtkNotebookNew()
    tabsNw$setTabPos("top")
   
    ####################################################
    ####### Report tab

    tabReport <- tabReport_fill(mainWindow, statusbar, commonFields=tabNetwork$fields)
 
    ####################################################
    ####### Only network tab
    
    # clustersId  # Global for subnetwork
    tabPlotNetwork <- tabPlotNetwork_fill(mainWindow, statusbar, commonFields=tabNetwork$fields)

    
    # ####################################################
    # ####### SubNw network tab

    tabSubNetwork <- tabSubNetwork_fill()
    
    # ####################################################
    # ####### FGNet tab end
    RGtk2::gtkNotebookInsertPage(tabsNw, tabReport$tabReport, tab.label = gtkLabelNew("HTML report"))
    RGtk2::gtkNotebookInsertPage(tabsNw, tabPlotNetwork$tabPlotNetwork, tab.label = gtkLabelNew("Plot network"))
    # gtkNotebookInsertPage(tabsNw, tabSubNetwork$tabSubNetwork, tab.label = gtkLabelNew("Subnetwork [in construction]"))
    tabNetwork$fields$commonBox$add(tabsNw)
    
    # SignalConnects
    RGtk2::gSignalConnect(tabNetwork$fields$buttonSelectFeaResults, "clicked", loadFileDialog, data=list(parentWindow=mainWindow, feaResultsText=tabNetwork$fields$feaResultsText, comboFeaTool=tabNetwork$fields$comboFeaTool, expressionText=tabNetwork$fields$expressionText, alreadyDownloadedCheck=tabNetwork$fields$alreadyDownloadedCheck)) # Assigns value to feaResultsText_other
    RGtk2::gSignalConnect(tabNetwork$fields$comboFeaTool, "changed", selectNetworkTool, data=c(tabNetwork$fields, list(legendPrefixText=tabPlotNetwork$fields$legendPrefixText, plotChecksValues=tabReport$fields$plotChecksValues, FEA_tools=FEA_tools)))

    fields <- list(commonFields=tabNetwork$fields, tabReport=tabReport, tabPlotNetwork=tabPlotNetwork, tabSubNetwork=tabSubNetwork)
    #######################################################################
    #  ready
    return(c(tabNetwork=tabNetwork$tabNetwork, fields))#, queryArgs=list(comboIdType=comboIdType, annotsArea=annotsArea, emailText=emailText, frameEmail=frameEmail, argsText=argsText)))
    #######################################################################
}

# metagroupsMatrix
# plotOutput

plotFGNet_bipartite <- function(metagroupsMatrix, keepAllNodes, plotAllMg, vLayout, plotOutput, plotExpression, eWidth, eColor, vExpr,vSize, vLabelCex, vColor, colores, plotTitle, plotTitleSub, plotLegend, legendPrefix, legendText)
{
    #####################################################################################################
    #################################### Create Matrices  ###############################################    
    genesInManyMg <- setNames(1:nrow(metagroupsMatrix), rownames(metagroupsMatrix))
    if(!keepAllNodes) genesInManyMg <- which(apply(metagroupsMatrix, 1, sum)>1)
    
    mgJoinedGraph <- NULL
    mgJoined <- NULL
    if(length(genesInManyMg)<=1)
    {
        warning("There is nothing to plot. There is no intersection between metagroups/clusters.", immediate.=TRUE)
    }else
    {
        if(!plotAllMg) metagroupsMatrix <- metagroupsMatrix[names(genesInManyMg),apply(metagroupsMatrix[names(genesInManyMg),,drop=FALSE], 2, sum)>0, drop=FALSE]
        
        mgJoined <- metagroupsMatrix[names(genesInManyMg),, drop=FALSE]
                        
        # Replace 1 by mg number (for vertex color)     
        if(!any(is.na(suppressWarnings(as.numeric(colnames(mgJoined))))))
        {
            weighted <- TRUE
            for(col in 1:ncol(mgJoined))
            {
                thisCol <- which(mgJoined[,col]==1)
                mgJoined[thisCol,col] <- colnames(mgJoined)[col]
            }      
        }else
        {
            weighted <- NULL
        }
        
        if(!is.null(legendText))
        {
            colnames(mgJoined) <- paste(colnames(mgJoined), legendText, sep="\n")
        }
        
        # Create adjacency matrix (add nodes and mg to both, columns and rows)
        mgXmg <- matrix(data=0, ncol=dim(mgJoined)[2], nrow=dim(mgJoined)[2])
        rownames(mgXmg) <- colnames(mgJoined)
        
        genXgen <- matrix(data=0, ncol=dim(mgJoined)[1], nrow=dim(mgJoined)[1]+dim(mgJoined)[2])
        colnames(genXgen) <- rownames(mgJoined)
        
        mgJoined <- rbind(mgJoined, mgXmg)
        mgJoined <- cbind(genXgen, mgJoined)
        
        # Vertex colors (genes: white, mg:their color)
        vColor <- setNames(c(rep("white", length(genesInManyMg)), colores[colnames(metagroupsMatrix)]), rownames(mgJoined))
        vShape <- ifelse(vColor=="white", "circle", "square")
        if(is.null(eWidth)) eWidth <- 2

        #####################################################################################################
        ####################################   Create Graph   ###############################################
        # Create graph
        mgJoinedGraph <- graph.adjacency(mgJoined, weighted=weighted, mode="undirected", diag=FALSE)

        #####################################################################################################
        #########################################  Draw PLOTS  ##############################################
        
        if(any(plotOutput %in% c("static", "dynamic")))
        {
            ###########################
            # Vertex layout
            if(is.null(vLayout)) vLayout<-"kk"
            if(!is.matrix(vLayout)) 
            {
                if(vLayout %in% "kk")
                {
                    vertexLayout <- layout.kamada.kawai(mgJoinedGraph)
                    layoutName <- "Kamada Kawai"
                }
                if(vLayout %in% "circle")
                {
                    vertexLayout <- layout.circle(mgJoinedGraph)
                    layoutName <- "Circle"
                }
                if(vLayout %in% "sugiyama") 
                { 
                    vertexLayout <- layout.sugiyama(mgJoinedGraph)$layout
                    layoutName <- "Sugiyama"
                }
            }else # Else: Layout is already provided
            {
                vertexLayout <- vLayout
                layoutName <- "Personalized"
            }
                  
            #######################
            # Edge colors
            eColor <- colores[as.character(E(mgJoinedGraph)$weight)]
            if(is.null(weighted))
            {
                eColor <- rep(NA, length(E(mgJoinedGraph)))
                for(vertName in colnames(metagroupsMatrix))
                {
                    vertInd <- which(V(mgJoinedGraph)$name == vertName)
                    eColor[incident(mgJoinedGraph, vertInd)] <- colores[vertName]
                }
            }
                        
            vExpr <- setNames(vExpr[names(vColor)], names(vColor))
            vExpr[which(is.na(vExpr))] <- "#888888"
            # Assign color only to "intersecton" nodes
            if(plotExpression=="fill") vColor[vColor=="white"] <- vExpr[vColor=="white"]
                        
            # Add legendPrefix
            if(legendPrefix!="")
            {
                clustIndex <- which(V(mgJoinedGraph)$name %in% colnames(metagroupsMatrix))
                V(mgJoinedGraph)$name[clustIndex] <- paste(legendPrefix, V(mgJoinedGraph)$name[clustIndex], sep="") # NO subir
            }
            #######################
            # Plot
            if(plotTitleSub=="") paste("Layout: ", layoutName, sep="")
            plotFGNet(graph2plot=mgJoinedGraph, plotType="bipartite", plotOutput=plotOutput, plotExpression=plotExpression, vertexLayout=vertexLayout, eWidth=eWidth, eColor=eColor, vColor=vColor,
                  vExpr=vExpr, vSize=vSize, vLabelCex=vLabelCex, vShape=vShape, colores=colores, markGroup=NULL, trCols=NULL,
                  plotTitle=plotTitle, plotTitleSub=plotTitleSub, plotLegend=plotLegend, legendPrefix=legendPrefix, legendText=legendText)
        }

        ### Return
        ret <- list(iGraph=list(bipartite=mgJoinedGraph), adjMat=list(bipartite=mgJoined))
        return(ret)
                    
    }# length(genesInManyMg)>1
}
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

addGeneLabels <- function(tablaGeneTermSets, geneLabels)
{
    if(!is.null(geneLabels))
    {
        # Shouldnt happen...
        if(length(geneLabels) != length(unique(names(geneLabels)))) stop("geneLabels IDs are not unique.")
     
        # Reorder colums
        colGenes <- which(colnames(tablaGeneTermSets) == "Genes")
        colnames(tablaGeneTermSets)[colGenes] <- "GenesIDs"
        tablaGeneTermSets <- tablaGeneTermSets[,c(colnames(tablaGeneTermSets)[-colGenes], "GenesIDs")] 
        
        # Replace gene IDs in temp var
        tmpGenes <- sapply(as.character(tablaGeneTermSets[,"GenesIDs"]), function(clGenes){
            paste(geneLabels[strsplit(as.character(clGenes),split=",")[[1]]], collapse=",")    
        }) 
        
        # add
        tablaGeneTermSets <- cbind(tablaGeneTermSets, Genes=tmpGenes)
    }
    return(tablaGeneTermSets)
}

# graph2plot:
# graphCommonGTsets = functionalNetwork (default)
# mgJoinedGraph = intersectionNetwork (bipartite)

plotFGNet <- function(graph2plot, plotType, plotOutput, plotExpression, vertexLayout, eWidth, eColor, vColor, vExpr, vSize, vLabelCex, vShape="circle", colores, markGroup=NULL, trCols=NULL, plotTitle, plotTitleSub, plotLegend, legendPrefix, legendText)
{    
    if(length(vSize)>1)
    {
        # Default value        
        if("default" %in% names(vSize))
        {
            def <- vSize["default"]
            vSize <- vSize[-which(names(vSize)=="default")]
        }else{
            def <- mean(vSize)        
        }
        
        tmpVSize <- rep(def, length(V(graph2plot)))
        names(tmpVSize) <- V(graph2plot)$name
        
        vSize <- vSize[names(vSize)%in% names(tmpVSize)]
        tmpVSize[names(vSize)] <- vSize
        vSize <-tmpVSize
    }
    
    #####################################################################################################
    #########################################  Draw PLOTS  ##############################################
    if(plotOutput=="dynamic")
    {
        # if(is.null(plotIntersectionNetwork)) plotIntersectionNetwork <- TRUE
        if(ecount(graph2plot)>0)
        {
            vBorder <- "#888888"
            if(plotExpression == "fill") vBorder <- sub("#FFFFFF", "#888888", vColor)
            if(plotExpression == "border")
            {
                vBorder <- vExpr
            }
            
            tkplot(graph2plot, layout=vertexLayout, edge.width=eWidth, edge.color=eColor, vertex.label=V(graph2plot)$name, vertex.label.cex=vLabelCex, vertex.label.family="sans", vertex.color=vColor, vertex.size=vSize, vertex.frame.color=vBorder, vertex.label.color="black")  # vertex.label no estaba especificado para intesection network
        } else
        {
            warning("The dynamic plot is not available for networks without edges, try the 'static' plot.", immediate.=TRUE) # Tkplot error: Error in mapply(function(from, to, id) .tkplot.create.edge: zero-length inputs cannot be mixed with those of non-zero length
        }
    }
    if(plotOutput=="static")
    {        
        if(plotType=="bipartite")
        {
            add <- FALSE
            if(plotExpression == "border")
            {
                outerVsize <- vSize+3
                if(length(outerVsize)==1) 
                {
                    outerVsize <- setNames(rep(outerVsize, length(vExpr)), names(vExpr))
                }
                outerVsize[which(vExpr=="#888888")] <- 0
                
                plot(graph2plot, layout=vertexLayout, edge.width=eWidth, edge.color=eColor, vertex.color=vExpr, vertex.frame.color=vExpr, vertex.label="",  vertex.size=outerVsize, vertex.shape=vShape) 
                add <- TRUE
            }
            
        }else # "default" (FunctionalNetwork con background)
        {            
            add <- TRUE
            # Background and border
            if(plotExpression == "fill")
            {
                plot(graph2plot, layout=vertexLayout, edge.width=eWidth, edge.color=eColor, vertex.label="", mark.groups=markGroup, mark.col=trCols, mark.border=colores, vertex.size=0)
            }else
            { # Border or default/false
                if(all(vExpr=="#888888"))
                {
                    outerVsize <- 0
                }else
                {
                    outerVsize <- vSize+3
                    if(length(vSize)>1) outerVsize[which(vExpr=="#888888")] <- 0
                }               
                plot(graph2plot, layout=vertexLayout, edge.width=eWidth, edge.color=eColor, vertex.label="", mark.groups=markGroup, mark.col=trCols, mark.border=colores, vertex.color=vExpr, vertex.frame.color=vExpr, vertex.size=outerVsize)
            }
            
            # Legend
            if(plotLegend) 
            {
                if(!any(is.na(suppressWarnings(as.numeric(names(colores)))))) colorOrder <- order(as.numeric(names(colores)))
                else colorOrder <- order(names(colores))
                legend(-1.35, -1.35, legend=paste(legendPrefix, names(colores)[colorOrder], legendText, sep=""), fill=colores[colorOrder], bty="n", xjust=0, yjust=0)
            }
        }
        if(add) eWidth <-0
        plot(graph2plot, layout=vertexLayout, edge.width=eWidth, edge.color=eColor, vertex.label=V(graph2plot)$name, vertex.label.cex=vLabelCex, vertex.label.family="sans", vertex.color=vColor, vertex.size=vSize, vertex.frame.color=vExpr, vertex.shape=vShape, vertex.label.color="black", add=add)   # en intersect. no estaba vertex.label ni vertex.frame.color=vExpr,
        title(main=plotTitle, sub=plotTitleSub)    
    }
}

################################################################################
### Aux functions

#################################################################################
### Fills the Cluster (subnetwork) tab
#################################################################################


tabSubNetwork_fill <- function()
{
    tabSubNetwork <- RGtk2::gtkVBox(FALSE,3)
    
    
    fgnSubNwVBox <- RGtk2::gtkVBox(FALSE,3)
    fgnSubNwL1Box <- RGtk2::gtkHBox(FALSE,3)
    fgnSubNwL2Box <- RGtk2::gtkHBox(FALSE,3)
    
    # Select cluster
    clSelectClusterFrame <- RGtk2::gtkFrame("Select cluster")
    RGtk2::gtkFrameSetShadowType(clSelectClusterFrame, GtkShadowType["none"])
    clSelectCluster <- RGtk2::gtkHBox(FALSE,3)
    txtSelectCluster <- RGtk2::gtkEntryNew()
    txtSelectCluster$setWidthChars(5)
    comboSelectCluster <- RGtk2::gtkComboBoxNewText(show=FALSE)
    clSelectCluster$packStart(txtSelectCluster, expand=FALSE)
    clSelectCluster$packStart(comboSelectCluster, expand=FALSE)
    clSelectClusterFrame$add(clSelectCluster)
    fgnSubNwL1Box$packStart(clSelectClusterFrame, expand=FALSE)
    
    # plotOutput="static"
    clplotOutputFrame <- RGtk2::gtkFrame("Output")
    RGtk2::gtkFrameSetShadowType(clplotOutputFrame, GtkShadowType["none"])
    comboClplotOutput <- RGtk2::gtkComboBoxNewText()
#for (i in capitalize(names(plotOutputID)))RGtk2::gtkComboBoxAppendText(comboClplotOutput, i)
#comboClplotOutput$setActive(plotOutputID["static"])
    clplotOutputFrame$add(comboClplotOutput)
    fgnSubNwL1Box$packStart(clplotOutputFrame, expand=FALSE)
    
    # Checkbox
    clPlotSaveCheck<- RGtk2::gtkCheckButton("Save (.RData)")
    clPlotSaveCheck$"tooltip-text" <- "Save igraph & matrices"
    fgnSubNwL1Box$packStart(clPlotSaveCheck, expand=FALSE)
    
    fgnSubNwFrame <- RGtk2::gtkFrameNew("Plot...")
    nwVBox1 <- RGtk2::gtkVBox()
    nwButton1 <- RGtk2::gtkButton("nw1")
    nwVBox1$packEnd(nwButton1, expand=FALSE)
#gSignalConnect(nwButton1, "clicked", generateNetwork)
    
    nwVBox2 <- RGtk2::gtkVBox()
    nwButton2 <- RGtk2::gtkButton("nw2")
    nwVBox2$packEnd(nwButton2, expand=FALSE)
#gSignalConnect(nwButton2, "clicked", generateNetwork)
    
    nwVBox3 <- RGtk2::gtkVBox()
    nwButton3 <- RGtk2::gtkButton("nw3")
    nwVBox3$packEnd(nwButton3, expand=FALSE)
# gSignalConnect(nwButton3, "clicked", generateNetwork)
    
    nwVBox5 <- RGtk2::gtkVBox()
    nwButton5 <- RGtk2::gtkButton("nw5")
    nwVBox5$packEnd(nwButton5, expand=FALSE)
#    gSignalConnect(nwButton5, "clicked", generateNetwork)
    
    nwVBox6 <- RGtk2::gtkVBox()
    nwButton6 <- RGtk2::gtkButton("nw6")
    nwVBox6$packEnd(nwButton6, expand=FALSE)
#    gSignalConnect(nwButton6, "clicked", generateNetwork)
    
    nwVBox7 <- RGtk2::gtkVBox()
    nwButton7 <- RGtk2::gtkButton("nw7")
    nwVBox7$packEnd(nwButton7, expand=FALSE)
#    gSignalConnect(nwButton7, "clicked", generateNetwork)
    
    nwVBox8 <- RGtk2::gtkVBox()
    nwButton8 <- RGtk2::gtkButton("nw8")
    nwVBox8$packEnd(nwButton8, expand=FALSE)
#   gSignalConnect(nwButton8, "clicked", generateNetwork)
    
    
    fgnSubNwTable <- RGtk2::gtkTable(rows = 6, columns = 3, homogeneous = FALSE)
    fgnSubNwTable$attach(RGtk2::gtkLabel("(background)"), left.attach=1,2, top.attach=0,1)
    fgnSubNwTable$attach(RGtk2::gtkLabel("(bipartite)"), left.attach=2,3, top.attach=0,1)
    fgnSubNwTable$attach(RGtk2::gtkLabel("Gene-term sets"), left.attach=0,1, top.attach=1,2)
    fgnSubNwTable$attach(RGtk2::gtkLabel(""), left.attach=0,1, top.attach=3,4)
    fgnSubNwTable$attach(RGtk2::gtkLabel("Terms sharing genes"), left.attach=0,1, top.attach=4,5)
    fgnSubNwTable$attach(RGtk2::gtkLabel("Genes sharing terms"), left.attach=0,1, top.attach=5,6)
    
    fgnSubNwTable$attach(nwVBox1, left.attach=1,2, top.attach=1,2)
    fgnSubNwTable$attach(nwVBox2, left.attach=2,3, top.attach=1,2)
    
    fgnSubNwTable$attach(nwVBox3, left.attach=1,2, top.attach=2,3)
    
    fgnSubNwTable$attach(nwVBox5, left.attach=1,2, top.attach=4,5) 
    fgnSubNwTable$attach(nwVBox6, left.attach=2,3, top.attach=4,5) 
    
    fgnSubNwTable$attach(nwVBox7, left.attach=1,2, top.attach=5,6) 
    fgnSubNwTable$attach(nwVBox8, left.attach=2,3, top.attach=5,6) 
    
    fgnSubNwTable$setColSpacing(0, 5)
    
    fgnSubNwFrame$add(fgnSubNwTable)
    fgnSubNwVBox$packStart(fgnSubNwL1Box, expand=FALSE,10)
    fgnSubNwVBox$packStart(fgnSubNwL2Box, expand=FALSE,10)
    fgnSubNwVBox$packStart(fgnSubNwFrame, expand=FALSE,10)
    tabSubNetwork$packStart(fgnSubNwVBox, expand=FALSE,10)

    
    return(list(tabSubNetwork=tabSubNetwork))
}

# 
# # Reads content until "
# getContent <- function(reply, attribute)
# {
#     start <- gregexpr(attribute, reply)[[1]]
#     start <- start[1] + attr(start, "match.length")
#     end <- regexpr('\"', substring(reply, start, nchar(reply))) + start -2
#     
#     ret <- substr(reply, start=start, stop=end)
#     return(ret)
# }
# 
# errorMsgDavid <- function(errorMsg)
# {
#     stop(paste("Message from DAVID server: ", errorMsg$message, sep=""), call.=FALSE)
# }
# 
# # geneIdType <- "GENE_SYMBOL"
# # annotations <- c("GOTERM_BP_ALL", "GOTERM_MF_ALL", "GOTERM_CC_ALL", "KEGG_PATHWAY", "INTERPRO")
# # geneList <- c("A2M", "ABL1", "APBA1", "APBB1", "APLP1", "APLP2", "APOE", "APP", "ATOH1", "BRCA1", "BRCA2", "CDK5R1", "CDK5", "CDK5R2", "DAB1", "DLL1", "DNMT1", "EGFR", "ERBB2", "ETS1", "FOS", "FYN", "GLI1", "GLI2", "GLI3", "JAG1", "KIT", "LRP1", "LRP8", "MAPT", "MYC", "NOTCH1", "NRAS", "PAX2", "PAX3", "PSEN1", "PSEN2", "PTCH1", "RELN", "ROBO1", "SHC1", "SHH", "SMO", "SRC", "TGFB1", "TP53", "VLDLR", "WNT1", "WNT2", "WNT3")
# 
# # API: david.abcc.ncifcrf.gov/content.jsp?file=DAVID_API.html
# # Maximum gene ids: 4000
# fea_david <- function(geneList, geneIdType="ENSEMBL_GENE_ID", geneLabels=NULL, annotations=c("GOTERM_BP_ALL", "GOTERM_MF_ALL", "GOTERM_CC_ALL", "INTERPRO"), email=NULL, argsWS=c(overlap=4L, initialSeed=4L, finalSeed=4L, linkage=0.5, kappa=35L), jobName=NULL, downloadFile=TRUE)
# {    
#     # Check arguments
#     if(!is.character(geneList)) stop("geneList should be a character vector.")
#     
#     # argsWS
#     if(is.null(email))
#     {
#         argsWS <- NULL
#     }else{
#         argsNames <- c("overlap", "initialSeed", "finalSeed", "linkage", "kappa")
#         if(!is.numeric(argsWS)) stop("argsWS should contain the arguments to pass to the web service.")
#         if(any(!names(argsWS) %in% argsNames)) stop(paste("Web service arguments should be: ", paste(argsNames, collapse=", "), ".", sep=""))
#         if(any(!argsNames %in% names(argsWS)))
#         {
#             defaultArgs <- c(overlap=4L, initialSeed=4L, finalSeed=4L, linkage=0.5, kappa=35L)
#             argsNames <- c(argsWS, defaultArgs[argsNames[which(!argsNames %in% names(argsWS))]])
#         }  
#     }
# 
#     # Format arguments:
#     queryArgs <- list(queryArgsAsCharacter(match.call()))
#     
#     # Query:
#     if(!is.null(email)) # WebService
#     {        
#         if(!loadInstPkg("RDAVIDWebService")) stop("Package RDAVIDWebService is required to query DAVID through the webserver. Install the package or set email=NULL to query DAVID through the web API.")
#         
#         randomNumber <- sample(100000:999999, 1)
#         if(is.null(jobName)) jobName <- paste(randomNumber, "_DAVID", sep="")
#         downloadFileName <- paste(tempdir(), .Platform$file.sep, jobName, ".txt", sep="")
#         
#         # Connect to DAVID        
#         tryCatch( 
#         {
#             davidConnection <- RDAVIDWebService::DAVIDWebService$new(email=email, url="https://david.ncifcrf.gov/webservice/services/DAVIDWebService.DAVIDWebServiceHttpSoap12Endpoint/")
#         }, warning = function (w)
#         {
#             if(grepl("SSL", w)) w <- paste("If you are seeing this error you might need to install a certificate to connect to DAVID web service.\n See the instructions in the forum: \nhttps://support.bioconductor.org/p/70090/#72226", w, sep="\n")
#             errorMsgDavid(w)
#         })
#                 
#         # Upload gene list
#         result <- tryCatch( 
#             {
#                 RDAVIDWebService::addList(davidConnection, geneList, idType=geneIdType, listName=paste("List_", randomNumber, sep=""), listType="Gene")
#             }, error = function(e) 
#             {
#                 if(grep("idType", e$message)) 
#                 {
#                     idsFile <- "DAVID_GeneIdTypes.txt"
#                     write.table(getIdTypes(davidConnection), file=idsFile, row.names=FALSE, col.names=FALSE, quote=FALSE)
#                     
#                     #errorMsg <- simpleError(message=paste("Gene ID type not valid. Available IDs: ", paste(getIdTypes(davidConnection), collapse=", "), ".",sep=""), call=functionCall)
#                     errorMsg <- simpleError(message=paste("Gene ID type not valid. Available ID types were saved in the file ", idsFile, sep=""), call=match.call())
#                     stop(errorMsg)
#                 } else {
#                     errorMsgDavid(e)
#                 }
#             }
#             )
#         if(length(result$unmappedIds) > 0) message(paste("Unmapped IDs: ", paste(result$unmappedIds, collapse=", "), ".", sep=""))    
#         
#         # Set annotations
#         tryCatch( 
#         {
#             RDAVIDWebService::setAnnotationCategories(davidConnection, categories=annotations)                    
#         }, error = function(e) 
#         {
#             if(grep("categories", e$message)) 
#             {
#                 annotFile <- "DAVID_AnnotationCategoryNames.txt"
#                 write.table(getAllAnnotationCategoryNames(davidConnection), file=annotFile, row.names=FALSE, col.names=FALSE, quote=FALSE)
#                 
#                 errorMsg <- simpleError(message=paste("Some of the annotation categories are not valid. Available ones were saved in the file ", annotFile, sep=""))
#                 stop(errorMsg)
#             } else {
#                 errorMsgDavid(e)
#             }
#         }
#         )
#         
#         # Request & save clustering report
#         RDAVIDWebService::getClusterReportFile(davidConnection, type="Term", fileName=downloadFileName, 
#                                                  overlap=argsWS["overlap"], initialSeed=argsWS["initialSeed"], finalSeed=argsWS["finalSeed"], linkage=argsWS["linkage"], kappa=argsWS["kappa"])
#         moveFile <- TRUE
#         
#     }else
#     {
#         ## Query through web API
#         if(!loadInstPkg("RCurl")) stop("We highly recommend to provide a registered email to query DAVID through the Web Service.\nOtherwise, please install package 'RCurl' to continue.")
#         
#         if(length(geneList)>400) stop("Maximum number of genes: 400. For more genes register at DAVID Web Service (see help for details).")
#         geneList <- paste(geneList, collapse=",")
#         annotations <- paste(annotations, collapse=",")
#         
#         tool <- "term2term"
#         queryUrl <- paste("https://david.ncifcrf.gov/api.jsp?type=", geneIdType, "&ids=", geneList, "&tool=", tool, "&annot=", annotations, sep="") # Do not change order
#         
#         # URL has a charactor size limitation (<= 2048 characters in total), i.e., the very large gene list may not be able to completely passed by URL.
#         if(nchar(queryUrl)>2048) stop("Query url too long.")
#                 
#         curlHandle <- RCurl::getCurlHandle(cookiefile = "CurlHandleCookie.txt")        
#         reply <- getURL(queryUrl, curl = curlHandle, ssl.verifypeer = FALSE)
# 
#         replyRowids <- getContent(reply, attribute = 'document.apiForm.rowids.value="')
#         replyAnnot <- getContent(reply, attribute = 'document.apiForm.annot.value="')
#         
#         getURL <- paste("https://david.ncifcrf.gov/term2term.jsp?rowids=", replyRowids, "&annot=", replyAnnot, sep="")
#         if(nchar(getURL) < 2048)
#         {
#             finalReply <- getURL(getURL, curl = curlHandle, ssl.verifypeer = FALSE)
#         }else
#         {    
#             finalReply <- tryCatch({
#                 postForm("https://david.ncifcrf.gov/term2term.jsp",
#                                  curl = curlHandle,
#                                  rowids = replyRowids,
#                                  annot = replyAnnot)
#             }, error = function(e) {
#                 FALSE
#             })
#             
#             if(finalReply != FALSE) warning("Query URL too long, default annotations might be used.")  
#             if(finalReply == FALSE) stop("Query URL too long, try with less genes or use the Web Server (provide email).")  
#         }
#     
#         downloadFileName <- NULL
#         if(finalReply != FALSE)
#         {
#             downloadFileName <- getContent(finalReply, attribute = '<a href="data/download/')[1]
#         }
#         
#         if(grepl(".txt", downloadFileName))
#         {
#             downloadFileName <- paste("https://david.ncifcrf.gov/data/download/", downloadFileName, sep="")
#             moveFile <- FALSE
#         }else 
#         {
#             errorMsg <- getContent(finalReply, attribute = '<div class="error">')[1]
#             errorMsg <- substr(errorMsg, start=1, stop=regexec("</div>", errorMsg)[[1]][1]-1)
#             if(errorMsg == "Warning: Your list contains more than 3000 genes.  Please select a list with less than 3000 genes to use this tool.")
#             {
#                 stop("Too many genes for David API. Try with diferent gene ID or executing it manualy through the web and downloading the results as txt.")
#             } 
#             if(errorMsg == "")
#             {
#                 stop("Error in query to David. Please, check if you are providing the right ID type. ")
#             }
#             stop(paste("Message from David: ", errorMsg, sep=""))
#         }
#     } 
# 
#     ret <- format_david(downloadFileName, jobName=jobName, geneLabels=geneLabels, moveFile=moveFile, downloadFile=downloadFile)
#     invisible(c(queryArgs=queryArgs,ret))
# }
# 

SOAPQuery <- function(envelope_body, serverWS)
{
    # Libraries
    if(!loadInstPkg("RCurl")) stop("Package 'RCurl' is required to query GeneTerm Linker server. Install it or perform the query manually at the web and use its job ID to continue the analysis.")
    
    # Initialize variables
    rHeader  <- RCurl::basicTextGatherer()
    rContent <- RCurl::basicTextGatherer()
    
    # Build SOAP envelope
    envelope_start <-  paste('<?xml version="1.0"?>',  
                                                     '<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" ',
                                                     'xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" ',
                                                     'xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ',
                                                     'xmlns:xsd="http://www.w3.org/2001/XMLSchema" ',
                                                     'SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">',
                                                     '<SOAP-ENV:Body>', sep="")
    envelope_end <-     '</SOAP-ENV:Body></SOAP-ENV:Envelope>'
        
    # Execute query
    rContent$reset()
    rHeader$reset()
    RCurl::curlPerform(url=serverWS, writefunction = rContent$update, headerFunction=rHeader$update, verbose = FALSE,
                            httpheader=c(Accept="text/xml", Accept="multipart/*", SOAPAction='"urn:gtLinkerWS#analyze"', 'Content-Type' ="text/xml; charset=utf-8"),                
                            postfields=paste(envelope_start, envelope_body , envelope_end, sep=""))
    reply <- structure(list(header = RCurl::parseHTTPHeader(rHeader$value(NULL)), content = rContent$value()), class = "SOAPHTTPReply") # RCurl:::parseHTTPHeader

    
    #    Reply...
    if (reply$header[["status"]] =="200" )  
    {    
        reply <- xmlToDataFrame(reply$content)
    } else 
    {
        reply <- as.character(-1)
    }
    
    return(reply)
}

#filterAttribute: Sorted by metagroup/Cluster!!

fea2incidMat <- function(feaResults, key="Genes", sepChar=NULL, clusterColumn=NULL, filterAttribute=NULL, filterOperator="<", filterThreshold=0, removeFilteredGtl=NULL)
{
    # Check arguments
    grType <- "Cl"
    metagroups <- NULL
    if(is.list(feaResults) && ("metagroups" %in% names(feaResults))) grType <- "Mg"
    if(is.list(feaResults) && ("metagroups" %in% names(feaResults))) metagroups <- feaResults$metagroups   # Para david no hace falta, son lo mismo
    if(is.list(feaResults) && ("geneTermSets" %in% names(feaResults))) geneTermSets <- feaResults$geneTermSets

    if(is.data.frame(feaResults) || is.matrix(feaResults)) 
    {
        geneTermSets <- data.frame(feaResults)
    }
    
    # Fom other types of tools: Consider each gtset an individual cluster (assign each of them a color)
    if(!any(c("Cluster", "Metagroup") %in% colnames(geneTermSets)))
    {
        geneTermSets <- data.frame(cbind(Gtset=1:nrow(geneTermSets),geneTermSets))
        clusterColumn <- "Gtset"
    }
    
    if(!is.data.frame(geneTermSets)) stop("feaResults should be the formatted gene-term sets.")
    if(dim(geneTermSets)[1] == 0) stop("0 gene term sets.")
    if(!is.na(suppressWarnings(as.numeric(filterThreshold)))) filterThreshold <- as.numeric(filterThreshold)
    #if(!is.numeric(filterThreshold)) stop("filterThreshold should be a number.")
    if(!is.null(filterAttribute) && is.na(filterAttribute)) 
    {
        filterAttribute <- NULL
        filterOperator <- NULL 
        filterThreshold <- 0        
    }
    if(is.null(filterThreshold)) filterThreshold <- 0 
    if(!is.null(filterAttribute) && !is.data.frame(filterAttribute)) 
    {
        if(class(feaResults)=="list")
        {
            tmpClusterResults <- feaResults[[which(names(feaResults) %in% c("clusters","metagroups"))]]
            if(is.null(tmpClusterResults)) tmpClusterResults <- geneTermSets
        }else
        {
            tmpClusterResults <- geneTermSets
        }        
        if(is.character(filterAttribute) && (filterAttribute %in% colnames(tmpClusterResults)))
        {
            tmpFilterAttribute <- tmpClusterResults[,filterAttribute, drop=FALSE]  
            tmpFilterAttribute <- setNames(as.character(tmpFilterAttribute[,1]), rownames(tmpFilterAttribute))
            if(!any(is.na(suppressWarnings(as.numeric(tmpFilterAttribute))))) tmpFilterAttribute <- setNames(as.numeric(tmpFilterAttribute), names(tmpFilterAttribute))
            
            tmpFilterAttribute <- data.frame(tmpFilterAttribute)
            colnames(tmpFilterAttribute) <- filterAttribute
            filterAttribute <- tmpFilterAttribute
            
        } else stop("filterAttribute should be a column from the data.frame returned by one of the fea_ functions.")    
    }
    if(is.null(filterAttribute) && filterThreshold!=0) stop("To filter provide an filterAttribute.")
    key <- capitalize(tolower(key))
    
    if(is.null(clusterColumn))
    {
        clusterColumn <- "Cluster"
        if(("metagroups" %in% names(feaResults)) && ("Metagroup" %in% colnames(feaResults$geneTermSets))) clusterColumn <- "Metagroup"
    }
    
    #if(!key %in% c("Genes", "Terms")) stop("key should be either 'Genes' or 'Terms'.")
    if(is.null(removeFilteredGtl)) removeFilteredGtl <- TRUE
    if(!is.logical(removeFilteredGtl)) stop("removeFilteredGtl should be either TRUE or FALSE.")
    if(removeFilteredGtl && is.null(metagroups))  removeFilteredGtl <- FALSE
    if(removeFilteredGtl && key!="Terms") removeFilteredGtl <- FALSE
      
    # Initialize
    if(is.null(sepChar))
    {
        if(key == "Genes") sepChar <- ","
        if(key == "Terms") sepChar <- ";"
    }
    
    emptyGtSet<-nchar(as.character(geneTermSets[,key]))==0 # Any gtset does not have genes / terms?
    if(any(emptyGtSet))
    {
        warning("There are gene-term sets withouth genes.")
        geneTermSets <- geneTermSets[!emptyGtSet,]
    }    

    colsNeeded <- which(colnames(geneTermSets) %in% c("Cluster", "Metagroup", key, clusterColumn))
    geneTermSets <- as.matrix(geneTermSets[,colsNeeded, drop=FALSE]) # Group & Genes
    if(all(!is.na(suppressWarnings(as.numeric(geneTermSets[,clusterColumn]))))) geneTermSets[,clusterColumn] <- gsub(" ", "", geneTermSets[,clusterColumn])

    # Filter & sort by filterAttribute    
    filtrar <- NULL
    if(!is.null(filterAttribute))
    {  
        # Filter
        if(is.character(filterThreshold)) filterThreshold <- paste("\"",filterThreshold,"\"",sep="")

        filtrar <- rownames(filterAttribute)[eval(parse(text=paste("which(filterAttribute[,1] ", filterOperator," ", filterThreshold,")",sep=""))) ] # Space required for negative values (<-)
        if(length(filtrar)>0)
        {
            # Filter by Cluster or Gene-Term set?
            filtByCluster <- sum(filtrar %in% geneTermSets[,clusterColumn]) >= sum(filtrar %in% rownames(geneTermSets))
            if(filtByCluster)  
            {
                 geneTermSets <- geneTermSets[-which(geneTermSets[,clusterColumn] %in% filtrar),, drop=FALSE]
                  message(paste("The following metagroups/clusters have been filtered out: ", paste(filtrar, collapse=", "), sep=""))
            }else{     
                 geneTermSets <- geneTermSets[-which(rownames(geneTermSets) %in% filtrar),, drop=FALSE]
                 message(paste("The following gene-term sets have been filtered out: ", paste(filtrar, collapse=", "), sep=""))
            }
            filterAttribute <- filterAttribute[-which(rownames(filterAttribute) %in% filtrar), , drop=FALSE]
        
            if(nrow(geneTermSets)==0) stop(paste("All metagroups/clusters have ", colnames(filterAttribute), filterOperator, filterThreshold,". Try modifying the filter threshold.", sep=""))
            
            # Sort
            # filterAttribute <- filterAttribute[order(filterAttribute[,1], decreasing=TRUE), , drop=FALSE]
            
            if(filtByCluster)
            {
                sortedGeneTermSets <- NULL
                for(gr in rownames(filterAttribute)) sortedGeneTermSets <- rbind(sortedGeneTermSets, geneTermSets[ geneTermSets[,clusterColumn] %in% gr,,drop=FALSE])
                geneTermSets <- sortedGeneTermSets
            }else
            {
                geneTermSets <- geneTermSets[rownames(filterAttribute),]
            }
            # Filter MG:
            if(!is.null(metagroups)) metagroups <- metagroups[which(!rownames(metagroups) %in% filtrar),]
        }
    } else
    {
      ord <- unlist(geneTermSets[,clusterColumn])
      if(all(!is.na(suppressWarnings(as.numeric(ord))))) ord <-as.numeric(ord)
      geneTermSets <- geneTermSets[order(ord),, drop=FALSE]        
    }

    # Clear (for DAVID)
    # Remove spaces in genes
    if(key=="Genes") geneTermSets[,key] <- sapply(geneTermSets[,key], function(tmp) gsub(pattern=" ", replacement="",  x=tmp, fixed=TRUE))
    # Change ~ GO separator:
    if(key=="Terms") geneTermSets[,key] <- sapply(geneTermSets[,key], function(tmp) gsub(pattern="~", replacement=":",  x=tmp, fixed=TRUE))
    
    ################################
    # Transform into tables
    ################################
                                
    ### GeneTermSets
    # List of genes/terms in each Gene-Term Set
    gtSetsList <- as.list(as.character(geneTermSets[,key]))
    if(!is.null(sepChar)) 
    {
        gtSetsList <- lapply(gtSetsList, function(gr) { 
                unlist(strsplit(as.character(gr), sepChar, fixed=TRUE))
        })   
    }    
    if(nrow(geneTermSets)==0) stop("There are no gene-term sets.")
    
    # Columna 1: Metagrupo/Cluster al que pertenece
    names(gtSetsList) <- paste(as.character(geneTermSets[,clusterColumn]), ".", unlist(lapply(table(factor(unlist(geneTermSets[,clusterColumn])))[unique(unlist(geneTermSets[,clusterColumn]))], function(x) 1:x)), sep="")
     
    # Remove filtered terms from metagroups (only GeneTermLinker)
    if(removeFilteredGtl && key=="Terms")
    {
        nonFilteredList <- getMGTerms(metagroups, grType="Metagroup")
        nonFilteredList <- sapply(nonFilteredList, function(gr){
          paste(gr[,"TermID"], ":", gr[,"TermDescription"], sep="")
        })
        names(nonFilteredList) <- gsub("Metagroup ", "", names(nonFilteredList))
        
        newGtSetsList <- NULL
        for(mg in names(nonFilteredList))
        {
            gtsets <- grep(paste("^",mg, "[.]", sep=""), names(gtSetsList))
            gtSetsList[gtsets] <- lapply(gtSetsList[gtsets], function(gtset) gtset[tolower(gtset) %in% tolower(nonFilteredList[[mg]])])
            tmp <- unique(gtSetsList[gtsets])
            names(tmp) <- paste(mg, ".", 1:length(tmp), sep="")
            newGtSetsList <- c(newGtSetsList, tmp)
        }
        gtSetsList <- newGtSetsList
    }
    if(key=="Terms") gtSetsList <- sapply(gtSetsList, function(x) unlist(formatTerms(x)))
    
    nKeys <- length(unique(unlist(gtSetsList)))

    # Genes - GeneTermSet matrix
    nGtSets <- length(gtSetsList)
    gtSetsMatrix <- matrix(ncol=nGtSets, nrow=nKeys, data=0)
    colnames(gtSetsMatrix) <- names(gtSetsList)
    rownames(gtSetsMatrix) <- sort(unique(unlist(gtSetsList)))
    for( gts in  names(gtSetsList) )
    {
        gtSetsMatrix[eval(gtSetsList[[gts]]),gts]<-1
    }

    # Metagroups / Clusters     (Based on GeneTermSets. In gtLinker it might include filtered terms)
    mgList <- list()
    for(mg in unique(geneTermSets[,clusterColumn])) # Non-filtered mg
    {
        mgList[[mg]] <- unlist(gtSetsList[which(sapply(strsplit(names(gtSetsList),".",fixed=TRUE), function(x) x[-length(x)]) == mg)])
        if(!is.null(sepChar))
        { 
            mgList[[mg]] <- unique(unlist(lapply(mgList[[mg]], function(mg) { strsplit(as.character(mg), sepChar, fixed=TRUE)}))) 
        }else
        {
            mgList[[mg]] <- unique(unlist(mgList[[mg]])) 
        }

        if(key=="Genes") mgList[[mg]] <- gsub(pattern=" ", replacement="",  x=mgList[[mg]], fixed=TRUE)
    }
    
    nGroups <- length(mgList)
    nKeys <- length(unique(unlist(mgList)))
    metagroupsMatrix <- matrix(ncol=nGroups, nrow=nKeys, data=0)
    colnames(metagroupsMatrix) <- names(mgList)
    rownames(metagroupsMatrix) <- sort(unique(unlist(mgList)))
    for( mg in  names(mgList) )
    {
        metagroupsMatrix[eval(mgList[[mg]]),mg]<-1
    }

    ret <- list(metagroupsMatrix=metagroupsMatrix, gtSetsMatrix=gtSetsMatrix, filteredOut=filtrar)
    if(grType=="Cl") names(ret)[1] <- "clustersMatrix"
    return(ret)
}

plotGoAncestors <- function(goIds, tColor=NULL, ontology=NULL, plotOutput="static", nCharTerm=50, nSize=NULL,labelCex=NULL, asp=NULL, fileName=NULL, height=1000)
{
    #### DB
    if(!is.list(ontology))
    {
        if(!loadInstPkg("GO.db")) stop("Package GO.db is required to plot GO trees.")
        
        # ontology == NULL: only OK if all GO ids are from the same DB 
        # ontology == character: selected DB is used
        # ontology == list: for internal use
        
        selectedDB <- ontology 
        if(!is.null(selectedDB))
        {
            if(!is.character(selectedDB) || length(selectedDB)>1) stop("ontology should be either 'BP', 'MF' *or* 'CC'")
            selectedDB <- toupper(selectedDB)
            if(!selectedDB %in% c("BP","MF","CC")) stop("ontology should be 'BP', 'MF' *or* 'CC'")
        }
        
        ontology <- list()
        ontology[["BP"]] <- AnnotationDbi::as.list(GO.db::GOBPPARENTS)
        ontology[["MF"]] <- AnnotationDbi::as.list(GO.db::GOMFPARENTS)
        ontology[["CC"]] <- AnnotationDbi::as.list(GO.db::GOCCPARENTS)
        
        if(!is.null(selectedDB)) goIds <- goIds[goIds %in% names(ontology[[selectedDB]])]    
        if(is.null(selectedDB)) selectedDB <- names(which(sapply(ontology, function(x) any(goIds %in% names(x)))))
        if(length(selectedDB)!=1) stop("Provide 'ontology' or all GO IDs from the same type: BP, MF *or* CC.")
        ontology <- ontology[[selectedDB]]
    }
    
    adjList <- matrix(nrow=0, ncol=3)
    colnames(adjList) <- c("parent", "rel", "child")
    goChilds <- goIds
    
    # Find parents (calculate adjacency)
    while(any(goChilds != "all"))
    {
        goChilds <- goChilds[which(goChilds!="all")]
        
        goFamilyList <- lapply(ontology[goChilds], function(x) data.frame(parent=x, rel=names(x)))
        adjList <- rbind(adjList, as.matrix(cbind(do.call(rbind, goFamilyList), child=rep(names(goFamilyList),sapply(goFamilyList, nrow)))))
        
        # Next children
        goChilds <- unique(as.character(adjList[which(!adjList[,"parent"] %in% adjList[,"child"]),"parent"]))    
    }
    adjList <- adjList[which(adjList[,1]!="all"),, drop=FALSE]
    adjList <- adjList[,c("child","parent","rel"), drop=FALSE]

    #### Plot
    #adjList <- as.matrix(do.call(rbind.data.frame, adjList)) # unir
    goGraph <- graph.edgelist(adjList[,c("child","parent"), drop=FALSE], directed=TRUE)
    missingNodes <- rownames(goIds)[!goIds %in% unique(as.vector(adjList))]
    goGraph <- goGraph + vertex(missingNodes)
    finalLeaves <- NULL
    if(vcount(goGraph)>0)
    {
        goGraph <- set.edge.attribute(goGraph, "type", value=adjList[,"rel"])
        
        BP <- "GO:0008150" %in% V(goGraph)$name
        goTerms <- sapply(V(goGraph)$name, function(x)
        {
            term <- capitalize(GO.db::GOTERM[[x]]@Term)
            
            if (BP) # Shorten terms...
            {
                term <- gsub("( process)$", " pr.", term)
                term <- gsub(" development ", " dev. ", term)
                term <- gsub("( development)$", " dev.", term, perl=TRUE)
                term <- gsub("Development ", "Dev. ", term)
            }
            # Trim terms
            if(nchar(term)>nCharTerm) term <- paste(substr(term, 1, nCharTerm),"...", sep="")
            
            # split in two lines
            #gsub("(.*) (.*) (.*)", "\\1 \n\\2 \\3", term)
            spaceLoc <- gregexpr(" ", term, fixed=TRUE)[[1]]
            if((spaceLoc[1]!=-1) && (length(spaceLoc)>1))
            {
                spaceLoc <- spaceLoc[ceiling(length(spaceLoc)/2)]
                term <- paste(substr(term, 1, spaceLoc-1), substr(term, spaceLoc+1, nchar(term)), sep="\n")
            }

            term
        })
        names(goTerms) <- NULL
        goGraph <- set.vertex.attribute(goGraph, "term", value=goTerms) # comprobar
        
        # Node color
        goGraph <- set.vertex.attribute(goGraph, "initial", value=V(goGraph)$name%in% goIds)
        finalLeaves <- igraph::degree(goGraph,mode="in")==0
        
        if(plotOutput!="none")
        {
            vColor <- c("slategray1", "skyblue2") # Default: color for initial terms, darker if leaf.
            if(length(tColor) == 1) vColor <- rep(tColor,2) # If only one color is provided, all initial terms are coloured with it        
            # Apply to graph...
            goGraph <- set.vertex.attribute(goGraph, "color", value=c("white",vColor[1])[as.numeric(V(goGraph)$initial)+1]) # comprobar
            V(goGraph)$color[finalLeaves] <- vColor[2]
            
            if(!is.null(names(tColor))) V(goGraph)$color <- tColor[V(goGraph)$name]
        
            # Calculate node level for layout
            tmpGoGraph <- goGraph
            nodeLevels <- NULL
            while(any((leaves <- igraph::degree(tmpGoGraph,mode="in"))==0))
            {
                leaves <- leaves[leaves==0]
                nodeLevels <- c(nodeLevels, leaves)
                nodeLevels <- nodeLevels +1
                
                tmpGoGraph <- delete.vertices(tmpGoGraph, names(leaves))
            }
            
            # Layout
            #nodeLevels <- nodeLevels + sample(c(-0.1,+0.1), length(nodeLevels), replace=TRUE)
            vertexLayout <- layout.sugiyama(goGraph, layers=nodeLevels[V(goGraph)$name], hgap=5,maxiter=300, attributes="all")
            eColors <- c("darkgray","cadetblue3", "darkgoldenrod1","pink", "darkolivegreen1")
            names(eColors) <- c("is_a","part_of","regulates","positively_regulates","negatively_regulates")
            dColorsSimplif <- c("gray", "blue", "yellow","pink", "green") # Simplified name        
            if(length(unique(E(goGraph)$type[!E(goGraph)$type %in% names(eColors)]))>0) warning("missing rel")
            
            if(is.null(labelCex)) labelCex <-  ifelse(vcount(goGraph)<20, 1, 0.75)
        
            # if... plotDynamic
            if(plotOutput=="dynamic")
            {
                if(is.null(labelCex)) labelCex <- 1
                if((apply(vertexLayout$layout,2, sum)[1]==0) && TRUE)  vertexLayout$layout[1,1] <- vertexLayout$layout[1,1]+0.1
                tkplot(goGraph, layout=vertexLayout$layout, 
                             edge.color=eColors[E(goGraph)$type], edge.arrow.size=0.8,
                             vertex.color=V(goGraph)$color, vertex.frame.color=V(goGraph)$color,
                             vertex.label=V(goGraph)$term, vertex.label.color="black",  vertex.label.cex=labelCex,
                             vertex.size=15)
                print(paste("Links: ", paste(names(eColors), " (", dColorsSimplif,")", collapse=", ", sep=""), collapse=""))
            } else # Not dynamic
            {        
                if(!is.null(fileName))
                {
                    if(is.null(asp))
                    {
                        asp <- ((max(vertexLayout$layout[,2])-min(vertexLayout$layout[,2]))/max(abs(vertexLayout$layout[,1])))*3
                        asp <- min(asp, 1)
                    }
                    if(is.null(nSize)) nSize <- 15*asp
                    if(is.null(labelCex)) labelCex <-  1+(1*asp)                    
                    
                    png(fileName, height = height, width = height/asp)
                }
                if(is.null(nSize)) nSize <- ifelse(vcount(goGraph)<20, 15, 10)
                
                arrowSize <- nSize/30
                
                origvert <- c(rep(TRUE, vcount(goGraph)), rep(FALSE, nrow(rbind(vertexLayout$layout.dummy))))
                realedge <- !is.na(get.edgelist(vertexLayout$extd_graph)[,2])        
                
                
                plot(vertexLayout$extd_graph, #layout=vertexLayout$layout,
                         edge.color=eColors[E(vertexLayout$extd_graph)$type],
                         edge.arrow.mode=ifelse(realedge, 2, 0), edge.arrow.size=arrowSize,
                         vertex.shape=ifelse(origvert, "circle", "none"),
                         vertex.size=ifelse(origvert, nSize, 0),
                         vertex.color=V(vertexLayout$extd_graph)$color, vertex.frame.color=V(vertexLayout$extd_graph)$color,
                         vertex.label=ifelse(origvert, V(goGraph)$term, ""), vertex.label.color="black",  vertex.label.cex=labelCex,
                         asp=asp,margin=0)        
                
                legend(-1.2,1.2,title="Link color:",legend = levels(factor(E(goGraph)$type)), col = eColors[levels(factor(E(goGraph)$type))], lty = 1, lwd=3, bg="transparent") 
                if(!is.null(fileName)) dev.off()
            }
        }
        
        finalLeaves <- cbind(sort(sapply(V(goGraph)$name[finalLeaves], function(x) capitalize(GOTERM[[x]]@Term))))
        finalLeaves <- cbind(rownames(finalLeaves), finalLeaves)
    }
   
    
    ret <- list(iGraph=goGraph, leaves=finalLeaves)
    invisible(ret)
}

createHTML_FEA_header<- function(p, tool, queryArgs, feaResults, folder)
{
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
        
    if(tool!="Imported text file") 
    {
        hwrite(paste("Functional enrichment with ", tool, "",sep=""), p, heading=2)
    }else{
        hwrite("Functional enrichment", p, heading=2)
        hwrite("Report generated from text file with FEA results.", p, heading=2)
    }
    if(!is.null(queryArgs)) hwrite('<span id="switchQueryInfo" class="switcher switchQueryInfo"></span><span id="contentQueryInfo">', p, br=FALSE)
    
    ############################################
    ## Tool
    serverWeb <- FEA_tools[tool,"URL"]
    if(!is.na(serverWeb)) 
    {      
        hwrite("Server: ", p, class='InfoLabel', br=FALSE)
        if("serverWeb" %in% names(queryArgs)) serverWeb <- queryArgs$serverWeb
        hwrite(serverWeb, link=paste(serverWeb, '" target="_blank', sep=""),p, br=TRUE)
    }
       
    ############################################
    ## txt file
    if(tool == "GeneTerm Linker") #### GTLinker !!!!
    {
        if(!is.null(queryArgs$jobID))
        {
            hwrite("Job ID: ", p, class='InfoLabel', br=FALSE)
            hwrite(queryArgs$jobID, p, br=TRUE)
        }
        
        hwrite("Raw gene-term sets text files: ", p,  br=FALSE)
        jobName <- gsub(.Platform$file.sep, "", folder)
        nRawMg <- nrow(feaResults$metagroups)
        hwrite(paste('[Mg', 1:nRawMg,']', sep=""), p, link=paste(folder,jobName,"_metagroup_", 1:nRawMg, ".txt", sep=""), table=FALSE, br=FALSE)
        hwrite('',p, br=TRUE)
    }
    
    hwrite("<br/>Formatted results from functional enrichment and clustering: ", p,  br=FALSE)
    curWd <- getwd()
    if(!grepl(paste("\\", .Platform$file.sep, "$",sep=""), curWd, fixed=FALSE)) curWd <- paste(curWd, .Platform$file.sep, sep="")
    fileName <- gsub(curWd, "", feaResults$fileName, fixed=TRUE)    
    hwrite(fileName,link=paste(folder, fileName, sep=""), p,  br=TRUE)
    

    ############################################
    ## Arguments
    hwrite("<br/>Arguments set for the query: ", p,  br=TRUE)        
    if(!is.null(queryArgs)) 
    {
        if("organism" %in% names(queryArgs))
        {
            data("organisms", envir = environment())
            organisms<- get("organisms", envir  = environment())
            hwrite("Organism: ", p, class='InfoLabel', br=FALSE) 
            hwrite(paste(queryArgs$organism, " (",organisms[queryArgs$organism,"Name"],")",sep=""), p, br=TRUE)
        }
        if("geneList" %in% names(queryArgs)) 
        {
            genesQuery <- strsplit(eval(queryArgs$geneList),", ")[[1]]
             hwrite("Genes: ", p, class='InfoLabel', br=FALSE)
             hwrite(paste("(", length(genesQuery), ") ", sep=""), p, br=FALSE)
             hwrite(paste(sort(genesQuery), sep="", collapse=", "), p, br=TRUE)
        }
    
        # Other arguments...    
        argumentsLeft <- names(queryArgs)[!names(queryArgs) %in% c("fun", "serverWeb", "geneList","organism", "argsWS", "...")] # argsWS se muestra muy raro
    
        # NOT eval: argsWS, eset, geneSets, genesUniverse, refPackage, geneID2GO
        for(arg in argumentsLeft)
        {
            hwrite(paste(arg, ": ",sep=""), p, class='InfoLabel', br=FALSE)
            hwrite(queryArgs[[arg]], p, br=TRUE)   
        }
    
        hwrite('</span>', p, br=TRUE) # Section end (contentQueryInfo)       
    }else{
        hwrite('Not available.', p, br=TRUE)
    }
}

################################################################################
### Aux functions
# select...


#################################################################################
### Fills tabTopGo
#################################################################################
# Requiered arguments for topGO query:
# genes 
# geneIdType <- "GENENAME"
# annotations <- c("BP", "MF", "CC")
# refPackage <- NULL                        # genesUniverse <- NULL 
# orgPackage <- "org.Sc.sgd.db"             # geneID2GO <- NULL
# nodeSize <- 5                             # 1 (no prune), more stable: 5-10
# pValThr <- 0.01


    
tabTopGo_fill <- function(mainWindow, allOrgs)
{
    tabTopGo <- RGtk2::gtkVBox(FALSE,2)
    hbox1TopGO <- RGtk2::gtkHBoxNew(homogeneous=FALSE, spacing=0)
    # geneIdType 
    geneIDsTopGO <- c("ENTREZID", "ENSEMBL", "ENSEMBLPROT", "ENSEMBLTRANS", "UNIPROT", "SYMBOL") # Los ensemble en algunos org  no estan
    geneIDsTopGO <- c(geneIDsTopGO, "ALIAS", "COMMON", "TAIR") # Varios (no humano)
    frameGeneIdTypeTopGo <- RGtk2::gtkFrame("Gene ID")
    RGtk2::gtkFrameSetShadowType(frameGeneIdTypeTopGo, GtkShadowType["none"])
    comboGeneIdTypeTopGo <- RGtk2::gtkComboBoxNewText()
    for(id in geneIDsTopGO) RGtk2::gtkComboBoxAppendText(comboGeneIdTypeTopGo, id)
    comboGeneIdTypeTopGo$setActive(1)
    frameGeneIdTypeTopGo$add(comboGeneIdTypeTopGo)
    hbox1TopGO$packStart(frameGeneIdTypeTopGo, expand=TRUE)
    
    # Organism
    orgTopGoBox <- RGtk2::gtkHBoxNew(homogeneous=FALSE, spacing=0)
    comboOrgTopGo <- RGtk2::gtkComboBoxNewText()
    for (ch in names(allOrgs[["Descr"]])) RGtk2::gtkComboBoxAppendText(comboOrgTopGo, ch)
    comboOrgTopGo$setActive(allOrgs[["ID"]]["Hs"])
    comboOrgTopGo$"tooltip-text" <- "Available organisms"
    frameOrgTopGo <- RGtk2::gtkFrame("Organism")
    RGtk2::gtkFrameSetShadowType(frameOrgTopGo, GtkShadowType["none"])
    orgTopGoBox$packStart(comboOrgTopGo, expand = TRUE)
    frameOrgTopGo$add(orgTopGoBox)
    hbox1TopGO$packStart(frameOrgTopGo, expand=TRUE)
    tabTopGo$packStart(hbox1TopGO, expand=FALSE)
    
    # annotations <- c("BP", "MF", "CC")
    # Annotations
    topGO_annots <- c("GO Biological Process (BP)","GO Molecular Function (MF)", "GO Cellular Component (CC)")
    names(topGO_annots) <- c("GO_BP","GO_MF","GO_CC")
    frameAnnotsTopGo <- RGtk2::gtkFrame("Annotations")
    annotsAreaTopGo <- RGtk2::gtkVBoxNew(homogeneous=FALSE, spacing=0)
    frameAnnotsTopGo$add(annotsAreaTopGo)
    checkAnnotsTopGo<-list()
    for(annot in topGO_annots)
    {
        checkAnnotsTopGo[[annot]] <- RGtk2::gtkCheckButton(annot)
        checkAnnotsTopGo[[annot]]$active <- TRUE
        annotsAreaTopGo$add(checkAnnotsTopGo[[annot]])
    }
    tabTopGo$packStart(frameAnnotsTopGo, expand=FALSE)
    
    # Evidence
    data("GOEvidenceCodes", envir = environment())
    GOEvidenceCodes <- get("GOEvidenceCodes", envir  = environment())
    
    frameEvidenceTopGo <- RGtk2::gtkFrame("Evidence")
    frameEvidenceTopGo$setShadowType("none")
    fevidenceScroll <- RGtk2::gtkScrolledWindow()
    evidenceScroll$setPolicy("automatic", "automatic")
    evidenceScroll$setShadowType("none")
    
    evidenceViewport <- RGtk2::gtkViewportNew()
    
    subFrameEvidence <- RGtk2::gtkFrame()
    RGtk2::gtkFrameSetShadowType(subFrameEvidence, GtkShadowType["none"])
                  
    evidArea <- RGtk2::gtkVBoxNew(FALSE, 0)         
    subFrameEvidence$add(evidArea)
    # Fill...
    checkEvidenceTopGo <-list()
    for(evid in rownames(GOEvidenceCodes))
    {
        checkEvidenceTopGo[[evid]] <- RGtk2::gtkCheckButton(paste(evid, " (",GOEvidenceCodes[evid,2],")", sep=""))
        evidArea$add(checkEvidenceTopGo[[evid]])
    }
    #checkEvidenceTopGo[["TAS"]]$active <- TRUE
    
    evidenceViewport$add(subFrameEvidence)
    evidenceScroll$add(evidenceViewport)
    frameEvidenceTopGo$add(evidenceScroll)
    tabTopGo$packStart(frameEvidenceTopGo, expand=TRUE)
    
    # refPackage <- NULL  
    ## 
    refPackageFrame <- RGtk2::gtkFrame("Chip package (gene universe)")
    refPackageBox <- RGtk2::gtkHBoxNew(homogeneous=FALSE, spacing=0)
    RGtk2::gtkFrameSetShadowType(refPackageFrame, GtkShadowType["none"])
    refPackageTxt <- RGtk2::gtkEntryNew()
    refPackageTxt$setWidthChars(25)
    refPackageTxt$"tooltip-text" <- "The chip package is used to estimate all the measured genes (gene universe). If blank, the organism package will be used."
    refPackageBox$packStart(refPackageTxt, expand = TRUE)
    # Installed automatically by buildGeneSets()
    refPackageURL <- RGtk2::gtkLinkButtonNewWithLabel("http://www.bioconductor.org/packages/release/BiocViews.html#___ChipDb", label = "[install]", show = TRUE)
    refPackageBox$packStart(refPackageURL, expand = FALSE)
    refPackageFrame$add(refPackageBox)
    tabTopGo$packStart(refPackageFrame, expand = FALSE)
    
    # TopGoOptions
    topGoOptionsBox <- RGtk2::gtkHBoxNew(homogeneous=FALSE, spacing=0)
    # nodeSize <- 5    
    nodeSizeFrame <- RGtk2::gtkFrame("Minimum term size (nodeSize)")
    RGtk2::gtkFrameSetShadowType(nodeSizeFrame, GtkShadowType["none"])
    nodeSizeTxt <- RGtk2::gtkEntryNew()
    nodeSizeTxt$"tooltip-text" <- "Set to 1 not to leave out any term. TopGO authors recommend setting to 5-10 for more stable results"
    nodeSizeTxt$setText("5")
    nodeSizeFrame$add(nodeSizeTxt)
    topGoOptionsBox$packStart(nodeSizeFrame, expand=TRUE)
    
    # pValThr <- 0.01
    pValThrFrame <- RGtk2::gtkFrame("P-value threshold")
    RGtk2::gtkFrameSetShadowType(pValThrFrame, GtkShadowType["none"])
    pValThrTxt <- RGtk2::gtkEntryNew()
    pValThrTxt$"tooltip-text" <- "p-value threshold to select terms through Fisher test"
    pValThrTxt$setText("0.01")
    pValThrFrame$add(pValThrTxt)
    topGoOptionsBox$packStart(pValThrFrame, expand=TRUE)
    tabTopGo$packStart(topGoOptionsBox, expand=FALSE)

    #######################################################################
    ## tabTopGo ready    
    return(list(tabTopGo=tabTopGo, queryArgs=list(geneIDsTopGO=geneIDsTopGO, comboGeneIdTypeTopGo=comboGeneIdTypeTopGo,
                                                  comboOrgTopGo=comboOrgTopGo, allOrgs=allOrgs,
                                                  checkAnnotsTopGo=checkAnnotsTopGo, checkEvidenceTopGo=checkEvidenceTopGo, GOEvidenceCodes=GOEvidenceCodes, topGO_annots=topGO_annots, refPackageTxt=refPackageTxt, nodeSizeTxt=nodeSizeTxt, pValThrTxt=pValThrTxt)))
    #######################################################################
}

#################################################################################
### Fills the common arguments
#################################################################################

tabNetwork_common_fill <- function(mainWindow,geneList)
{
    tabNetwork <- RGtk2::gtkHBox(FALSE,3)
    
    ############################################################################
    ##### 1. Genes EXPRESSION text field
    # Expression
    table.Left <- RGtk2::gtkTable(rows=20,columns=2)
    frameExpressionFields <- RGtk2::gtkFrame("Expression (only for ploting)")
    RGtk2::gtkFrameSetShadowType(frameExpressionFields, GtkShadowType["none"])
    table.Left$attach(frameExpressionFields, left.attach = 0,2, top.attach = 0,19, xoptions =  c("expand", "fill"), yoptions = c("expand", "fill"))
    tabNetwork$packStart(table.Left, TRUE, TRUE, 10)
    
    # Scrolled area:
    expressionArea <- RGtk2::gtkScrolledWindow()
    expressionArea$setPolicy("automatic", "automatic")
    expressionArea$setShadowType("in")
    frameExpressionFields$add(expressionArea)
    
    # Text field
    expressionText <- RGtk2::gtkTextViewNewWithBuffer()
    expressionText$grabFocus()
    expressionText$"tooltip-text" <- "One gene per line, followed by its expression separated by tab or space"
    expressionText$modifyFont(pangoFontDescriptionFromString(", monospace"))
    expressionArea$add(expressionText)
    
    # Add genes from argument to field
    if(!is.null(geneList) && !is.null(names(geneList)))
    {
        genesBuffer <- RGtk2::gtkTextBufferNew()
        RGtk2::gtkTextBufferSetText(genesBuffer,paste(paste(names(geneList), geneList,sep="\t"),collapse="\n"))
        RGtk2::gtkTextViewSetBuffer(expressionText, genesBuffer)
    }
    
    # Combo
    exprPlotOptionsID <- setNames(0:1, c("border","fill"))
    exprPlotOptionsShow <- setNames(0:1, c("Border","Fill node"))
    frameExpressionPlot <- RGtk2::gtkFrame("Plot as")
    RGtk2::gtkFrameSetShadowType(frameExpressionPlot, GtkShadowType["none"])
    comboExpressionPlot <- RGtk2::gtkComboBoxNewText()
    for (i in capitalize(names(exprPlotOptionsShow))) RGtk2::gtkComboBoxAppendText(comboExpressionPlot, i)
    RGtk2::gtkComboBoxSetTitle(comboExpressionPlot, "comboExpressionPlot")
    comboExpressionPlot$setActive(exprPlotOptionsID["border"])
    comboExpressionPlot$"tooltip-text" <- "Genes with positive values are plotted RED, negative values GREEN"
    frameExpressionPlot$add(comboExpressionPlot)
    table.Left$attach(frameExpressionPlot, left.attach = 0,1, top.attach = 19,20, xoptions = "", yoptions = "")
    
    frameButtonSelectExprFile <- RGtk2::gtkFrameNew("")
    RGtk2::gtkFrameSetShadowType(frameButtonSelectExprFile, GtkShadowType["none"])
    buttonSelectExprFile <- RGtk2::gtkButton("Load from file")   #.RData containing vector or .csv???
    buttonSelectExprFile$"tooltip-text" <- "Text file with one gene per line, followed by its expression separated by TAB"
    buttonSelectExprFile$name <- "buttonSelectExprFile"
    gSignalConnect(buttonSelectExprFile, "clicked", loadFileDialog, data=list(parentWindow=mainWindow, expressionText=expressionText))
    
    frameButtonSelectExprFile$add(buttonSelectExprFile)
    table.Left$attach(frameButtonSelectExprFile, left.attach = 1,2, top.attach = 19,20, xoptions = "", yoptions = "")
        
    ############################################################################
    ##### 2. FGNet options
    
    box.Right <- RGtk2::gtkVBoxNew(FALSE, 10)
    frame.FGNetOptions <- RGtk2::gtkFrameNew("Functional Network")
    #RGtk2::gtkFrameSetShadowType(frame.FGNetOptions, GtkShadowType["none"])
    box.Right$add(frame.FGNetOptions)
    tabNetwork$add(box.Right)
    
    ##### TOP (common box)
    commonBox <- RGtk2::gtkVBoxNew(FALSE, 10)
    commonBox$setBorderWidth(10)
    
    fgnCommon1Box <- RGtk2::gtkHBox(FALSE,3)
    ### Tool
    frameFeaTool <- RGtk2::gtkFrame("FEA tool")
    RGtk2::gtkFrameSetShadowType(frameFeaTool, GtkShadowType["none"])
    frameFeaTool2 <- RGtk2::gtkFrame("")
    RGtk2::gtkFrameSetShadowType(frameFeaTool2, GtkShadowType["none"])
    comboFeaTool <- RGtk2::gtkComboBoxNewText()
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    for (i in rownames(FEA_tools)) RGtk2::gtkComboBoxAppendText(comboFeaTool, i)
    RGtk2::gtkComboBoxSetTitle(comboFeaTool, "comboFeaTool")
    comboFeaTool$setActive(FEA_tools["Imported text file","ID"])
    frameFeaTool$add(comboFeaTool)
    fgnCommon1Box$packStart(frameFeaTool, expand=FALSE)

    # Result
    frameFEAresultsText <- RGtk2::gtkFrame("FEA results")
    RGtk2::gtkFrameSetShadowType(frameFEAresultsText, GtkShadowType["none"])
    feaResultsText <- RGtk2::gtkEntryNew()
    #feaResultsText$setWidthChars(25)
    frameFEAresultsText$add(feaResultsText)
    fgnCommon1Box$packStart(frameFEAresultsText, expand=TRUE)
    
    
#gSignalConnect(feaResultsText, "changed", loadFEAresults?)
    
    # Button
    frameFEAfile <- RGtk2::gtkFrame("")
    RGtk2::gtkFrameSetShadowType(frameFEAfile, GtkShadowType["none"])
    buttonSelectFeaResults <- RGtk2::gtkButton("Select file")
    buttonSelectFeaResults$name <- "buttonSelectFeaResults"
    frameFEAfile$add(buttonSelectFeaResults)
    fgnCommon1Box$packStart(frameFEAfile, expand=FALSE)
    
    commonBox$packStart(fgnCommon1Box, expand=FALSE)
                    
    ### GeneTerm Linker:
    gtLinkerDownloadExpander <- RGtk2::gtkExpander("GeneTerm Linker download options", show=FALSE)
    gtLinkerDownloadExpander$Hide()
    gtLinkerDownloadBox <- RGtk2::gtkHBox(FALSE,3)
    
    # Server
    serverWebReportFrame <- RGtk2::gtkFrame("Server")
    RGtk2::gtkFrameSetShadowType(serverWebReportFrame, GtkShadowType["none"])
    serverWebReportText <- RGtk2::gtkEntryNew()
    serverWebReportText$setWidthChars(25)
    serverWebReportText$setText("http://gtlinker.cnb.csic.es")
    serverWebReportFrame$add(serverWebReportText)
    gtLinkerDownloadBox$packStart(serverWebReportFrame, expand=FALSE)
    # Checkbox
    alreadyDownloadedCheckFrame <- RGtk2::gtkFrame("")
    RGtk2::gtkFrameSetShadowType(alreadyDownloadedCheckFrame, GtkShadowType["none"])
    alreadyDownloadedCheck<- RGtk2::gtkCheckButton("AlreadyDownloaded")
    alreadyDownloadedCheckFrame$add(alreadyDownloadedCheck)
    gtLinkerDownloadBox$packStart(alreadyDownloadedCheckFrame, expand=FALSE)
    # Add
    gtLinkerDownloadExpander$add(gtLinkerDownloadBox)
    RGtk2::gtkWidgetSetSensitive(gtLinkerDownloadExpander, FALSE)
    gtLinkerDownloadExpander$Hide()
    commonBox$packStart(gtLinkerDownloadExpander, expand=FALSE)
    
    fgnCommon2Box <- RGtk2::gtkHBox(FALSE,3)
    
    
    ### Threshold frame
    thresholdFrame <- RGtk2::gtkFrame("Filter clusters") # MG: silhouette, CL... # OTHER:  TODO (desactivar si no es david/gtlinker?)
    thresholdFrame$"tooltip-text" <- "Clusters that meet these criteria will be REMOVED from the network"
    thresholdBoxNetwork <- RGtk2::gtkHBox(FALSE,3)
    
    thresholdAttributeNetworkFrame <- RGtk2::gtkFrame("Attribute")
    RGtk2::gtkFrameSetShadowType(thresholdAttributeNetworkFrame, GtkShadowType["none"])
    thresholdAttributeNetworkText <- RGtk2::gtkEntryNew()
    thresholdAttributeNetworkText$setWidthChars(15)
    thresholdAttributeNetworkText$setText("")
    thresholdAttributeNetworkFrame$add(thresholdAttributeNetworkText)
    thresholdBoxNetwork$packStart(thresholdAttributeNetworkFrame, expand=TRUE,10)
    
    thresholdOperatorNetworkFrame <- RGtk2::gtkFrame("Operator") 
    RGtk2::gtkFrameSetShadowType(thresholdOperatorNetworkFrame, GtkShadowType["none"])
    thresholdOperatorNetworkText <- RGtk2::gtkEntryNew()
    thresholdOperatorNetworkText$setWidthChars(5)
    thresholdOperatorNetworkText$setText("<")
    thresholdOperatorNetworkFrame$add(thresholdOperatorNetworkText)
    thresholdBoxNetwork$packStart(thresholdOperatorNetworkFrame, expand=FALSE,10)
    
    thresholdValueNetworkFrame <- RGtk2::gtkFrame("Value") 
    RGtk2::gtkFrameSetShadowType(thresholdValueNetworkFrame, GtkShadowType["none"])
    thresholdValueNetworkText <- RGtk2::gtkEntryNew()
    thresholdValueNetworkText$setWidthChars(5)
    thresholdValueNetworkText$setText("0")
    thresholdValueNetworkFrame$add(thresholdValueNetworkText)
    thresholdBoxNetwork$packStart(thresholdValueNetworkFrame, expand=FALSE,10)
    thresholdFrame$add(thresholdBoxNetwork)
    fgnCommon2Box$packStart(thresholdFrame, expand=TRUE)
    commonBox$packStart(fgnCommon2Box, expand=FALSE)

    frame.FGNetOptions$add(commonBox)

    
    # List fields:
    fields <- list(expressionText=expressionText, comboExpressionPlot=comboExpressionPlot, exprPlotOptionsID=exprPlotOptionsID, buttonSelectExprFile=buttonSelectExprFile, 
                   commonBox=commonBox,
                   comboFeaTool=comboFeaTool, frameFEAresultsText=frameFEAresultsText, feaResultsText=feaResultsText,
                   serverWebReportText=serverWebReportText,alreadyDownloadedCheck=alreadyDownloadedCheck,
                   thresholdFrame=thresholdFrame, thresholdAttributeNetworkText=thresholdAttributeNetworkText, 
                   thresholdOperatorNetworkText=thresholdOperatorNetworkText, thresholdValueNetworkText=thresholdValueNetworkText, 
                   gtLinkerDownloadExpander=gtLinkerDownloadExpander, buttonSelectFeaResults=buttonSelectFeaResults)

    return(list(tabNetwork=tabNetwork, fields=fields))
}

# txtFile <- "DavidClustering.txt"
# results <- getResults_david(txtFile)
# selCluster <- 1


### PENDIENTE:
# Gtlinker
# Top-GO... etc

plotSubNetwork <- function(results, selCluster, plotType=c("nw1","nw2","nw3","nw5","nw6","nw7","nw8"), plotOutput="dynamic", returnGraph=FALSE, geneExpr=NULL,plotExpression="border")
{
#   ret <- NULL
#   if(class(results)=="list")
#   {
#       grType <- names(results)[names(results)%in% c("clusters", "metagroups")]
#       if(grType == "clusters")
#       {
#         geneTermSets <- results$geneTermSets[results$geneTermSets$Cluster == selCluster,, drop=FALSE]
#         geneTermSets <- cbind(geneTermSets[,-1], Cluster=1:nrow(geneTermSets))
#         grType <- "Cluster"
#       }
#       if(grType == "metagroups")
#       {
#         geneTermSets <- results$geneTermSets[results$geneTermSets$Metagroup == selCluster,, drop=FALSE]
#         geneTermSets <- cbind(geneTermSets[,-1], Cluster=1:nrow(geneTermSets))
#         grType <- "Metagroup"
#       }
#   }else{
#       
#       
#       #### TEST
#       results <- cbind(Cluster=1:nrow(results),results)
#       
#       
#       
#       geneTermSets <- results[results$Cluster == selCluster,, drop=FALSE]
#       geneTermSets <- cbind(geneTermSets[,-1], Cluster=1:nrow(geneTermSets))
#       grType <- "Gene-term set"
#   }
#     
#   if(any(plotType %in% c("nw1","nw2","nw3")))
#   {
#     incidMat <- toMatrix(geneTermSets, key="genes")
#     if("nw1" %in% plotType) ret <- c(ret, functionalNetwork(incidMat, legendPrefix="gtSet ", plotTitle=paste(grType, selCluster,sep=""), plotTitleSub="Genes in gene-term sets", plotType=plotOutput, plotIntersectionNetwork=FALSE, returnGraph=returnGraph, returnAdjMatrices=returnGraph, geneExpr=geneExpr,plotExpression=plotExpression))  # Genes in GTsets
#     if("nw2" %in% plotType) ret <- c(ret, intersectionNetwork(incidMat, grPrefix="gtSet ", plotTitle=paste(grType, selCluster,sep=" "), plotTitleSub="Genes in gene-term sets", keepAllNodes = TRUE,plotType=plotOutput, returnGraph=returnGraph, geneExpr=geneExpr,plotExpression=plotExpression))
#     
#     if("nw3" %in% plotType) 
#     {
#       # DAVID - No intersection, GTLinker - YES.
#       incidMat <- toMatrix(geneTermSets, key="Terms")
#       ret <- c(ret, functionalNetwork(incidMat, legendPrefix="gtSet", plotTitle=paste(grType, selCluster,sep=" "),plotTitleSub="Terms in gene-term sets", plotIntersectionNetwork=FALSE, returnGraph=returnGraph, returnAdjMatrices=returnGraph, geneExpr=NULL)) # No intersection...  
#       # nw4? intersectionNetwork(incidMat, plotType="static", keepAllNodes=TRUE) (in david it does not work, there is only one term per gtset)
#     }
#   }
#   
#   
#   
#   ##### TO DO:  No vale para GTLINKER. Pensar
#   if(any(plotType %in% c("nw5","nw6","nw7","nw8")))
#   {    
#     rownames(geneTermSets) <- sapply(strsplit(geneTermSets$Terms, ":"), function(x) paste(capitalize(x[length(x)])," (" ,x[1], ")", sep=""))
#     # require(reshape2)
#     geneTermSetsReshaped <- melt(apply(geneTermSets[,c("Terms", "Genes")],1, function(x) unlist(strsplit(x["Genes"],","))))
#     geneTermSetsReshaped[,2] <- capitalize(sapply(strsplit(geneTermSetsReshaped[,2], ":"), function(x) x[length(x)]))
#     
#     colnames(geneTermSetsReshaped) <- c("Cluster","Terms")
#     matrices <- toMatrix(geneTermSetsReshaped, key="Terms")
#     # functionalNetwork(matrices, legendText=F, eColor="black") # Sin enlaces
#     if("nw5" %in% plotType) ret <- c(ret, functionalNetwork(matrices$clustersMatrix, legendText=FALSE ,plotTitle=paste(grType, selCluster,sep=" "), plotTitleSub="Terms sharing genes (?)", plotType=plotOutput, plotIntersectionNetwork=FALSE, returnGraph=returnGraph, returnAdjMatrices=returnGraph, geneExpr=NULL))   # TODOS con todos...
#     if("nw6" %in% plotType) ret <- c(ret, intersectionNetwork(matrices$clustersMatrix, plotTitle=paste(grType, selCluster,sep=" "), plotTitleSub="Terms - Genes", keepAllNodes=TRUE, plotType=plotOutput, returnGraph=returnGraph, geneExpr=NULL))
#     
#     
#     colnames(geneTermSetsReshaped)<- c("Genes","Cluster")
#     matrices <- toMatrix(geneTermSetsReshaped, key="Genes")
#     # functionalNetwork(matrices, legendText=F, eColor="black") # Sin enlaces
#     if("nw7" %in% plotType) ret <- c(ret, functionalNetwork(matrices$clustersMatrix, legendText=FALSE, plotTitle=paste(grType, selCluster,sep=" "), plotTitleSub="Genes sharing terms (?)", plotType=plotOutput, plotIntersectionNetwork=FALSE, returnGraph=returnGraph, returnAdjMatrices=returnGraph, geneExpr=NULL,plotExpression=plotExpression))   # TODOS con todos...
#     if("nw8" %in% plotType) ret <- c(ret, intersectionNetwork(matrices$clustersMatrix, plotTitle=paste(grType, selCluster,sep=" "), plotTitleSub="Genes - Terms", keepAllNodes=TRUE, plotType=plotOutput, returnGraph=returnGraph, geneExpr=geneExpr,plotExpression=plotExpression))
#   }
#   
#   
#   # BORRADOR DE GTLINKER:
# #   rownames(geneTermSets) <- geneTermSets$Terms
# #   mg12 <- melt(apply(geneTermSets[,c("Terms", "Genes")],1, function(x) unlist(strsplit(x["Genes"],","))))
# #   colnames(mg12)<- c("Metagroup","Terms")
# #   matrices <- toMatrix(mg12, key="Terms", clusterColumn="Metagroup")
# #   functionalNetwork(matrices$clustersMatrix, legendText=F, eColor="black", plotTitle=paste("Terms with common genes. Cl  ", cl,sep=""))#, plotType="dynamic")   # TODOS con todos...
# #   intersectionNetwork(matrices$clustersMatrix, plotTitle=paste("Terms - Genes. Cl  ", cl,sep=""), keepAllNodes=TRUE)#, plotType="dynamic")
# #   functionalNetwork(matrices, legendText=F, eColor="black") 
# #   
#   
#   
#   return(ret)
}  





# pdf("plots.pdf")
# plotSubNetwork(results, selCluster, plotOutput="static")
# dev.off()

# Used in GUI and REPORT
# if(is.null(jobName)) jobName <- getJobName(results$fileName) 

getJobName <- function(fileName)
{    
    if(is.numeric(fileName)) # jobID?
    {
        jobName <- as.character(fileName)
    }else
    {
        # Remove folder/location
        jobName <- strsplit(fileName, .Platform$file.sep, fixed=TRUE)[[1]]
        jobName <- jobName[length(jobName)]
        
        # Gtlinker
        jobName <- gsub("_formatted_metagroups.txt","", jobName)
        jobName <- gsub("_formatted_gtSets.txt","", jobName)
        jobName <- gsub("_global_overview.txt","", jobName)
        
        # Other
        jobName <- gsub("_formatted.txt","", jobName)
        jobName <- gsub(".txt","", jobName)
        jobName <- gsub("_feaResults.RData","", jobName)
        jobName <- gsub(".RData","", jobName)
        
    }
    return(jobName)
}

# ##### Arguments
# library(gage); data(gse16873)
# eset <- gse16873
# refSamples <- grep('HN',colnames(gse16873), ignore.case =T)
# compSamples <- grep('DCIS',colnames(gse16873), ignore.case =T)
# 
# geneIdType <- "ENTREZID"
# annotations <- "REACTOME" # c("GO_BP","GO_MF","GO_CC","KEGG","REACTOME")   , Set to NULL to use the geneSets as is (not named with annotation)
# organism <- "Hs" 
# # required if no geneSets are provided 
# geneSets <- NULL #entrezGS$terms2genes$REACTOME    # Named by annotation (optional, to filter)
#   library(gage)
#   C2geneSets <- readList("c2.cp.v4.0.symbols.gmt")
# geneSets <- lapply(geneSets[c(1,5)], function(x) sample(x,100)) 

# jobName <-  NULL
# 
# sameDirection <- FALSE    
# compareType <- "as.group"
# # 'as.group', group-on-group comparison between ref and samp; 
# # 'unpaired' (used to be '1on1'), one-on-one comparison between all possible ref and samp combinations, although the original experimental design may not be one-on-one paired; 
# # '1ongroup', comparison between one samp column at a time vs the average of all ref columns.
# # ... More arguments to pass to gage




##############################################
fea_gage <- function(eset, refSamples, compSamples, geneIdType, geneLabels=NULL, organism="Hs", annotations=c("GO_BP","GO_MF","GO_CC","REACTOME"), geneSets=NULL, sameDirection=FALSE, onlyEssentialTerms=TRUE, compareType="as.group", jobName=NULL, ...)
{        
    if(!loadInstPkg("gage")) stop("Package gage is not available.")
    
    queryArgs <- list(queryArgsAsCharacter(match.call()))
    
    ######################
    # Check arguments 
    exprsEset <- eset
    if(!is.matrix(eset)) exprsEset <- exprs(eset)
    if(!is.null(jobName) && !is.character(jobName)) stop("jobName should be character.")
    if(any(refSamples %in% compSamples)) stop("refSamples and compSamples should not overlap.")
    if(is.character(refSamples)) refSamples <- which(colnames(eset) %in% refSamples)
    if(is.character(compSamples)) compSamples <- which(colnames(eset) %in% compSamples)
    
    data("organisms", envir = environment())
    organisms<- get("organisms", envir  = environment())
    if(!is.character(organism)) stop("Organism should be the name of an organism db package or one of the rownames in the following table: data(organisms)")
    if(organism %in% rownames(organisms)) 
    {
        orgPackage <- organisms[organism,"orgPackage"]
    } else 
    {
        orgPackage <- organisms
    }
        
    ###############################
    # Prepare jobName / folder
    if(is.null(jobName)) jobName <- paste(sample(100000:999999,size=1), "_gage",sep="")
    folder <- jobName
    
    # Create folder
    if((!file.exists(file.path(folder))))
    {
        dir.create(file.path(folder))        
    }
    currWD <- getwd()
    setwd(folder)
    
    ######################
    # Gene Sets
    # If not provided... calculate
    if(is.null(geneSets))
    {
        if(is.null(organism) || is.null(geneIdType) || is.null(annotations)) stop("Please, provide either 'geneSets' OR the annotations, organism and geneIdType to build new gene-sets.")
        geneSets <- buildGeneSets(organismDb=orgPackage,geneIDtype=geneIdType, annotations=annotations, termLabel="TERM")$terms2genes
        fileName <- "geneSets.RData"
        save(geneSets, file=fileName) 
        message(paste("Gene-sets saved as ", fileName, sep=""))
    }
    
    # Filter the geneSets by annotation
    if(!is.null(annotations) && is.list(geneSets[[1]]))
    {
        if(any(!annotations %in% names(geneSets))) stop("The requested annotations do not match names(geneSets).")
        geneSets <- geneSets[annotations]
        
        # Unlist...
        # Paste annotation into id:
        names(geneSets)[which(names(geneSets)=="REACTOME")] <- "REACT"
        for(annot in names(geneSets)[!grepl("GO",names(geneSets))]) # Non-GO annotations
        {
            names(geneSets[[annot]]) <- paste(annot, ":",names(geneSets[[annot]]),sep="")
        }
        # Unlist
        names(geneSets) <- NULL
        geneSets <- unlist(geneSets, recursive=FALSE)
    }    

    #####################
    # GAGE
    resultGage <- gage(exprsEset, ref=refSamples, samp=compSamples, compare=compareType, gsets=geneSets, same.dir=sameDirection)#, ...)

    fileName <- paste(jobName, "_rawGageResults.RData", sep="")
    save(resultGage, file=fileName) 
    message(paste("Raw GAGE results saved as ", fileName, sep=""))
    
    # GS redundancy
    gageGrouped <- list()
    if(sameDirection)
    {
        gageGrouped[["up"]] <- esset.grp(resultGage$greater, exprsEset, gsets=geneSets, ref=refSamples, samp=compSamples, compare=compareType, same.dir=sameDirection, test4up=TRUE)#, ...)
        gageGrouped[["dw"]] <- esset.grp(resultGage$less, exprsEset, gsets=geneSets, ref=refSamples, samp=compSamples, compare=compareType, same.dir=sameDirection, test4up=FALSE)#, ...)
    }else{
        gageGrouped[["both"]] <- esset.grp(resultGage$greater, exprsEset, gsets=geneSets, ref=refSamples, samp=compSamples, compare=compareType, same.dir=sameDirection)#, ...) # test4up not needed
    }
              
    #####################################
    # Generate geneTermSets table (Convert to FGNet format)
    # sapply(gageGrouped$both, length)
    # essentialSets  setGroups    allSets connectedComponent      overlapCounts       overlapPvals       coreGeneSets 
    #            19        19          65                 19               4225               4225                 65 
    
    # Select the significant terms (gageGrouped[[1]]$allSets) from resultGage (keep the 5 columns with info)
    # [[1]] might be "up" or "both"
    geneTermSets <- NULL  # in case only down
    if(length(gageGrouped[[1]]$allSets) > 0) 
    {
        geneTermSets <- resultGage$greater[rownames(resultGage$greater)%in%gageGrouped[[1]]$allSets,1:5, drop=FALSE]
        geneTermSets <- cbind(dir=names(gageGrouped)[1], geneTermSets) # Add dir
    }
    # Add down:
    if(length(gageGrouped)>1)  # = if(sameDir) 
    {
        geneTermSets <- rbind(geneTermSets, cbind(dir="Down",resultGage$less[rownames(resultGage$less)%in%gageGrouped[["dw"]]$allSets,1:5, drop=FALSE]))
    }    
    
    # Add "Terms"  and "essentialSet" columns
    geneTermSets <- data.frame(essentialSet=rownames(geneTermSets) %in%  unlist(sapply(gageGrouped, function(x) x$essentialSets)),
                               geneTermSets, Terms=rownames(geneTermSets))
    # Add Cluster and Genes...
    tmpGenes <- setNames(rep("", nrow(geneTermSets)), rownames(geneTermSets))
    tmpCluster <- setNames(rep("", nrow(geneTermSets)), rownames(geneTermSets))
    for(updw in names(gageGrouped))
    {
        # Term - Cluster
        tmp <- unlist(mapply(rep, 1:length(gageGrouped[[updw]]$setGroups), sapply(gageGrouped[[updw]]$setGroups, length))) # equivalent to melt(gageGrouped[[updw]]$setGroups)
        tmp <- cbind(Terms=unlist(gageGrouped[[updw]]$setGroups), Cluster=tmp)
        # Add direction to cluster name
        tmp[,"Cluster"] <- paste(updw, as.numeric(tmp[,"Cluster"]), sep="_")
    
        # Add genes
        tmp <- cbind(tmp, Genes=sapply(as.character(tmp[,"Terms"]), function(x)
        {
            genesGtset <- gageGrouped[[updw]]$coreGeneSets[[x]]  ### Genes en lista original??
            paste(as.character(genesGtset), collapse=",")
        }))
        rownames(tmp) <- NULL
        
        tmpCluster[as.character(tmp[,"Terms"])] <- tmp[,"Cluster"]
        tmpGenes[as.character(tmp[,"Terms"])] <- tmp[,"Genes"]
    }
    geneTermSets <- data.frame(Cluster=tmpCluster, geneTermSets, Genes=tmpGenes)
    rownames(geneTermSets) <- NULL
    
    # Sort by cluster
    geneTermSets <- geneTermSets[order(as.numeric(do.call(rbind,strsplit(as.character(geneTermSets$Cluster),"_"))[,2])),,drop=FALSE]
    
    # Replace Gene ID?
    geneTermSets <- addGeneLabels(geneTermSets, geneLabels)
    
    # Write file
    fileName <- paste(jobName, ".txt", sep="")
    write.table(geneTermSets, file=fileName, quote=FALSE, row.names=FALSE, sep="\t")
    message(paste("Gene-term sets table saved as ", fileName, sep=""))
    
    #####################################
    # Calculate gene's FC (for plotting)
    genesFC <- log2(apply(exprsEset[,compSamples],1, mean)/apply(exprsEset[,refSamples],1, mean))
    if(!is.null(geneLabels))
    {
        subNames <- which(names(genesFC) %in% names(geneLabels))
        names(genesFC)[subNames] <- geneLabels[names(genesFC)[subNames]]
    }

    #####################################
    # Load results formatted (cluster table... etc)
    ret <- readGeneTermSets(fileName, tool="gage", simplifyGage=onlyEssentialTerms)
    setwd(currWD)
    invisible(c(queryArgs=queryArgs, ret, genesFC=list(genesFC)))
}






# 
# ###################### EXAMPLE
# matr <- toMatrix(geneTermSets)
# matr <- toMatrix(tablaClusters)
# functionalNetwork(matr)
# #matr <- toMatrix(geneTermSets[grepl("up",geneTermSets$Cluster),])
# 
# #####################
# # Expression
# exprsGenes <- apply(exprsEset[,compSamples],1, mean) - apply(exprsEset[,refSamples],1, mean)
# exprsGenes <- log2(apply(exprsEset[,compSamples],1, mean)/apply(exprsEset[,refSamples],1, mean))
# exprsGenes_Subset <- exprsGenes[rownames(matr$clustersMatrix)]
# 
# # Translate geneID 
# gsym <- AnnotationDbi::select(org.Hs.eg.db, keys=rownames(matr[[2]]), columns="SYMBOL",keytype=geneIdType)
# gsymTable <-table(gsym[,"SYMBOL"])
# for(y in names(gsymTable[gsymTable>1]))
# {
#     tmp <- which(gsym[,"SYMBOL"]==y)
#     gsym[tmp,"SYMBOL"] <- paste(y, 1:length(tmp), sep=".")
# }
# # matr
# matr[1:2] <- lapply(matr[1:2], function(x) 
# {  
#     rownames(x) <-  sapply(rownames(x), function(y) gsym[gsym[,geneIdType]==y, "SYMBOL"][1])
#     x
# })
# # expr
# names(exprsGenes_Subset) <- sapply(names(exprsGenes_Subset), function(y) gsym[gsym[,geneIdType]==y, "SYMBOL"][1])
# 
# functionalNetwork(matr,geneExpr=exprsGenes_Subset,legendText=F)

# 
# ################################################################################
# ### Aux functions
# # selectAPI
# # selectWs
# # selectWs_fillFields
# 
# selectAPI <- function(aux, argsList)
# {
#     RGtk2::gtkWidgetSetSensitive(argsList$frameEmail, FALSE)
#     RGtk2::gtkWidgetSetSensitive(argsList$argsText, FALSE)
# 
#     ## Fill fields
#     argsList$comboIdType$getModel()$clear()
#     # argsList$davidVars$DAV_GeneIds <- c("GENE_SYMBOL", "ENTREZ_GENE_ID", "ENSEMBL_GENE_ID", "ENSEMBL_TRANSCRIPT_ID", "AFFYMETRIX_3PRIME_IVT_ID", "AFFYMETRIX_EXON_GENE_ID", "AFFYMETRIX_SNP_ID", "AGILENT_CHIP_ID", "AGILENT_ID", "AGILENT_OLIGO_ID", "FLYBASE_GENE_ID", "FLYBASE_TRANSCRIPT_ID", "GENBANK_ACCESSION", "GENPEPT_ACCESSION", "GENOMIC_GI_ACCESSION", "PROTEIN_GI_ACCESSION", "ILLUMINA_ID", "IPI_ID", "MGI_ID", "PFAM_ID", "PIR_ACCESSION", "PIR_ID", "PIR_NREF_ID", "REFSEQ_GENOMIC", "REFSEQ_MRNA", "REFSEQ_PROTEIN", "REFSEQ_RNA", "RGD_ID", "SGD_ID", "TAIR_ID", "UCSC_GENE_ID", "UNIGENE", "UNIPROT_ACCESSION", "UNIPROT_ID", "UNIREF100_ID", "WORMBASE_GENE_ID", "WORMPEP_ID", "ZFIN_ID")
#     # for (id in argsList$davidVars$DAV_GeneIds) RGtk2::gtkComboBoxAppendText(argsList$comboIdType, id) 
#     # argsList$comboIdType$setActive(which(argsList$davidVars$DAV_GeneIds==argsList$davidVars$dav_DefaultId)-1)
# 
#     # Annotations
#     for(ch in argsList$annotsArea$getChildren()) argsList$annotsArea$remove(ch) # Vaciar
#     # DAV_Annots <- c("BBID", "BIND", "BIOCARTA", "CHROMOSOME", "COG_ONTOLOGY", "GOTERM_BP_ALL", "GOTERM_CC_ALL", "GOTERM_MF_ALL", "INTERPRO", "OMIM_DISEASE", "PIR_SUPERFAMILY", "SMART", "SP_PIR_KEYWORDS", "UP_SEQ_FEATURE")
#     # checkAnnotsDavid <- list()
#     # for(annot in DAV_Annots)
#     # {
#     #   checkAnnotsDavid[[annot]] <- RGtk2::gtkCheckButton(annot)
#     #   if(annot %in% argsList$davidVars$dav_DefaultAnnots) checkAnnotsDavid[[annot]]$active <- TRUE
#     #   argsList$annotsArea$add(checkAnnotsDavid[[annot]])
#     # }
#     
#     # Activate area
#     RGtk2::gtkWidgetSetSensitive(argsList$optionBoxV, TRUE) 
# }
# 
# # argsList= parentWindow, frameEmail, argsText, optionBoxV,  emailText, comboIdType, annotsArea
# selectWs <- function(aux, argsList)
# {
#     RGtk2::gtkWidgetSetSensitive(argsList$frameEmail, TRUE)
#     RGtk2::gtkWidgetSetSensitive(argsList$argsText, TRUE)
# 
#     if(is.null(argsList$davidVars$dav_wsGeneIds))
#     {
#         RGtk2::gtkWidgetSetSensitive(argsList$optionBoxV, FALSE) # Fill when connect
#     } else{
#         argsList$reconnect <- FALSE
#         selectWs_fillFields(NULL, argsList)
#     }
# }
# 
# # argsList= parentWindow, emailText, comboIdType, annotsArea, optionBoxV
# selectWs_fillFields <- function(aux, argsList)
# {
#     msgTxt <- NULL
#     if(argsList$emailText$getText()=="" && argsList$reconnect)
#     {
#         msgTxt <- "DAVID Web Service requires email registration to connect."
#     }else 
#     {
#         if(is.null(argsList$davidVars$dav_wsGeneIds) || argsList$reconnect)
#         {
#             tryCatch( 
#             {
#                 if(!loadInstPkg("RDAVIDWebService", parentWindow=argsList$parentWindow)) stop("Package RDAVIDWebService is required to query DAVID through the webserver. Install the package or query DAVID through the web API.")
# 
#                 davidWsConnection <- RDAVIDWebService::DAVIDWebService$new(email=argsList$emailText$getText())
#                 argsList$davidVars$dav_wsGeneIds <- RDAVIDWebService::getIdTypes(davidWsConnection)    
#                 argsList$davidVars$dav_wsAnnots <- RDAVIDWebService::getAllAnnotationCategoryNames(davidWsConnection)
#             }, error = function(e) 
#             {
#                 msgTxt <<- paste(e, "Make sure the email is registered.", sep="\n")
#             })
#         }
#         argsList$davidVars$DAV_GeneIds <- argsList$davidVars$dav_wsGeneIds
#         DAV_Annots <- argsList$davidVars$dav_wsAnnots
#         
#         ## Fill fields
#         argsList$comboIdType$getModel()$clear()
#         for (id in argsList$davidVars$DAV_GeneIds) RGtk2::gtkComboBoxAppendText(argsList$comboIdType, id) 
#         argsList$comboIdType$setActive(which(argsList$davidVars$DAV_GeneIds==argsList$davidVars$dav_DefaultId)-1)
#         
#         # Annotations
#         for(ch in argsList$annotsArea$getChildren()) argsList$annotsArea$remove(ch) # Vaciar
#         checkAnnotsDavid <- list()
#         for(annot in DAV_Annots)
#         {
#             checkAnnotsDavid[[annot]] <- RGtk2::gtkCheckButton(annot)
#             if(annot %in% argsList$davidVars$dav_DefaultAnnots) checkAnnotsDavid[[annot]]$active <- TRUE
#             argsList$annotsArea$add(checkAnnotsDavid[[annot]])
#         }  
#         RGtk2::gtkWidgetSetSensitive(argsList$optionBoxV, TRUE) 
#         RGtk2::gtkWidgetSetSensitive(argsList$argsText, TRUE)
#     }
#     
#     if(!is.null(msgTxt))
#     {
#         dialog <- RGtk2::gtkDialogNewWithButtons("Email required", argsList$parentWindow,
#                                           c("modal", "destroy-with-parent"), 
#                                           "RGtk2::gtk-ok", RGtk2::GtkResponseType["accept"],
#                                           show=TRUE)
#         dialog[["vbox"]]$add(RGtk2::gtkLabel(msgTxt))
#         response <- dialog$run() 
#         dialog$destroy()
#     }    
# }
# 
# #################################################################################
# ### Fills tabDavid
# #################################################################################
# # Parameters required for david query:
# # genes=NULL
# # geneIdType="ENSEMBL_GENE_ID"
# # annotations=c("GOTERM_BP_ALL", "GOTERM_MF_ALL", "GOTERM_CC_ALL","INTERPRO")
# # email=NULL
# # argsWS = c(overlap=4L, initialSeed=4L, finalSeed=4L, linkage=0.5, kappa=35L), 
#   
# tabDavid_fill <- function(mainWindow, davidVars)
# {
#     tabDavid <- RGtk2::gtkVBox(FALSE,3)
#     
#     #### radioFrame Interface selection + email
#     # Radio button
#     radioFrame <- RGtk2::gtkFrame("DAVID interface")
#     radioBoxV <- RGtk2::gtkVBox(FALSE,3)
#     radioBoxH <- RGtk2::gtkHBox(FALSE,3)
#     wsRadio <- RGtk2::gtkRadioButtonNewWithLabelFromWidget(RGtk2::gtkRadioButton(), "WebService")
#     wsRadio$"tooltip-text" <- "Query DAVID using the Web Service (Recommended). Requires registration."
#     apiRadio <- RGtk2::gtkRadioButtonNewWithLabelFromWidget(wsRadio, "API")
#     apiRadio$"tooltip-text" <- "Query DAVID using the web API. More limited than the Web Service."
#     wsRadio$active<-TRUE
#     # gSignalConnect at end
#     
#     radioBoxH$packStart(wsRadio, FALSE, FALSE, 2)
#     url <- RGtk2::gtkLinkButtonNewWithLabel("http://david.abcc.ncifcrf.gov/webservice/register.htm", label = "[register]", show = TRUE)
#     radioBoxH$packStart(url, FALSE, FALSE, 0)
#     radioBoxH$packStart(apiRadio, FALSE, FALSE, 2)
#     
#     radioBoxV$packStart(radioBoxH, expand = FALSE)
#     radioFrame$add(radioBoxV)
#     
#     # Email # Only for WEB SERVICE
#     frameEmail <- RGtk2::gtkFrame("Email")
#     RGtk2::gtkFrameSetShadowType(frameEmail, GtkShadowType["none"])
#     RGtk2::gtkWidgetSetSensitive(frameEmail, TRUE)
#     emailBox <- RGtk2::gtkHBox(FALSE,3)
#     
#     # Text field
#     emailText <- RGtk2::gtkEntryNew()
#     emailText$setWidthChars(25)
#     emailText$setText("")
#     emailText$"tooltip-text" <- "Insert your registered email to connect to DAVID Web Service."
#     emailBox$packStart(emailText, expand = FALSE)
#     
#     # Connect button
#     wsConnectButton <- RGtk2::gtkButton("Connect")
#     emailBox$packStart(wsConnectButton,  expand = FALSE, FALSE, 10) 
#     
#     frameEmail$add(emailBox)
#     radioBoxV$add(frameEmail)
#     
#     tabDavid$packStart(radioFrame, expand = FALSE, TRUE, 2)
#     
#     #### other options
#     optionBoxV <- RGtk2::gtkVBox(FALSE,3)
#     RGtk2::gtkWidgetSetSensitive(optionBoxV, FALSE)
#     
#     # geneIdType
#     comboIdType <- RGtk2::gtkComboBoxNewText()
#     # fill...
#     frameIdType <- RGtk2::gtkFrame("Gene ID")
#     RGtk2::gtkFrameSetShadowType(frameIdType, GtkShadowType["none"])
#     frameIdType$add(comboIdType)
#     optionBoxV$packStart(frameIdType, expand = FALSE) # tabDavid$add(frameIdType)
#     
#     
#     # Annotations
#     frameAnnots <- RGtk2::gtkFrame("Annotations")
#     RGtk2::gtkFrameSetShadowType(frameAnnots, GtkShadowType["none"])
#     optionBoxV$packStart(frameAnnots, expand = FALSE) #tabDavid$add(frameAnnots)
#     
#     davAnotsArea <- RGtk2::gtkScrolledWindow()
#     davAnotsArea$setPolicy("automatic", "automatic")
#     davAnotsArea$setShadowType("none")
#     optionBoxV$packStart(davAnotsArea, expand = TRUE) #tabDavid$add(davAnotsArea)
#     
#     frameAnnotsList <- RGtk2::gtkFrame()
#     RGtk2::gtkFrameSetShadowType(frameAnnotsList, GtkShadowType["none"])
#     annotsArea <- RGtk2::gtkVBoxNew(FALSE, 0)         
#     frameAnnotsList$add(annotsArea)
#     # Fill...
#     scrollAnnots <- RGtk2::gtkViewportNew()
#     scrollAnnots$add(frameAnnotsList)
#     davAnotsArea$add(scrollAnnots)
#     
#     # Clustering args # Only for WEB SERVICE
#     frameArgs <- RGtk2::gtkFrame("Clustering arguments")
#     RGtk2::gtkFrameSetShadowType(frameArgs, GtkShadowType["none"])
#     argsText <- RGtk2::gtkEntryNew()
#     argsText$setWidthChars(25)
#     argsText$setText("overlap=4L, initialSeed=4L, finalSeed=4L, linkage=0.5, kappa=35L")
#     RGtk2::gtkWidgetSetSensitive(argsText, FALSE)
#     frameArgs$add(argsText)
#     optionBoxV$packStart(frameArgs, expand = FALSE) #tabDavid$add(frameArgs)
#     
# 
#     # Signalconnects:
#     RGtk2::gSignalConnect(apiRadio, "clicked", selectAPI, data=list(parentWindow=mainWindow, davidVars=davidVars, frameEmail=frameEmail, argsText=argsText, comboIdType=comboIdType, annotsArea=annotsArea, optionBoxV=optionBoxV))
#     RGtk2::gSignalConnect(wsRadio, "clicked", selectWs, data=list(parentWindow=mainWindow, davidVars=davidVars, frameEmail=frameEmail, argsText=argsText, optionBoxV=optionBoxV,  emailText=emailText, comboIdType=comboIdType, annotsArea=annotsArea))
#     RGtk2::gSignalConnect(wsConnectButton, "clicked", selectWs_fillFields, data=list(parentWindow=mainWindow, davidVars=davidVars, reconnect=TRUE, emailText=emailText, comboIdType=comboIdType, annotsArea=annotsArea, argsText=argsText, optionBoxV=optionBoxV))
#     
#     tabDavid$add(optionBoxV)
#     #######################################################################
#     ## tabDavid ready    
#     return(list(tabDavid=tabDavid, queryArgs=list(davidVars=davidVars, comboIdType=comboIdType, annotsArea=annotsArea, emailText=emailText, frameEmail=frameEmail, argsText=argsText)))
#     #######################################################################
# }

# functCall <- feaResults$call[[1]]

queryArgsAsCharacter <- function(functCall)
{       
    # As list:
    queryArgs <- formals(eval(as.name(functCall[[1]]))) # Default arguments
    queryArgs <- sapply(names(queryArgs),function(x) # Given arguments (raw value, can be a variable name or not)
    {
        tmp <- functCall[[x]]
        if(!is.null(tmp))
        {
            return(tmp)
        }else{
            return(queryArgs[[x]]) # NULL
        }
    })
    queryArgs <- as.list(c(fun=as.character(as.name(functCall[[1]])), queryArgs))
    
    # Eval/format as string:    
    if(("organism" %in% names(queryArgs)) && is.name(queryArgs$organism))
    {
        # Eval and capitalize
        queryArgs$organism <- eval(queryArgs$organism, envir=parent.frame())
        if(!is.null(queryArgs$organism)) queryArgs$organism <- capitalize(tolower(queryArgs$organism))
    }
    if(("geneList" %in% names(queryArgs)) && is.name(queryArgs$geneList))
    {
        # Eval and collapse
        queryArgs$geneList <- paste(eval(queryArgs$geneList, envir=parent.frame()), sep="", collapse=", ")
    }
    if(("argsWS" %in% names(queryArgs)))
    {
        # Eval
        if(is.name(queryArgs$argsWS)) queryArgs$argsWS <- eval(queryArgs$argsWS, envir=parent.frame())
            
        # Collapse (format)
        if(!is.null(names(queryArgs$argsWS)))
        {
            queryArgs$argsWS <- paste(names(queryArgs$argsWS), queryArgs$argsWS, sep="=", collapse=", ")
        }else{
            queryArgs$argsWS <- paste(queryArgs$argsWS, collapse=", ")
        }
    }

    # Other arguments...    
    argumentsLeft <- names(queryArgs)[!names(queryArgs) %in% c("fun","geneList","organism", "argsWS", "...")] 
    argsEval <- c("serverWeb", "geneIdType", "annotations", "email", "jobName", "alreadyDownloaded", "jobID", "refSamples", "compSamples", "sameDirection", "compareType", "nodeSize", "pValThr", "testStat")
            # NOT eval: argsWS, eset, geneSets, genesUniverse, refPackage, geneID2GO
    
    for(arg in argumentsLeft)
    {
        if((is.name(queryArgs[[arg]])) && (arg %in% argsEval)) queryArgs[[arg]] <- eval(queryArgs[[arg]], envir=parent.frame())     
        if(is.null(queryArgs[[arg]])) queryArgs[[arg]] <- "NULL"
        
        queryArgs[[arg]] <- paste(queryArgs[[arg]], sep="", collapse=", ")
    }
    
    return(queryArgs)
}

# incidMatrices <- fea2incidMat(res_topGo)
analyzeNetwork <- function(incidMatrices, fNw=NULL, plotOutput=TRUE, colors=NULL)
{
    if(is.null(fNw)) fNw <-functionalNetwork(incidMatrices, plotOutput="none")
     
    clNw <- graph.adjacency(fNw$adjMat$commonClusters, weighted=TRUE, mode="undirected", diag=FALSE)  # weigted: only one edge between genes (returned is NOT weighted)
    gtsNw <- fNw$iGraph$commonGtSets
    
    data("groupTypes", envir = environment())
    groupTypes<- get("groupTypes", envir  = environment())
    clMatrix <- incidMatrices[[which(names(incidMatrices)%in%groupTypes[,"tablesName"])]]
    
    #########################################
    # Global betweenness:
    glBetw <- round(sort(betweenness(clNw), decreasing=TRUE))
    # Global degree
    glDegr <- round(sort((igraph::degree(clNw)/(length(V(clNw))-1)*100), decreasing=TRUE),digits=2)
    # Equivalent to boxplot: cbind(degree=round(summary(glDegr))[-4], betweenness=round(summary(glBetw))[-4])
    
    
    ## Cluster betweenness (intra-modular hub)
    genesMg <- apply(clMatrix,2, function(x) names(x)[which(x==1)])
    clSubgraphs <- list()
    clBetw <- list(Global=glBetw)
    clDegr <- list(Global=glDegr)
    for(cl in names(genesMg))
    {
        clSubgraphs[[cl]] <- induced.subgraph(gtsNw, which(V(gtsNw)$name %in% genesMg[[cl]]))
        clBetw[[cl]] <- round(sort(betweenness(clSubgraphs[[cl]]), decreasing=TRUE))
        clDegr[[cl]] <- round(sort(igraph::degree(clSubgraphs[[cl]]), decreasing=TRUE)/(length(V(clSubgraphs[[cl]]))-1),digits=2)*100
    }    
    
    #########################################
    ## Plot
    if(plotOutput)
    {
        if(is.null(colors)) colors <- rep("white", length(clDegr))
        par(mfrow=c(1,2))
        boxplot(clDegr, main="Normalized node degree", sub="Global / intra-cluster", outpch=16,outcol=c("black", colors), outlwd=1, boxfill=c("black", colors), medcol=c("black", colors), medlwd = 10, lwd = 1, ylim=c(0,100), ylab="Percentage of total nodes", axes=FALSE)
        box()
        axis(side=1, labels=names(clDegr), at=1:length(clDegr), las=2)
        axis(side=2, las=1)
        
        boxplot(c(0,clBetw[-1]), main="Node betweenness", sub="Global / intra-cluster", outpch=16, outcol=c("white", colors),outlwd=1, boxfill=c("white", colors), medcol=c("white", colors), medlwd = 10, lwd = 1, axes=FALSE)
        maxBetwGlobal <- max(clBetw$Global)
        if(maxBetwGlobal>0) 
        {
            transf <- max(unlist(clBetw[-1])/maxBetwGlobal)
            betwGlobal <- clBetw$Global*transf
        }else
        {
            betwGlobal <- 0
        }
        boxplot(betwGlobal, add=TRUE, outpch=16, outcol="black", outlwd=1, boxfill="black", medcol="black", medlwd = 10, lwd = 1, axes=FALSE)
        box()
        abline(v=1.5)
        axis(side=1, labels=names(clDegr), at=1:length(clDegr), las=2)
        axis(side=4, las=1)
        axis(side=2, las=1, labels=c(0, max(clBetw$Global)), at=c(0, max(unlist(clBetw[-1])))) # Global side
    }
    
    #########################################
    ## Stats
    ret <- list()
    
    # Node degree and betweenness:
    ret[["degree"]] <- clDegr
    ret[["betweenness"]] <- clBetw
    
    # Clustering coeficient. Transitivity measures the probability that the adjacent vertices of a vertex are connected.
    ret[["transitivity"]] <- c(commonClustersNw=transitivity(clNw, type="undirected"), commonGtSetsNw=transitivity(gtsNw, type="undirected"))
    
    # Hubs
    clBetw <- sapply(clBetw, function(x) x[x!=0]) # Remove genes with betw==0
    clBetw <- clBetw[sapply(clBetw[names(clBetw)!="Global"], length)>0] # Remove clusters without genes with betw>0 (except Global)
    
    hubs <- unique(unlist(sapply(clBetw, names))) # Gene names
    hubs <- matrix(0, nrow=length(hubs), ncol=length(clBetw), dimnames=list(hubs, names(clBetw)))
    for(cl in names(clBetw))
    {
        hubs[,cl] <- clBetw[[cl]][rownames(hubs)]
    }
    hubs[which(is.na(hubs))] <- 0
    ret[["betweennessMatrix"]] <- hubs
    
    hubsList <- lapply(clBetw, function(x){
       names(x[x>=quantile(x,probs=0.75)])
    })
    ret[["hubsList"]] <- hubsList
    
    # Intra-modular hubs count
    intraModularHubs <- hubsList[names(hubsList)!="Global"]
    tmpHubsTable <- table(unlist(intraModularHubs))
    tmpHubsTable <- sort(tmpHubsTable[tmpHubsTable>1], decreasing=TRUE)
    ret[["intraHubsCount"]] <- tmpHubsTable
    
    invisible(ret)    
}



# 
# #########################################
# ### Centralization:
# centralization.degree (clNw, mode ="total")
# # $centralization
# # [1] 0.599435
# # 
# # $theoretical_max
# # [1] 3540
# 
# centralization.closeness (clNw, mode ="total")
# # $centralization
# # [1] 0.4355989
# # 
# # $theoretical_max
# # [1] 29.24786
# 
# centralization.betweenness (clNw, directed = FALSE)
# # $centralization
# # [1] 0.08470773
# # 
# # $theoretical_max
# # [1] 100949
# 
# centralization.evcent (clNw, directed = FALSE)
# # $centralization
# # [1] 0.6417392
# # 
# # $theoretical_max
# # [1] 58

################################################################################
### Aux functions
# selectNetworkType
# generateNetwork

# argsList= comboFunNwIntNw, funNwIntNwID, plotTitleText, weightedCheck, keepAllNodesCheck, comboPlotOutput,plotOutputID
selectNetworkType <- function(aux, argsList)
{
  selNwTypeID<- which(argsList$funNwIntNwID==argsList$comboFunNwIntNw$getActive())
  selNwTypeTxt <- names(argsList$funNwIntNwText)[selNwTypeID]
  
  if(names(selNwTypeID) %in% c("default","bipartite"))
  {
    argsList$plotTitleText$setText(selNwTypeTxt)
    RGtk2::gtkWidgetSetSensitive(argsList$plotTitleText, TRUE)
    RGtk2::gtkWidgetSetSensitive(argsList$comboPlotOutput, TRUE)
    
    if(names(selNwTypeID) == "default")
    {
      RGtk2::gtkWidgetSetSensitive(argsList$weightedCheck, TRUE)
      RGtk2::gtkWidgetSetSensitive(argsList$keepAllNodesCheck, FALSE)
    }
    if(names(selNwTypeID) == "bipartite")
    {
      RGtk2::gtkWidgetSetSensitive(argsList$weightedCheck, FALSE)
      RGtk2::gtkWidgetSetSensitive(argsList$keepAllNodesCheck, TRUE)
    }
    
  }
  if(names(selNwTypeID) == "both")
  {
    argsList$comboPlotOutput$setActive(argsList$plotOutputID["dynamic"])
    RGtk2::gtkWidgetSetSensitive(argsList$comboPlotOutput, FALSE)
    argsList$plotTitleText$setText("")
    RGtk2::gtkWidgetSetSensitive(argsList$plotTitleText, FALSE)
    
    RGtk2::gtkWidgetSetSensitive(argsList$weightedCheck, TRUE)
    RGtk2::gtkWidgetSetSensitive(argsList$keepAllNodesCheck, TRUE)
  }
}


# argsList= 
# parentWindow, statusbar
# commonFields: feaResultsText, comboFeaTool,  thresholdAttributeNetworkText, thresholdValueNetworkText, thresholdOperatorNetworkText, expressionText, comboExpressionPlot
# all tabPlotNetwork fields (onlyNwFields)

generateNetwork <- function(button, argsList) # button: Not used, but required for signalConnect.
{ 
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
    
    ###################################################################
    # Start processing
    inputFile <- argsList$commonFields$feaResultsText$getText()
    reportTool <- argsList$commonFields$comboFeaTool$getActive()
    reportTool <- rownames(FEA_tools)[which(as.numeric(FEA_tools[,"ID"])==reportTool)]
    
    # Recargar siempre? donde poner para q solo cuando cambia?
    feaResults <- readFEAresults(feaResultsText=argsList$commonFields$feaResultsText,comboFeaTool=argsList$commonFields$comboFeaTool, expressionText=argsList$commonFields$expressionText,
                                    serverWebReportText=argsList$commonFields$serverWebReportText,alreadyDownloadedCheck=argsList$commonFields$alreadyDownloadedCheck, parentWindow=argsList$parentWindow)
    
    # inputFile is GTLinker jobID?
    if(!is.na(suppressWarnings(as.numeric(inputFile)))) inputFile <- feaResults$fileName
        
    if(is.null(feaResults) || (reportTool==-1 || inputFile==""))
    {
        # Dialog
        dialog <- RGtk2::gtkDialogNewWithButtons("FEA results required", argsList$parentWindow,
                                          c("modal", "destroy-with-parent"), 
                                          "gtk-ok", RGtk2::GtkResponseType["accept"],
                                          show=TRUE)
        dialog[["vbox"]]$add(RGtk2::gtkLabel("Please provide a file with the FEA results to continue."))
        response <- dialog$run() 
        dialog$destroy()
        
    }else
    {        
        ###################################################################
        # Get arguments
        geneExpr <- processExpressionField(argsList$commonFields$expressionText)
        plotExpression <- names(argsList$commonFields$exprPlotOptionsID)[which(argsList$commonFields$exprPlotOptionsID==argsList$commonFields$comboExpressionPlot$getActive())]
        ###################################################################
        # Go to the given file directory        
        folder <- strsplit(inputFile, .Platform$file.sep, fixed=TRUE)[[1]]
        folder <- sub(folder[length(folder)],"",inputFile)
                      
        # Create folder
        currWD <- getwd()
        if(folder!="")
        {
            if((!file.exists(file.path(folder))))
            {
                dir.create(file.path(folder))        
            }
            setwd(folder)
        }
        
        ####################################
        #### Plot networks
        retFNw <- NULL
        if(!is.null(feaResults))
        {
            
          argsList$statusbar$push(argsList$statusbar$getContextId("info"), "Generating network...")
          # Subnetwork
          if(button$label %in% c("nw1","nw2","nw3","nw5","nw6","nw7","nw8"))
          {
#               # Get selected cluster
#               selCluster=""
#               if(txtSelectCluster$visible) selCluster <- txtSelectCluster$getText()
#               if(comboSelectCluster$visible) selCluster <- names(clustersId)[which(clustersId==comboSelectCluster$getActive())]
#               if(selCluster=="") selCluster <- clustersId[1]
#               txtSelectCluster$setText("")
#               
#               # Fill combo          
#               comboSelectCluster$getModel()$clear()
#               for (i in names(clustersId)) RGtk2::gtkComboBoxAppendText(comboSelectCluster, i)
#               comboSelectCluster$setActive(clustersId[selCluster])
#               RGtk2::gtkWidgetSetSensitive(comboSelectCluster, TRUE)
#               comboSelectCluster$Show()
#               RGtk2::gtkWidgetSetSensitive(txtSelectCluster, FALSE)
#               txtSelectCluster$Hide()  
#               
#             subNwType <- button$label
#             plotOutput <- names(argsList$onlyNwFields$plotOutputID)[which(argsList$onlyNwFields$plotOutputID==argsList$onlyNwFields$comboClplotOutput$getActive())] # "dinamic","static"
# 
              ## add trycatch
#             retFNw <- plotSubNetwork(feaResults, selCluster=selCluster, plotOutput=subNwType, plotOutput=plotOutput, returnGraph=saveCheck$active, geneExpr=geneExpr,plotExpression=plotExpression)
#             
          }else # FunctionalNetwork 
          {
            jobName <- getJobName(feaResults$fileName) # for save
            ##############################
            # Get arguments
            # toMatrix():
            key <- names(argsList$onlyNwFields$keysID)[which(argsList$onlyNwFields$keysID==argsList$onlyNwFields$comboKey$getActive())]
            sepChar <- NULL
            clusterColumn <- NULL
            filterAttribute <- argsList$commonFields$thresholdAttributeNetworkText$getText()  # Only david and gTLinker
                if(filterAttribute=="") filterAttribute <- NULL
            filterThreshold <- argsList$commonFields$thresholdValueNetworkText$getText()
                if(filterThreshold=="") filterThreshold <- 0
            filterOperator <- argsList$commonFields$thresholdOperatorNetworkText$getText() 
                if(filterOperator=="") filterOperator <- NULL
            removeFiltered <- NULL
            
            # functionalNetwork():
            weighted <- argsList$onlyNwFields$weightedCheck$active
            keepAllNodes <- argsList$onlyNwFields$keepAllNodesCheck$active
            plotAllMg <- keepAllNodes
            plotTitle <- argsList$onlyNwFields$plotTitleText$getText()
            legendPrefix <- argsList$onlyNwFields$legendPrefixText$getText()
            legendText <- NULL
            if(!argsList$onlyNwFields$showLegendCheck$active) legendText <- FALSE
            vSize <- as.numeric(argsList$onlyNwFields$vSizeText$getText())
            vLabelCex <- as.numeric(argsList$onlyNwFields$vLabelCexText$getText())
            bgTransparency <- as.numeric(argsList$onlyNwFields$bgTransparencyText$getText())
            eColor <- argsList$onlyNwFields$eColorText$getText()
            nwType <- names(argsList$onlyNwFields$funNwIntNwID)[which(argsList$onlyNwFields$funNwIntNwID==argsList$onlyNwFields$comboFunNwIntNw$getActive())]  # "functionalNetwork","intersectionNetwork","both"
            if(nwType=="both") nwType <- names(argsList$onlyNwFields$funNwIntNwID)[1:2]
            
            plotOutput <- names(argsList$onlyNwFields$plotOutputID)[which(argsList$onlyNwFields$plotOutputID==argsList$onlyNwFields$comboPlotOutput$getActive())] # "dinamic","static"
            
            #### PLOT
            # Matrices
            matr <- fea2incidMat(feaResults=feaResults, key=key, sepChar=sepChar, clusterColumn=clusterColumn, filterAttribute=filterAttribute, filterThreshold=filterThreshold,filterOperator=filterOperator, removeFilteredGtl=removeFiltered)
            
            # Plot
            retFNw <- tryCatch( 
                            {                        
                                tmpReply <- functionalNetwork(matr, plotOutput=plotOutput, plotType=nwType, 
                                                              plotTitle=plotTitle, legendPrefix=legendPrefix, legendText=legendText, 
                                                              plotExpression=plotExpression,geneExpr=geneExpr, 
                                                              vSize=vSize, vLabelCex=vLabelCex, eColor=eColor, 
                                                              weighted=weighted,  bgTransparency=bgTransparency, 
                                                              plotTitleSub=NULL, keepAllNodes=keepAllNodes, plotAllMg=plotAllMg)  # MISSING!!!  
                                argsList$statusbar$push(argsList$statusbar$getContextId("info"), "Network ready.")
                                tmpReply # (invisible returns)
                            }, error = function(e) 
                            {
                                argsList$statusbar$push(argsList$statusbar$getContextId("info"), "Error in network. See R console for details.")
                                stop(e)
                            })

          }
          
          ####################################
          # Save return
          if(argsList$onlyNwFields$saveCheck$active)
          {
              if(jobName=="") jobName <- "network"
              jobName <- paste(jobName,"_network.RData",sep="")
              save(retFNw, file=jobName)
              message(paste("Network saved as ",jobName, sep=""))
          }
        }
        setwd(currWD)
    }    
} 

#################################################################################
### Fills the Only network tab
#################################################################################

tabPlotNetwork_fill <- function(mainWindow, statusbar, commonFields)
{
    tabPlotNetwork <- RGtk2::gtkVBox(FALSE,3)
    ### plotOptionsFrame
    # Not added: sepChar, vLayout=NULL, keepColors=TRUE
    plotOptionsExpander <- RGtk2::gtkExpanderNew("More options")
    fgnPlotOptionsBox <- RGtk2::gtkVBox(FALSE,3)
    
    fgnPlotOptionsL1Box <- RGtk2::gtkHBox(FALSE,3)
    fgnPlotOptionsL2Box <- RGtk2::gtkHBox(FALSE,3)
    fgnPlotOptionsL1bBox <- RGtk2::gtkHBox(FALSE,3)
    fgnPlotOptionsL3Box <- RGtk2::gtkHBox(FALSE,3)
    fgnPlotOptionsL4Box <- RGtk2::gtkHBox(FALSE,3)
    fgnPlotOptionsL5Box <- RGtk2::gtkHBox(FALSE,3)
    
    # key="Genes"
    keysID <- setNames(0:1, c("Genes","Terms"))
    comboKeyFrame <- RGtk2::gtkFrame("Network type")
    RGtk2::gtkFrameSetShadowType(comboKeyFrame, GtkShadowType["none"])
    comboKey <- RGtk2::gtkComboBoxNewText()
    for (i in names(keysID)) RGtk2::gtkComboBoxAppendText(comboKey, i)
    comboKey$setActive(keysID["Genes"])
    comboKey$"tooltip-text" <- "Network nodes"
    comboKeyFrame$add(comboKey)
    fgnPlotOptionsL1Box$packStart(comboKeyFrame, expand=FALSE)
    
    # plotFunctionalNetwork
    funNwIntNwID <- setNames(0:2, c("default","bipartite","both"))
    funNwIntNwText <- setNames(0:2, c("Functional Network (default)","Intersection Network (bipartite)","Both"))
    funNwIntNwFrame <- RGtk2::gtkFrame("")
    RGtk2::gtkFrameSetShadowType(funNwIntNwFrame, GtkShadowType["none"])
    comboFunNwIntNw <- RGtk2::gtkComboBoxNewText()
    for (i in names(funNwIntNwText)) RGtk2::gtkComboBoxAppendText(comboFunNwIntNw, i)
    comboFunNwIntNw$setActive(funNwIntNwID["default"])
    funNwIntNwFrame$add(comboFunNwIntNw)    
    fgnPlotOptionsL1Box$packStart(funNwIntNwFrame, expand=FALSE)
    
    # plotOutput="static"
    plotOutputID <- setNames(0:1, c("dynamic","static"))
    plotOutputFrame <- RGtk2::gtkFrame("Output")
    RGtk2::gtkFrameSetShadowType(plotOutputFrame, GtkShadowType["none"])
    comboPlotOutput <- RGtk2::gtkComboBoxNewText()
    for (i in capitalize(names(plotOutputID))) RGtk2::gtkComboBoxAppendText(comboPlotOutput, i)
    comboPlotOutput$setActive(plotOutputID["static"])
    comboPlotOutput$"tooltip-text" <- "static: standard R plot (R console) \ndynamic:interactive tkplot (metagroups background cannot be drawn)"
    
    plotOutputFrame$add(comboPlotOutput)
    fgnPlotOptionsL2Box$packStart(plotOutputFrame, expand=FALSE)
    
    # Checkbox
    fgnPlotOptionsHBox <- RGtk2::gtkHBox(FALSE,3)
    # save
    saveCheck<- RGtk2::gtkCheckButton("Save (.RData)")
    saveCheck$"tooltip-text" <- "Save igraph & matrices"
    fgnPlotOptionsL2Box$packStart(saveCheck, expand=FALSE)
    # weighted=FALSE
    weightedCheck<- RGtk2::gtkCheckButton("Weighted")
    weightedCheck$"tooltip-text" <- "Edge width based on the number of shared gene-term sets"    
    fgnPlotOptionsHBox$packStart(weightedCheck, expand=FALSE)
    # keepAllNodes=FALSE
    keepAllNodesCheck<- RGtk2::gtkCheckButton("keepAllNodes")
    keepAllNodesCheck$"tooltip-text" <- "Show all nodes, including those in only one cluster"
    RGtk2::gtkWidgetSetSensitive(keepAllNodesCheck, FALSE)
    
    
    fgnPlotOptionsHBox$packStart(keepAllNodesCheck, expand=FALSE)
    fgnPlotOptionsL1bBox$packStart(fgnPlotOptionsHBox, expand=FALSE)
    
    
    
    # plotTitle="Functional Network"
    plotTitleFrame <- RGtk2::gtkFrame("Title")
    RGtk2::gtkFrameSetShadowType(plotTitleFrame, GtkShadowType["none"])
    plotTitleText <- RGtk2::gtkEntryNew()
    plotTitleText$setWidthChars(15)
    plotTitleText$setText("Functional Network")
    plotTitleFrame$add(plotTitleText)
    fgnPlotOptionsL3Box$packStart(plotTitleFrame, expand=TRUE)
    
    # legendPrefix=NULL
    legendPrefixFrame <- RGtk2::gtkFrame("Legend prefix")
    legendPrefixBox <- RGtk2::gtkHBox(FALSE,3)
    RGtk2::gtkFrameSetShadowType(legendPrefixFrame, GtkShadowType["none"])
    legendPrefixText <- RGtk2::gtkEntryNew()
    legendPrefixText$setText("Cl ")
    legendPrefixText$setWidthChars(7)
    legendPrefixBox$packStart(legendPrefixText, expand=FALSE)
    
    showLegendCheck<- RGtk2::gtkCheckButton("Show legend")
    showLegendCheck$active <- TRUE
    legendPrefixBox$packStart(showLegendCheck, expand=FALSE)
    
    legendPrefixFrame$add(legendPrefixBox)
    fgnPlotOptionsL3Box$packStart(legendPrefixFrame, expand=FALSE)
    
    # legendText=NULL
    
    # vSize=12
    vSizeFrame <- RGtk2::gtkFrame("vSize")
    RGtk2::gtkFrameSetShadowType(vSizeFrame, GtkShadowType["none"])
    vSizeText <- RGtk2::gtkEntryNew()
    vSizeText$setWidthChars(5)
    vSizeText$setText("12")
    vSizeText$"tooltip-text" <- "Vertex (node) size"
    vSizeFrame$add(vSizeText)
    fgnPlotOptionsL4Box$packStart(vSizeFrame, expand=TRUE)
    
    # vLabelCex=0.75 
    vLabelCexFrame <- RGtk2::gtkFrame("LabelCex")
    RGtk2::gtkFrameSetShadowType(vLabelCexFrame, GtkShadowType["none"])
    vLabelCexText <- RGtk2::gtkEntryNew()
    vLabelCexText$setWidthChars(5)
    vLabelCexText$setText("0.75")
    vLabelCexText$"tooltip-text" <- "Node label size"
    vLabelCexFrame$add(vLabelCexText)
    fgnPlotOptionsL4Box$packStart(vLabelCexFrame, expand=TRUE)
    
    # bgTransparency=0.4
    bgTransparencyFrame <- RGtk2::gtkFrame("bgTransp.")
    RGtk2::gtkFrameSetShadowType(bgTransparencyFrame, GtkShadowType["none"])
    bgTransparencyText <- RGtk2::gtkEntryNew()
    bgTransparencyText$"tooltip-text" <- "Background transparency"
    bgTransparencyText$setWidthChars(5)
    bgTransparencyText$setText("0.4")
    bgTransparencyFrame$add(bgTransparencyText)
    fgnPlotOptionsL4Box$packStart(bgTransparencyFrame, expand=TRUE)
    
    # eColor="#323232"
    eColorFrame <- RGtk2::gtkFrame("eColor")
    RGtk2::gtkFrameSetShadowType(eColorFrame, GtkShadowType["none"])
    eColorText <- RGtk2::gtkEntryNew()
    bgTransparencyText$setWidthChars(5)
    eColorText$setText("#323232")
    eColorText$"tooltip-text" <- "Edge color"
    eColorFrame$add(eColorText)
    fgnPlotOptionsL4Box$packStart(eColorFrame, expand=FALSE)
    
    # Tab end
    fgnPlotOptionsBox$packStart(fgnPlotOptionsL3Box, expand=FALSE,10)
    fgnPlotOptionsBox$packStart(fgnPlotOptionsL4Box, expand=FALSE,10)
    fgnPlotOptionsBox$packStart(fgnPlotOptionsL5Box, expand=FALSE,10)
    plotOptionsExpander$add(fgnPlotOptionsBox)
    
    tabPlotNetwork$packStart(fgnPlotOptionsL1Box, expand=FALSE,10)
    tabPlotNetwork$packStart(fgnPlotOptionsL1bBox, expand=FALSE,10)
    tabPlotNetwork$packStart(fgnPlotOptionsL2Box, expand=FALSE,10)
    tabPlotNetwork$packStart(plotOptionsExpander, expand=FALSE,10)
    
    buttonNetwork <- RGtk2::gtkButton("Create")
    tabPlotNetwork$packStart(buttonNetwork, expand = FALSE, FALSE, 10) 
    
    # Make list with fields:
    fields <- list(comboKey=comboKey,keysID=keysID, comboFunNwIntNw=comboFunNwIntNw, funNwIntNwID=funNwIntNwID, funNwIntNwText=funNwIntNwText, weightedCheck=weightedCheck, keepAllNodesCheck=keepAllNodesCheck, comboPlotOutput=comboPlotOutput,plotOutputID=plotOutputID, saveCheck=saveCheck,
    plotTitleText=plotTitleText, legendPrefixText=legendPrefixText, showLegendCheck=showLegendCheck, 
    vSizeText=vSizeText, vLabelCexText=vLabelCexText, bgTransparencyText=bgTransparencyText, eColorText=eColorText)
    
    
    # SignalConnects
    RGtk2::gSignalConnect(buttonNetwork, "clicked", generateNetwork, data=list(parentWindow=mainWindow, statusbar=statusbar, 
                                                            commonFields=commonFields, onlyNwFields=fields))
    
    RGtk2::gSignalConnect(comboFunNwIntNw, "changed", selectNetworkType, data=list(comboFunNwIntNw=comboFunNwIntNw,funNwIntNwID=funNwIntNwID, funNwIntNwText=funNwIntNwText, plotTitleText=plotTitleText, comboPlotOutput=comboPlotOutput,plotOutputID=plotOutputID,
                                                                            weightedCheck=weightedCheck, keepAllNodesCheck=keepAllNodesCheck))
    
    return(list(tabPlotNetwork=tabPlotNetwork, fields=fields))
}

# Return:
# $`Cluster 1`
# Terms                                      
# [1,] "Cellular component organization"          
# [2,] "Organelle organization"                   
# [3,] "Positive regulation of catalytic activity"
# [4,] "Positive regulation of molecular function"
# ...

getTerms <- function(feaResults, returnValue="description") #GO
{    
    if(!is.list(feaResults)) stop("Please provide the whole output from one of the fea functions.")  # Only Clusters/Metagroups are used. (no need of $GeneTermSets)
    
                            grNames <- NULL
                            if("clusters" %in% names(feaResults))
                            {    
                                if(!is.null(feaResults$clusters))    
                                {
                                    grType<-"Cluster"
                                    feaResults <- feaResults$clusters
                                    if("Cluster" %in% colnames(feaResults)) grNames <- feaResults$Cluster
                                }else{
                                    
                                    grType <- "Gene-term set"
                                    feaResults <- feaResults$geneTermSets
                                    feaResults$Terms <- unlist(formatTerms(as.character(feaResults$Terms)))
                                    
                                    grNames <- rownames(feaResults)
                                }
                            }
                            if("metagroups" %in% names(feaResults))
                            {
                                grType <- "Metagroup"
                                feaResults <- feaResults$metagroups
                                grNames <- rownames(feaResults)
                            }

    mgTerms <- getMGTerms(feaResults, grType=grType)
    
    if(returnValue=="GO") # Return go IDs
    {        
        terms <- sapply(mgTerms, function(x) x[grepl(pattern="GO:",x[,"TermID"]),"TermID"])
        #terms <- sapply(terms, function(x) sapply(x, function(y) strsplit(y,split=":[[:alpha:]]",perl=TRUE)[[1]][1]))
        names(terms) <- paste(grType, grNames)

    }
    else if(returnValue=="description") # Return term description
    {    
        terms <- lapply(mgTerms, function(x) 
            {
            temp <- rbind(x)[,"TermDescription", drop=FALSE]
            colnames(temp) <- "Terms"
            rownames(temp) <- NULL
            return(temp)
            })
    }
    return(terms)    
}

################################################################################
### Aux functions

showVignette <- function(button) # button: Not used, but required for signalConnect.
{
    #vignette("UserGuide", "FGNet")
    #openPDF(file, bg=TRUE)
    #print('vignette("builtinMethods", "affy")')
}

#################################################################################
### Fills 
#################################################################################
 
tabHelp_fill <- function(mainWindow)
{
    tabHelp <- RGtk2::gtkHBox(FALSE,10)
    tabHelpV <- RGtk2::gtkVBox(FALSE,10)
    
    helpTxt <- 'To generate the functional network:\n\n 1. Run the Functional Enrichment Analisis (FEA) with one of the tools (Tab "1 - FEA")\n\n 2. Generate the HTML report or personalize the networks (Tab "2 - Network")\n'
    tabHelpV$packStart(RGtk2::gtkLabel(helpTxt), TRUE, TRUE, 50)
    
    vignetteFrame <- RGtk2::gtkFrame("To see FGNet tutorial, type in R console:")
    RGtk2::gtkFrameSetShadowType(vignetteFrame, GtkShadowType["none"])
    vignetteText <- RGtk2::gtkEntryNew()
    vignetteText$setText('browseVignettes("FGNet")')
    vignetteFrame$add(vignetteText)
    
    tabHelpV$packStart(vignetteFrame, FALSE, FALSE, 50)
    
    tabHelp$packStart(tabHelpV, FALSE, FALSE, 50)
    
#     buttonVignette <- RGtk2::gtkLabel("User guide")
#     tabHelp$packStart(buttonVignette, FALSE, FALSE, 0)
#     gSignalConnect(buttonVignette, "clicked", showVignette)
# tabHelp$packStart(RGtk2::gtkLinkButtonNewWithLabel("/home/saraa/Desktop/R-refcard.pdf", label = "[ TEEEST ]", show = TRUE), FALSE, FALSE, 0)
        
    #######################################################################
    #  ready
    return(list(tabHelp=tabHelp)) 
    #######################################################################
}

# also used in toMatrix & clDescriptions
formatTerms<- function(termTbl)
{
    if(all(grepl("\\(([[:alnum:]]+:[[:alnum:]]+[0-9]+)\\)$", termTbl)))
    {
        ret <- termTbl    
    }else
    {
        if(any(grepl(":",termTbl, fixed=TRUE)))
        {
            termTbl <- strsplit(termTbl, ":")
            
            ret <- lapply(termTbl, function(x) 
            {
                if(length(x)<3)
                {
                    capitalize(paste(paste(x[length(x)],sep=""))) # Drops annotation
                }else# format ANNOT:ID:Term description...
                {
                    capitalize(paste(paste(x[3:length(x)], collapse=" "), " (",paste(x[1:2], collapse=":"),")",sep=""))
                }
            })
        }else
        {
            ret <- termTbl
        }
    }
    return(ret)
}

# keepTermsCol: Column name. Only geneTerm sets with this column TRUE will be kept.  (Used by gtLinker and GAGE. Can also be used to filter...)
clustersTable <- function(geneTermSets, clusterColumn="Cluster", colsAvg=NULL, keepTermsCol=NULL, addKeyWordsTerm=TRUE, sortBy=NULL, decreasing=TRUE)
{
    ###########################
    # Create clusters table
    tablaClusters <- NULL 
    
    if(clusterColumn %in% names(geneTermSets))
    {
        if(!is.null(keepTermsCol)) geneTermSets <- geneTermSets[geneTermSets[,keepTermsCol],,drop=FALSE]
        
        for(cl in unique(geneTermSets[,clusterColumn]))
        {
            tmpTable <- as.matrix(geneTermSets[which(geneTermSets[,clusterColumn] == cl),c(clusterColumn, "Terms", "Genes", colsAvg)])
    
            # Collapse Terms
            tmpTerms <- tmpTable[,"Terms", drop=FALSE]
            if(addKeyWordsTerm) keyWordsTerm <- capitalize(keywordsTerm(list(cbind(TermDescription=sapply(strsplit(tmpTerms, ":"), function(x) x[length(x)]))), nChar=100))
            tmpTerms <- formatTerms(tmpTerms)
            tmpTerms <- paste(tmpTerms, collapse=";")
    
            # Merge genes from geneTerm sets
            tmpGenes <- list()
            for(i in 1:length("Genes"))
            {
                tmpGenes[[i]] <- sort(unique(unlist(strsplit(as.character(tmpTable[,"Genes"[i]]), split=","))))
                nGenes <- length(tmpGenes[[i]])
                tmpGenes[[i]] <- paste(tmpGenes[[i]], collapse=",")
            }
            tmpGenes <- unlist(tmpGenes)
            
            # Calculate average from requested colums
            colsAvgCluster <- NULL
            if(!is.null(colsAvg)) 
            {
                colsAvgCluster <- sapply(colsAvg, function(x) 
                    {
                        x <- tmpTable[,x]
                        if(all(!is.na(suppressWarnings(as.numeric(x))))) 
                        {
                            x <- mean(as.numeric(x))
                        }else
                        {
                            paste(unique(x), collapse=", ")
                        }
                        
                    })
            }
            rowCluster <- c(Cluster=cl, nGenes=nGenes, colsAvgCluster, Genes=tmpGenes, Terms=tmpTerms)
            if(addKeyWordsTerm) rowCluster <- c(rowCluster, keyWordsTerm=keyWordsTerm)
            tablaClusters <- rbind(tablaClusters, rowCluster)
        }
        colnames(tablaClusters)[1] <- clusterColumn
        rownames(tablaClusters) <- as.character(tablaClusters[,clusterColumn])
        tablaClusters <- data.frame(tablaClusters)
        
        
        if(!is.null(sortBy))
        {
            sortBy <- as.character(tablaClusters[,sortBy])
            if(all(!is.na(suppressWarnings(as.numeric(sortBy))))) sortBy <- as.numeric(sortBy)
            tablaClusters <- tablaClusters[order(sortBy,decreasing=decreasing),]
        }
    }
    return(tablaClusters)        
}

# fileName <- "goResTable.txt" 
readGeneTermSets <- function(fileName, tool=NULL, simplifyGage=TRUE)
{
    data("FEA_tools", envir = environment())
    FEA_tools<- get("FEA_tools", envir  = environment())
        
    # Read file
    sepChar <- "\t"
    geneTermSets <- read.table(fileName, sep=sepChar, header=TRUE, quote="")
    if(any(is.na(geneTermSets$Genes)) || ("GenesIDs" %in% colnames(geneTermSets) && any(is.na(geneTermSets$GenesIDs))))
    {
        warning("Some gene-term sets contain no genes.")
        geneTermSets$Genes[is.na(geneTermSets$Genes)] <- ""
        if("GenesIDs" %in% colnames(geneTermSets)) geneTermSets$GenesIDs[is.na(geneTermSets$GenesIDs)] <- ""
    }
    
    # Create clusters table
    colsAvg <- NULL
    sortBy <- NULL
    if(!is.null(tool))
    {
        colsAvg <- sortBy <- FEA_tools[tool,"DefaultFilter"]
        if(is.na(colsAvg)) colsAvg  <- sortBy <- NULL
        
    }
    if(!is.null(tool) && tool=="gage") 
    {
        # gage:
        keepTermsCol <- NULL
        if(simplifyGage) keepTermsCol <- "essentialSet"
        tablaClusters <- clustersTable(geneTermSets, colsAvg="dir", sortBy=NULL, keepTermsCol=keepTermsCol, addKeyWordsTerm=FALSE)
    }else
    {
        # Default, any other case
        tablaClusters <- clustersTable(geneTermSets, colsAvg=colsAvg, sortBy=sortBy, decreasing=TRUE) # keepTermsCol=NULL, addKeyWordsTerm=TRUE, 
    }
    
    
    # Return
    invisible(list(clusters=tablaClusters, geneTermSets=geneTermSets, fileName=fileName))
}

######################################################
# refList
# buildGeneSets
# findGenesInTerm - TODO - 

######################################################
# geneIDtype <- "ENSEMBL"
# dbPackage <- "hgu133plus2.db" # organism or chip database
# if(is.null(genesUniverse)) genesUniverse <- refList(organism, geneIDtype)
refList <- function(dbPackage, geneIdType)
{
    if(!loadInstPkg(dbPackage)) stop(paste("Package", dbPackage, "is not available."))

    pkg.db <- eval(parse(text=dbPackage))
    AnnotationDbi::columns(pkg.db)
    
    if(!geneIdType %in% AnnotationDbi::columns(pkg.db)) stop(paste("geneIdType not available for ",dbPackage,". \nAvailable columns: ",paste(columns(pkg.db), collapse=", "), sep=""))
    
    return(AnnotationDbi::keys(pkg.db, keytype=geneIdType))
}


# organismDb <- "org.Hs.eg.db"
# geneIDtype <- "ENSEMBL"

# Builds gene-term sets based on Bioconductor databases: Organisms and GO/KEGG/REACTOME
# used by query_topGO and query_gage
buildGeneSets <- function(organismDb, geneIDtype, annotations=c("GO_BP","GO_MF","GO_CC","REACTOME"), evidence=NULL, termLabel=c("TERM","ID"))
{
    if(termLabel[1] == "TERM") termAsLabel <- TRUE
    # Check and load required libraries
    if("REACTOME" %in% annotations) 
    {
        if(!loadInstPkg("reactome.db")) 
        {
            warning("Package 'reactome.db' is required to build REACTOME sets.")
            annotations <- annotations[which(!annotations%in%"REACTOME")]
        }
    }

    if(!loadInstPkg(organismDb)) stop("The organism package is not available.")

    org.db <- eval(parse(text=organismDb))
    
    if(!geneIDtype %in% AnnotationDbi::columns(org.db)) stop(paste("geneIDtype not available for ",organismDb,". \nAvailable columns: ",paste(columns(org.db), collapse=", "), sep=""))

    allGenes <- AnnotationDbi::keys(org.db, keytype=geneIDtype)
    allGenes <- gsub(pattern="\"", "",allGenes)
    ret <- list(genes2terms=NULL, terms2genes=NULL, asTable=NULL)
    #### Build GO tables:
    if(any(c("GO_BP","GO_MF","GO_CC") %in% annotations))
    {
        tableGoGenes <- suppressWarnings(AnnotationDbi::select(org.db, keys=allGenes, columns="GO", keytype=geneIDtype))
        tableGoGenes <- tableGoGenes[!is.na(tableGoGenes[,"GO"]),] # Bueno o malo?
        if(!is.null(evidence)) tableGoGenes <- tableGoGenes[tableGoGenes$EVIDENCE %in% evidence, ]
        
        tableGoGenesSplit <- split(tableGoGenes, tableGoGenes$ONTOLOGY) # Split by ontology
        tableGoGenesSplit <- tableGoGenesSplit[which(paste("GO_", names(tableGoGenesSplit), sep="") %in% annotations)] # Select the requested ontologies
        
        geneID2GO <- lapply(tableGoGenesSplit, function(x) split(as.character(x$GO),x[,geneIDtype]))
        names(geneID2GO) <- paste("GO_", names(geneID2GO), sep="")
        GO2geneID <- lapply(tableGoGenesSplit, function(x) split(x[,geneIDtype], as.character(x$GO)))
        names(GO2geneID) <- paste("GO_", names(GO2geneID), sep="")

        ret$genes2terms <- c(ret$genes2terms, geneID2GO)
        ret$terms2genes <- c(ret$terms2genes, GO2geneID)
        ret$asTable <- c(ret$asTable, list(GO=tableGoGenes))
     
        if(loadInstPkg("GO.db")) 
        {
            termsLabels <- AnnotationDbi::select(GO.db, keys=unlist(sapply(ret$terms2genes, names)), columns="TERM", keytype="GOID")  # ONLY annotations NEEDS TO BE GO!
            termsLabels <- split(termsLabels$TERM, termsLabels$GOID)# (as list for consistency with other annotationss)
            termsLabels <- lapply(termsLabels, capitalize)
            
            if(termAsLabel)
            {
                # Concatenate the term ID with the term label
                ret$terms2genes <- lapply(ret$terms2genes, function(x){
                    names(x) <- paste(names(x), ":", termsLabels[names(x)], sep="")
                    x})                        
            }else{ 
                # Add a field with the term name
                if(!"termID2name" %in% names(ret)) ret <- c(ret, list(termID2name=NULL))
                ret$termID2name <- c(ret$termID2name, list(GO=termsLabels))
            }
        }else{
            if(termAsLabel) warning("To add terms as gene set label GO.db package is required.")
        }
    }
    
    # #### Build KEGG tables:
    # if("KEGG" %in% annotations)
    # {
    #     if("PATH" %in% AnnotationDbi::columns(org.db))
    #     {
    #         tableKeggGenes <- suppressWarnings(AnnotationDbi::select(org.db, keys=allGenes, columns="PATH", keytype=geneIDtype))
    #         tableKeggGenes <- tableKeggGenes[!is.na(tableKeggGenes[,"PATH"]),] # Bueno o malo?
    #         
    #         # genes2kegg <- split(as.character(tableKeggGenes$PATH),tableKeggGenes[,geneIDtype])
    #         # kegg2genes <- split(tableKeggGenes[,geneIDtype], as.character(tableKeggGenes$PATH))
    # 
    #         # ret$genes2terms <- c(ret$genes2terms, list(KEGG=genes2kegg))
    #         # ret$terms2genes <- c(ret$terms2genes, list(KEGG=kegg2genes))
    #         # ret$asTable <- c(ret$asTable, list(KEGG=tableKeggGenes))
    #         
    #         # if(loadInstPkg("KEGG.db")) 
    #         # {
    #         #     # Labels...
    #         #     termsLabels <- AnnotationDbi::as.list(KEGG.db::KEGGPATHID2NAME)
    #         #     termsLabels <- termsLabels[which(names(termsLabels) %in% names(kegg2genes))]
    #         #     # termsLabels <- sapply(termsLabels, function(x) x[1]) # Take only first
    #         #     
    #         #     if(termAsLabel)
    #         #     {
    #         #         # Concatenate the term ID with the term label
    #         #         names(ret$terms2genes$KEGG) <- paste(names(ret$terms2genes$KEGG), ":", termsLabels[names(ret$terms2genes$KEGG)], sep="")        
    #         #     }else{ 
    #         #         # Add a field with the term name
    #         #         if(!"termID2name" %in% names(ret)) ret <- c(ret, list(termID2name=NULL))
    #         #         ret$termID2name <- c(ret$termID2name, list(KEGG=termsLabels))
    #         #     } 
    #         # }else{
    #         #     if(termAsLabel) warning("To add terms as gene set label KEGG.db package is required.")
    #         # }
    #     }else{
    #         warning(paste("Kegg (pathway) info is not available in ", organismDb, sep=""))
    #     }
    # }
    
    
    if("REACTOME" %in% annotations)
    {
        reactPw2geneID <- AnnotationDbi::as.list(reactome.db::reactomePATHID2EXTID)  
        geneID2reactPw <- AnnotationDbi::as.list(reactome.db::reactomeEXTID2PATHID)
        entrezIdsOrg <- AnnotationDbi::keys(org.db, keytype="ENTREZID")
        
        geneID2reactPw <- geneID2reactPw[which(names(geneID2reactPw) %in% entrezIdsOrg)]
        reactPw2geneID <- sapply(reactPw2geneID, function(x) x[which(x %in% entrezIdsOrg)])
        reactPw2geneID <-reactPw2geneID[sapply(reactPw2geneID, length)>0]
        
        tableReactGenes <- unlist(mapply(rep, names(reactPw2geneID), sapply(reactPw2geneID, length))) # equivalent to melt(reactPw2geneID)
        tableReactGenes <- data.frame(cbind(unlist(reactPw2geneID), tableReactGenes))
        colnames(tableReactGenes) <- c("ENTREZID", "PATH")
        
        
        # TRANSLATE?
        # TO DO!!
        if(geneIDtype != "ENTREZID") warning("At the moment REACTOME gene sets can only be provided for ENTREZID.")
        
        ret$genes2terms <- c(ret$genes2terms, list(REACTOME=geneID2reactPw))
        ret$terms2genes <- c(ret$terms2genes, list(REACTOME=reactPw2geneID))
        ret$asTable <- c(ret$asTable, list(REACTOME=tableReactGenes))
        
        # Labels...
        termsLabels <- AnnotationDbi::as.list(reactomePATHID2NAME)
        termsLabels <- termsLabels[which(names(termsLabels) %in% names(reactPw2geneID))]
        termsLabels <- sapply(termsLabels, function(x) x[1]) # Take only first
        termsLabels <- strsplit(termsLabels, ": ")
        termsLabels <- sapply(termsLabels, function(x){
            paste(paste(x[-1],collapse=" ")," (",x[1],")",sep="")
        })
        if(termAsLabel)
        {
            # Concatenate the term ID with the term label
            names(ret$terms2genes$REACTOME) <- paste(names(ret$terms2genes$REACTOME), ":", termsLabels[names(ret$terms2genes$REACTOME)], sep="")        
        }else{ 
            # Add a field with the term name
            if(!"termID2name" %in% names(ret)) ret <- c(ret, list(termID2name=NULL))
            ret$termID2name <- c(ret$termID2name, list(REACTOME=termsLabels))
        }        
    }    
    return(ret)
}



# # termList <- sigTerm$goid
# # organism <- "org.Hs.eg.db"
# # geneIDtype<-"ENTREZID"
# # geneList <- entrezIDch
# 
# ### Valido para otros FEA/GSEA cuando no dan genes en el gtset... etc
# findGenesInTerm <- function(termIds, geneIds, geneIDtype, organismDb, addTermLabel=TRUE)
# {
#     termIds <- as.character(termIds)
#     dbs <- buildDatabases(organismDb,geneIDtype)
#     
#     ret <- cbind(TermID=termIds, Genes=sapply(termIds, function(term) 
#     {
#         genes <- unique(c(dbs$tableGoGenes[which(dbs$tableGoGenes$GO==term),geneIDtype], # GO
#                    dbs$tableKeggGenes[which(dbs$tableKeggGenes$PATH==term),geneIDtype])) # KEGG
#         return(paste(as.character(genes[genes %in% geneIds]), collapse=","))       
#     }))
#     
#     
#     if(addTermLabel && ("goTerms" %in% names(dbs)))
#     {
#         termLabel <- dbs$goTerms[ret[,"TermID"],]
#         termLabel <- apply(termLabel, 1, function(x) paste(x[1],"~", x[2], sep=""))
#         ret <- cbind(TermID=ret[,"TermID"], Term=termLabel, Genes=ret[,"Genes"])
#     }else{
#         colnames(ret) <- c("Term", "Genes")
#     }
#         
#     return(ret)
# }  

# Functions:
#     buildTermsTable
#     goTreeLinks
#     createHtml - MAIN

# (Create html links)
buildTermsTable <- function(termsDescriptions, leaves, boldTerms)
{
    if(!is.null(leaves))
    {
        if(grepl("Cluster", names(termsDescriptions)[[1]]))    names(leaves) <- paste("Cluster",names(leaves))
        if(grepl("Metagroup", names(termsDescriptions)[[1]]))    names(leaves) <- paste("Metagroup",names(leaves))
        
        for(n in names(termsDescriptions))
        {
            gos <- grepl("GO", termsDescriptions[[n]][,"TermID"])
            
            if(any(gos)) termsDescriptions[[n]] <- rbind(termsDescriptions[[n]][!gos,],termsDescriptions[[n]][gos,, drop=FALSE][termsDescriptions[[n]][gos,"TermID", drop=FALSE] %in% leaves[[n]],])
        }
    }
    
    termLinks <- lapply(termsDescriptions, function(mgMx) {
        if(!is.matrix(mgMx)) mgMx <- t(as.matrix(mgMx)) # 1 row?
        
        if(!is.null(boldTerms))
        {
            bold <- as.character(boldTerms[boldTerms %in% rownames(mgMx)])
            mgMx[bold,"TermDescription"] <- paste("<b>",mgMx[bold,"TermDescription"],"</b>",sep="") 
        }
        
        descrLinks <- apply(mgMx, 1, function(term){
            
            if(is.na(term["Link"]))
            {
                link <- term["TermDescription"]
            }else
            {
                th1 <- th2 <- th3 <- ""
                if(grepl(".png", term["Link"]))  ## Add thumbnail?
                {
                    th1 <- "<div id='thumbnail'>"
                    th2 <- paste("<img src='",term["Link"],"'/>", sep="")
                    th3 <- "</div>"
                }   
                link <- paste(th1, "<a href='", term["Link"],"' target='_blank'>", term["TermDescription"] ,th2, "</a>", th3, sep="")                
            }
            return (link)
        })
        
        descrLinks <- cbind(descrLinks, mgMx[,"Annotation"])
        colnames(descrLinks) <- NULL
        rownames(descrLinks) <- NULL
        return(descrLinks)
    })
    
    return(list(termLinks=termLinks, noLinks=lapply(termsDescriptions, function(x) x[,"TermDescription",drop=FALSE])))
}

# Creates the GO tree and returns the link for each metagroup
goTreeLinks <- function(gtSets, grPrefix, geneExpr, folder, plotGoTree, clusterColumn)
{   
    if(!loadInstPkg("GO.db")) stop("Package GO.db is required to plot GO trees.")
    
    data("groupTypes", envir = environment())
    groupTypes<- get("groupTypes", envir  = environment())
        
    # gtSets <- notFilteredGeneTermSets
    fileNames <- list()
    leaves <- list()
    
    # Initialize gtSets     
    if(grPrefix=="mg") 
    {
        gtSets  <- do.call(rbind,apply(as.matrix(gtSets),1, function(x){
            cbind(x["Metagroup"], strsplit(x["Terms"],";")$Terms, x["Genes"])
        }))
        colnames(gtSets) <- c("Metagroup","Term","Genes")
        rownames(gtSets) <- NULL
        gtSets <- data.frame(gtSets)
    }
    
    # Keep only GO terms
    gtSets <- gtSets[grepl(pattern="GO:",gtSets$Terms),]
    
    if(nrow(gtSets)>0 && plotGoTree)
    {
        # Create DB
        parentsDB <- list()
        parentsDB[["BP"]] <- AnnotationDbi::as.list(GO.db::GOBPPARENTS)
        parentsDB[["MF"]] <- AnnotationDbi::as.list(GO.db::GOMFPARENTS)
        parentsDB[["CC"]] <- AnnotationDbi::as.list(GO.db::GOCCPARENTS)
        
        # For each Mg/Cluster...
        geneSplit <- ","
        clusterColumn <- rownames(groupTypes)[which(groupTypes[,"prefix"]==grPrefix)]
        for(cl in as.character(unique(gtSets[[clusterColumn]])))
        {
            gtsetsCl <- gtSets[gtSets[,clusterColumn]==cl,]
            # Gtlinker: Merge genes from same term in different gtset
            if(grPrefix=="mg")
            {
                tmp <- cbind(as.character(unique(gtsetsCl$Terms)), NA)
                colnames(tmp) <- c("Term", "Genes")
                tmp[,"Genes"] <- apply(tmp, 1, function(x) paste(unique(unlist(lapply(gtsetsCl[gtsetsCl$Terms==x[1],"Genes"], function(x) strsplit(as.character(x),split=geneSplit)[[1]]))), collapse=geneSplit))
                gtsetsCl <- data.frame(tmp)
            }     
            
            # Count terms UP and DOWN (para gtlinker se podria optimizar...)
            if(is.null(geneExpr))
            {
                termExprs <- NULL
            }else{ 
                termExprs <- sapply(gtsetsCl$Genes, function(x) {
                                    genes <- strsplit(as.character(x),split=geneSplit)[[1]]
                                    (sum(geneExpr[genes]>0)-sum(geneExpr[genes]<0))/length(genes) # NA if any missing...
                                    })
            }
            
            # Set term color according to geneExpr
            termsAll <- as.character(gtsetsCl$Terms)
            termsAll <- sapply(strsplit(termsAll,":"), function(x) paste(x[1],x[2],sep=":"))
            termsAll <- unique(termsAll)
            colores <- rep("slategray1", length(termsAll)) # Por defecto, si no hay info de expresion
            names(colores) <- termsAll
            if(!is.null(termExprs))
            {
                colores[which(!is.na(termExprs))] <- "yellow" # Default, if geneExpr available
                colores[which(termExprs>=0.75)] <- "darkgoldenrod1"
                colores[which(termExprs==1)] <- "#FF1010FF" # "darkred"
                colores[which(termExprs<=-0.75)] <- "darkolivegreen1"
                colores[which(termExprs==-1)] <- "#10CF10FF" # green
            }
            
            # Identify terms from each ontology
            gos<- list()
            gos[["BP"]] <- colores[names(colores) %in% names(parentsDB[["BP"]])]
            gos[["MF"]] <- colores[names(colores) %in% names(parentsDB[["MF"]])]
            gos[["CC"]] <- colores[names(colores) %in% names(parentsDB[["CC"]])]
            
            # Plot
            fileNames[[cl]] <- list()
            for(db in c("BP","MF","CC")) 
            {
                if(length(gos[[db]])>0)
                {
                    fileName <- paste(paste("GO_",grPrefix, cl,"_",db,".png", sep=""),sep="")                    
                    tColor <- NULL
                    if(!is.null(termExprs)) tColor <- gos[[db]]
                    leaves[[cl]] <- c(leaves[[cl]], plotGoAncestors(names(gos[[db]]), tColor=tColor, ontology=parentsDB[[db]], fileName=fileName, height=1000)$leaves[,1])
                    fileNames[[cl]][[db]] <- paste(folder,fileName, sep="")
                }
            }
        }
        
        names(fileNames) <- paste(clusterColumn, names(fileNames))    
        ret <- list(fileNames=fileNames,leaves=leaves)
        return(ret)
    }else{
        return("") # No GO terms
    }
}

# Main function
createHtml <- function(htmlFileName, feaResults, jobName, tablesGenes, tablesTerms, tool, queryArgs, filterAttribute, filterOperator, filterThreshold, geneExpr=NULL, plotExpression=NULL, onlyGoLeaves=TRUE, plotGoTree=TRUE)
{
    #####################################################################################################
    ####################################   Initializations   ############################################

    data("groupTypes", envir = environment())
    groupTypes<- get("groupTypes", envir  = environment())
    grType <- names(feaResults)[which(names(feaResults) %in% c("metagroups", "clusters"))]
        
    # Group types...
    sortMG <- TRUE
    if(is.na(filterAttribute)) sortMG <- FALSE
    rawMetagroups <- feaResults[[grType]]
    if(tool=="gage") 
    {
        essentialRawMetagroups <- rawMetagroups
        rawMetagroups <- readGeneTermSets(feaResults$fileName, tool="gage", simplifyGage=FALSE)$clusters
    }
    
    grType <- rownames(groupTypes)[which(groupTypes[,"feaResultsName"]==grType)]
    
    # GTLinker or other?
    if(is.null(rawMetagroups))    
    {
        rawMetagroups <- feaResults$geneTermSets
        rawMetagroups <- data.frame(cbind(Gtset=1:nrow(rawMetagroups),rawMetagroups))
        colsAvg <- NULL
        if(tool=="topGO") colsAvg <- c("Annotated", "classic")
        rawMetagroups <- clustersTable(rawMetagroups, clusterColumn="Gtset", addKeyWordsTerm=FALSE, colsAvg=colsAvg)
        sortMG <- FALSE
            
        grType <- "Gene-term set"
    }
    if(grType == "Metagroup") 
    {
        onlyGoLeaves <- FALSE
    }

    mgIncMatrix <- tablesGenes[[which(names(tablesGenes)==groupTypes[grType,"tablesName"])]]
    termsNumMg <- apply(tablesTerms[[which(names(tablesTerms)==groupTypes[grType,"tablesName"])]],1,sum)
    grPrefix <- groupTypes[grType,"prefix"]
    
    filteredOut <- tablesGenes$filteredOut
    
    genesMetagroups <- unique(unlist(sapply(rawMetagroups[,"Genes"], function(x) strsplit(as.character(x), split=","))))
    nGenesTotal <- length(genesMetagroups)
    nGenesInNotFilteredMg <- nrow(mgIncMatrix)
    nRawMg <- nrow(rawMetagroups)
    
    # Get metagroup colors
    allMgNames <- c(colnames(mgIncMatrix), filteredOut)
    if(all(!is.na(suppressWarnings(as.numeric(allMgNames))))) allMgNames <- as.numeric(allMgNames)
    colores <- setColors(as.character(sort(allMgNames)))[colnames(mgIncMatrix)]
    
    if(sortMG) 
    {
        globalMetagroups <- rawMetagroups[colnames(mgIncMatrix),]
    }else{
        globalMetagroups <- rawMetagroups[rownames(rawMetagroups) %in% colnames(mgIncMatrix),]
    }

    #### Set folder to save images etc: Same as downloaded feaResults    
    folder <- paste(jobName, .Platform$file.sep, sep="")      
    
    # Get metagroup terms
    # keggPlots <- NULL
    # geneIDtype <- feaResults$queryArgs$geneIdType
    # if(plotKeggPw && !is.null(geneIDtype))
    # {
    #     keggExpression <- geneExpr
    #     if(is.null(keggExpression)) keggExpression <- setNames(rep(NA, length(genesMetagroups)), genesMetagroups)
    # 
    #     keggIDs <- getTerms(feaResults, returnValue="KEGG")
    #     names(keggIDs) <- NULL
    #     keggIDs <- unlist(keggIDs)
    #     keggPlots <- tryCatch(
    #                 {
    #                     keggPlots <- plotKegg(keggIDs, keggExpression, geneIDtype=geneIDtype)
    #                     keggPlots
    #                 }, error = function(e)
    #                 {
    #                     plotKeggPw <<- FALSE
    #                 })
    #     if(all(keggPlots==FALSE)) keggPlots <- NULL
    #     if(!is.null(keggPlots))   keggPlots <- setNames(paste(folder, keggPlots, sep=""), names(keggPlots))
    # }
    mgTerms <- getMGTerms(globalMetagroups, grType)

    # Add asterisc to terms in several metagroups:
    termsMultipleMg <- termsNumMg[which(termsNumMg>1)]
    if(length(termsMultipleMg)>0)
    {
        mgTerms <- sapply(mgTerms, function(x) 
        {
            tmp <- rownames(x) %in% names(termsMultipleMg)
            if(any(tmp))  x[tmp,"TermDescription"] <- paste(x[tmp,"TermDescription"], " *", sep="")
            x
        })
    }
    
    # Go trees:
    notFilteredGeneTermSets <- feaResults$geneTermSets[!feaResults$geneTermSets[,1] %in% filteredOut,]
    
    goTrees_global <- NULL
    if(grType=="Gene-term set")  
    {
        # Individual gene-term sets: Plot global GO tree
        goLinks_full <- ""
        goTrees_global <- goTreeLinks(gtSets=cbind("Gene-term set"=1,notFilteredGeneTermSets), grPrefix, geneExpr, folder, plotGoTree)

    }else
    {
        # Clusters or metagroups: plot GO tree by cluster/mg
        goLinks_full <- goTreeLinks(notFilteredGeneTermSets, grPrefix, geneExpr, folder, plotGoTree)
    }
    
    
    leaves <- NULL
    goLinks <- NULL
    if(is.list(goLinks_full))
    {
        if(onlyGoLeaves) leaves <- goLinks_full[["leaves"]]
        goLinks <- goLinks_full$fileNames
    }    
    # Terms table to write in html: 
    boldTerms <- NULL
    if(tool=="gage") boldTerms <- essentialRawMetagroups$Terms
    termsTables <- buildTermsTable(mgTerms, leaves, boldTerms)                                                                        
    
    # Copiar CSS a la carpeta actual...
    cssDir <- file.path(system.file('css', package='FGNet'))
    cssFile <- paste(cssDir, "functionalNetworks.css", sep=.Platform$file.sep)
    file.copy(cssFile, ".")
    
    # Add representative term to DAVID legend
    legendMg <- TRUE
    if(nrow(globalMetagroups)>15) legendMg <- FALSE
    if(legendMg)
    {
        legendMg <- NULL
        if(grType ==  "Cluster") legendMg <- paste(keywordsTerm(mgTerms), ", ...", sep="")
    }
    
    #####################################################################################################
    #################################### Create Plots  ###################################################
    
    iGraphFile <- "iGraph.RData"
    adjMatFile <- "adjMat.RData"
    networkPlot <- "nwFunctionalNetwork.png"
    networkPlot2a <- "nwIntersection_kk.png"
    networkPlot2b <- "nwIntersection_circle.png"
    networkTerms <- "nwTerms.png"
    nwStatsPlot <- "nwStats.png"
    distancePlot <- "plot_Distance.png"
    simplifiedTable <- "simplifiedTermsTable.txt"
    
    # Set node and label size
    numNodes <- sum(dim(mgIncMatrix))
    if(numNodes < 150)
    {
        vSize <- 12
        vLabelCex <- 0.9
    }
    if(numNodes >= 150)
    {
        vSize <- 10
        vLabelCex <- 3/4
    }    
    if(numNodes > 300)
    {
        vSize <- 8
        vLabelCex <- 2/3
    }    
    
    png(networkPlot, width = 800, height = 800)
    retGraph <- functionalNetwork(tablesGenes, plotType="default", plotOutput="static", vSize=vSize, vLabelCex=vLabelCex, legendText=legendMg, geneExpr=geneExpr, plotExpression=plotExpression)
    dev.off()
    png(nwStatsPlot, width = 800, height = 500)
    nwStats <- analyzeNetwork(tablesGenes, fNw=retGraph, plotOutput=TRUE, colors=colores)
    dev.off()
    
    png(networkPlot2a, width = 800, height = 800)
    intersectionGraph <- functionalNetwork(tablesGenes, plotType="bipartite", plotOutput="static", vLayout="kk", vSize=vSize, vLabelCex=vLabelCex, legendPrefix=grPrefix, geneExpr=geneExpr, plotExpression=plotExpression, plotTitle=paste("Genes in several ", tolower(grType), "s", sep=""))
    dev.off()
    if(!is.null(intersectionGraph))
    {
        tablesGenes$iGraph <- c(retGraph$iGraph, intersectionGraph$iGraph)
        retGraph$adjMat <- c(retGraph$adjMat, intersectionGraph$adjMat)
        
        png(networkPlot2b, width = 800, height = 800)
        functionalNetwork(tablesGenes, plotType="bipartite", plotOutput="static", vLayout="circle", vSize=vSize, vLabelCex=vLabelCex, legendPrefix=grPrefix, geneExpr=geneExpr, plotExpression=plotExpression,plotTitle=paste("Genes in several ", tolower(grType), "s", sep=""))
        dev.off()
    }
    
    if(length(termsMultipleMg)>0)
    {
        png(networkTerms, width = 800, height = 800)
        functionalNetwork(tablesTerms, plotType="bipartite", plotAllMg=FALSE, vSize=vSize, vLabelCex=vLabelCex, legendPrefix=grPrefix, plotTitle=paste("Terms in several ", tolower(grType), "s", sep="")) 
        dev.off()
    }
    
    png(distancePlot, width = 600, height = 600)
    distanceMatrix <- clustersDistance(tablesGenes, colores)
    dev.off()

    iGraph<-retGraph$iGraph
    save(iGraph, file=iGraphFile)
    adjMat<-retGraph$adjMat
    save(adjMat, file=adjMatFile)
    
    #####################################################################################################
    #################################### Create HTML  ###################################################
    p=openPage(htmlFileName, link.css=paste(folder, "functionalNetworks.css", sep=""))
    
    # Header
    hwrite('Functional Gene Networks', p, heading=1)
    
     # Query parameters
    createHTML_FEA_header(p, tool, queryArgs, feaResults, folder)
    
    # Results header                
    hwrite("Results: ", p, heading=2)
    
    #hwrite("Basic stats: ", p, br=TRUE)
    hwrite(paste("Number of ",tolower(grType),"s: ",sep=""), p, class='InfoLabel', br=FALSE)
    hwrite(nRawMg, p, br=TRUE)
    hwrite(paste("Number of genes included in all ",tolower(grType),"s: ",sep=""), p, class='InfoLabel', br=FALSE)
    hwrite(nGenesTotal, p, br=TRUE)
    hwrite(paste("Number of genes included in non-filtered ",tolower(grType),"s: ",sep=""), p, class='InfoLabel', br=FALSE)
    hwrite(nGenesInNotFilteredMg, p, br=TRUE)
    hwrite(paste("Filtered ",tolower(grType),"s ",sep=""), p, class='InfoLabel', br=FALSE)
    if(!is.na(filterAttribute)) hwrite(paste(" (", filterAttribute, " ",filterOperator, " ", filterThreshold, ")", sep=""), p, br=FALSE)
    hwrite(": ", p, br=FALSE)
    if(length(filteredOut)>0)  hwrite(paste(grPrefix, filteredOut, sep="", collapse=", "), p, br=TRUE) 
    else hwrite("None", p, br=TRUE) 

    hwrite("<br/>Exports: ", p, br=TRUE)
    hwrite("Functional network: ", p)
    #if(!is.null(pdfName)) hwrite('[PDF] ', p, link=paste(pdfName, sep="" ), br=FALSE)
    hwrite("iGraph (.RData)", p, link=paste(folder,iGraphFile, sep="" ), br=FALSE)
    hwrite(", ", p)
    hwrite("adjacency matrices (.RData)", p, link=paste(folder,adjMatFile, sep="" ), br=TRUE)
    
    if(grType != "Gene-term set")
    {
        hwrite(paste("Simplified ", tolower(grType),"-terms table (shown below): ",sep=""), p)
        hwrite(simplifiedTable, p, link=paste(folder,simplifiedTable, sep="" ), br=FALSE)
    }
    
    # Functional Network plot
    hwrite("Functional Network: ", p, heading=3)
    subImages <- ""
    closeButton <- '<a href="#close" title="Close" class="close">X</a>'
    if(!is.null(intersectionGraph))
    {        
        subImages <- c(hwrite(paste('Genes in several ', tolower(grType),'s: ', sep=""), class='InfoLabel', br=TRUE),
                         hwrite('(Different layouts)'),
                         
                         hwriteImage(paste(folder,networkPlot2a,sep=""), class='intersectionNw', link='#nwIntersection_kk', br=FALSE),
                         hwrite(paste('<div id="nwIntersection_kk" class="modalDialog"><div>',closeButton, '<img border="0" src="',folder,networkPlot2a,'" width="100%"></div></div>', sep="")),
                                                              
                         hwriteImage(paste(folder,networkPlot2b,sep=""), class='intersectionNw', link='#nwIntersection_circle', br=FALSE),
                         hwrite(paste('<div id="nwIntersection_circle" class="modalDialog"><div>',closeButton, '<img border="0" src="',folder,networkPlot2b,'" width="100%"></div></div>', sep="")))

        
        if(length(termsMultipleMg)>0) 
        {
            subImages <- c(subImages,
                         hwrite(paste('Terms in several ', tolower(grType),'s: ', sep=""), class='InfoLabel', br=TRUE),
                         hwrite('(Marked with * in the table)'),
                         hwriteImage(paste(folder,networkTerms,sep=""), class='intersectionNw', link='#nwTerms', br=FALSE),
                         hwrite(paste('<div id="nwTerms" class="modalDialog"><div>',closeButton, '<img border="0" src="',folder,networkTerms,'" width="100%"></div></div>', sep="")))
        }
    
    }
    imageTable <- c(hwriteImage(paste(folder,networkPlot,sep=""), class='network', link='#functionalNetwork', br=FALSE),
                                    hwrite(paste('<div id="functionalNetwork" class="modalDialog"><div>',closeButton, '<img border="0" src="',folder,networkPlot,'" width="100%"></div></div>', sep="")),
                                    hwrite(subImages, border=0, dim=c(length(subImages),1), class="ImageTable"))
    hwrite(c(imageTable), p, border=0, class="ImageTable")
    
    clustSectionHeader <- ""
    #if(sortMG) clustSectionHeader <- paste(" (sorted by ",filterAttribute,")", sep="")
    clustSectionHeader <- paste(grType, "s", clustSectionHeader,": ", sep="")
    
    hwrite(clustSectionHeader, p, heading=3, br=FALSE)
    showHideTerms <- '<span id="switchTerms" class="switcher switchTerms"></span><span id="contentTerms">'
    hwrite(showHideTerms, p, br=TRUE)
        
    # Terms table
    termsTable <- NULL
    txtTermsTable <- NULL
    goLinks <- goLinks[names(termsTables$termLinks)]
    for(mg in 1:length(termsTables$termLinks))
    {
        mgName <- paste("<b>",names(termsTables$termLinks)[mg],"</b>")
        attrs <- NULL
        if(tool=="GeneTerm Linker")
        {
            attrs <- c(paste("Silhouette: ", round(globalMetagroups[mg, "Silhouette Width"], 2), sep=""),
                                 paste("P-value: ", signif(globalMetagroups[mg, "pValue"],2),sep=""))        
        }        
        # if(tool=="DAVID")
        # {    
        #     attrs <- c(paste("Score: ", signif(as.numeric(as.character(globalMetagroups[mg, "ClusterEnrichmentScore"])),2),sep=""),
        #                          "","")
        # }    
        if(tool=="topGO")
        {    
            pVal <- signif(as.numeric(gsub("< ", "", as.character(globalMetagroups[mg, "classic"]))),2)                
            attrs <- c("", # "Silhouette  only in GtLinker
                       paste("Num annotated: ", signif(as.numeric(as.character(globalMetagroups[mg, "Annotated"])),2),sep=""),
                       paste("P-val: ", pVal, sep=""))
        }    
        if(tool=="gage")
        {    
#            attrs <- c("", # "Silhouette  only in GtLinker
#                        paste("Score: ", signif(as.numeric(as.character(globalMetagroups[mg, "EnrichmentScore"])),2),sep=""),
#                        paste("minPval: ", signif(as.numeric(as.character(globalMetagroups[mg, "minPval"])),2),sep=""))
        }    
        
        tmpGenes <- sort(unlist(strsplit(as.character(globalMetagroups[mg, "Genes"]), ",")))
        if(!is.null(geneExpr))
        {
            ngUP <- sum(geneExpr[tmpGenes]>0, na.rm=TRUE)
            ngDW <- sum(geneExpr[tmpGenes]<0, na.rm=TRUE)
        }
        nGenes <- length(tmpGenes)
        tmpGenes <- paste(tmpGenes, collapse=", ")
        linkGenes <- paste("Genes: ", '<a title="', tmpGenes,'" class="tooltip"><span title="Genes">', nGenes, '</span></a>',sep="")             #href="#close"
        if(!is.null(geneExpr)) 
        {
                linkGenes <- paste(linkGenes, " (", sep="")
                if(ngUP>0) linkGenes <- paste(linkGenes, ngUP, "up", sep="")
                if(ngUP>0 && ngDW>0) linkGenes <- paste(linkGenes, ",", sep="")
                if(ngDW>0) linkGenes <- paste(linkGenes, ngDW, "dw", sep="")
                linkGenes <- paste(linkGenes, ")", sep="")
        }
        txtGenes <- paste(nGenes, " genes: ", tmpGenes, sep="")
        attrsTxt <- c(attrs, txtGenes)
        attrs <- c(attrs, linkGenes)                     
        
        treesLink <- ""
        if(!is.null(goLinks[[mg]]) && all(!is.na(goLinks[[mg]])))
        {
            treesLink <- paste("<div id='thumbnail'>") 
            for(db in names(goLinks[[mg]]))
            {
                if(!is.null(goLinks[[mg]][[db]]))    treesLink <- paste(treesLink, paste("<a href='",goLinks[[mg]][[db]],"'>[",db, "]<img src='",goLinks[[mg]][[db]],"'/></a>", sep=""), collapse=" ")        
            }
            treesLink <- paste(treesLink, "</div>")
            treesLink <- cbind("<div style='text-align:right'>GO terms tree: </div>",treesLink)
        }
        terms <- rbind(termsTables$termLinks[[mg]], treesLink)
        dimnames(terms) <- NULL
        
        termsTable <- c(termsTable, hwrite(c(mgName, attrs), class='mgAttr', table=TRUE, border=0), 
                                        hwrite(terms, table=TRUE, col.class=list("termsRow", "annotRow")))
        txtTermsTable <- rbind(txtTermsTable, paste(c(names(termsTables$noLinks)[mg], attrsTxt), collapse="\t"), rbind(termsTables$noLinks[[mg]]))
    }
    
    #bgCols <- c(strsplit(paste(substr(colores, 1, 7)[rownames(globalMetagroups)], "#FFFFFF", collapse=" "), split=" ")[[1]],"#FFFFFF")
    borderCols <- paste('border-color:', strsplit(paste(substr(colores, 1, 7), substr(colores, 1, 7), collapse=" "), split=" ")[[1]], sep="") #x2
    hwrite(termsTable, p, border=1, class=rep(c('mgHeader', 'Terms'), length(termsTable)/2), row.style=borderCols, dim=c(length(termsTable),1))
    
    # Explanation of asterisc (there are terms in several metagroups):
    if(length(termsMultipleMg)>0) 
    {
        hwrite(paste("<i>* Terms marked with an asterisc are in several ", tolower(grType),"s.</i>", sep=""), p, br=TRUE)
        #hwriteImage(networkTerms, p, link=c(networkTerms), br=TRUE,border=0)    
    } else {
        hwrite(paste("<i>(There are no terms in more than one ", tolower(grType),")</i>", sep=""), p, br=TRUE)
    }

    if(!is.null(boldTerms) && (tool=="gage")) hwrite(paste("Bold indicates <i>essential</i> term.", sep=""), p, br=TRUE)


    hwrite('</span>', p, br=TRUE) # Section end (Terms table)
    
    
    if(!is.null(goTrees_global) && all(goTrees_global!=""))
    {
        
        goTreesImages <- sapply(goTrees_global$fileNames[[1]], function(image) hwriteImage(image, link=image, br=FALSE, class="GoTreesGlobal"))
        
        hwrite(paste('Global GO trees:', sep=""), p, class='InfoLabel', br=TRUE)
        hwrite(goTreesImages, p, border=0, dim=c(1,length(goTreesImages)), class="ImageTable")    
    }

    hwrite("Network analysis: ", p, heading=3, br=FALSE)
    hwrite('<span id="switchNwAnalysis" class="switcher switchNwAnalysis"></span><span id="contentNwAnalysis">', p, br=FALSE)
    
    hwriteImage(paste(folder,nwStatsPlot,sep=""), p, class='nwStats', link=paste(folder,nwStatsPlot,sep=""), br=TRUE)
    
    hwrite("<br><b>Potential inter-modular hubs (top betweenness in whole network):</b> ", p, br=TRUE)
    hwrite(paste(nwStats$hubsList$Global, collapse=", "), p, br=TRUE)
    
    hwrite(paste("<br><b>Potential intra-modular hubs (top betweenness within each ", tolower(grType),"):</b>", sep=""), p, br=TRUE)
    intraModularHubs <- nwStats$hubsList[names(nwStats$hubsList)!="Global"]
    # Lista
    # hwrite("Hub list:", p, br=TRUE)
    sapply(names(intraModularHubs), function(cl)
    {
        if(length(intraModularHubs[[cl]])>0) hwrite(paste(grType, " ", cl, ": ",paste(intraModularHubs[[cl]], collapse=", "), sep=""), p, br=TRUE)
    })

    # Comunes
    if(length(nwStats$intraHubsCount)>0) 
    {
        hwrite("<br>Most common possible hubs: ", p, br=FALSE)
        hwrite(names(nwStats$intraHubsCount), p,border=0, class='matrix', br=TRUE)
    }else{
        hwrite("(There are no hubs in more than one cluster)", p, br=TRUE)
    }
    #hwrite(nwStats$hubs, p, table=TRUE, border=0, class='matrix', br=TRUE)

    # Clustering coeficient. 
    hwrite("<br><b>Clustering coeficient / Transitivity:</b> ", p, br=TRUE)
    hwrite('<div class="transitivity">', p, br=FALSE)
    hwrite(as.matrix(round(nwStats$transitivity, digits=3)), p, table=TRUE, border=0, br=TRUE)
    hwrite('</div>', p, br=FALSE)  
    hwrite("(The functional network is based on two networks/incidence matrices: <i>common clusters</i> and <i>common-gene-term-sets</i>. These are their transitivity values -probability that adjacent vertices of a vertex are connected-.)", p, br=TRUE)
    
    hwrite('</span>', p, br=TRUE)  # Section end (contentNwAnalysis)
    
    # Distances Plot    
    if(!is.null(distanceMatrix))
    {   
        hwrite(paste("Distances between ", grType,"s: ", sep=""), p, heading=3, br=FALSE)
        hwrite('<span id="switchTerms" class="switcher switchTerms"></span><span id="contentTerms">', p, br=FALSE)
        
        colnames(distanceMatrix) <- paste(grPrefix, colnames(distanceMatrix), sep="")
        rownames(distanceMatrix) <- paste(grPrefix, rownames(distanceMatrix), sep="")
        distanceMatrix <- round(distanceMatrix,2)
        
        if(ncol(distanceMatrix) < 25) 
        {
            subImages <- c(hwrite('Distance matrix: ', class='InfoLabel', br=TRUE),
                                     hwrite(distanceMatrix, table=TRUE, border=0, class='matrix', br=FALSE))
        }else{
            subImages <- ""
        }
        imageTable <- c(hwriteImage(paste(folder,distancePlot,sep=""), class='distance', link=paste(folder,distancePlot,sep=""), br=TRUE), hwrite(subImages, border=0, dim=c(length(subImages),1)))
        
        hwrite(c(imageTable), p, table=TRUE, border=0) #, class="ImageTable"
        hwrite('</span>', p, br=TRUE)  # Section end (Distances)
    }
    closePage(p)
    
    write.table(txtTermsTable, file=simplifiedTable, row.names=FALSE, col.names=FALSE, quote=FALSE)
    
    browseURL(htmlFileName) # Open html
}

# Version 2.1, ADDED: geneExpr=NULL,plotExpression=c("border","fill")
# Quitar: metagroupAttribute=NULL --> columnas en metagroupsMatrix: ordenadas por el atributo
#   vertexLayout:  previous Vlayout (para todos) o  "kk", "circle"...etc: Solo se usa en intersection. 


# functionalNetwork:
# bgTransparency=0.4
# eColor="#323232"
# weighted=FALSE
# 
# intersectionNetwork 
# keepAllNodes=FALSE     # if(!keepAllNodes) genesInManyMg <- which(apply(metagroupsMatrix, 1, sum)>1)
# plotAllMg=FALSE


functionalNetwork <- function(incidMatrices, plotType=c("default", "bipartite")[1], plotOutput="static", plotTitle="Functional Network", plotTitleSub=NULL, legendPrefix=NULL, legendText=NULL,  geneExpr=NULL, plotExpression=c("border","fill"), vExprColors=c(neg="#008000", zero="white", pos="#FF2020"), vSize=12, vLabelCex=2/3, vLayout=NULL,keepColors=TRUE, bgTransparency=0.4, eColor="#323232", eWidth=NULL, weighted=FALSE, keepAllNodes=FALSE, plotAllMg=FALSE)
{    
    #####################################################################################################
    ########################### Check & initialize arguments ############################################
    filteredOut <- NULL
    gtSetsMatrix <- NULL
    
    if(!any(plotType %in% c("default", "bipartite"))) stop('plotType should be "default" or "bipartite.')
    # incidMatrices
     grType <- "Cluster"
     if(is.list(incidMatrices) && ("metagroupsMatrix" %in% names(incidMatrices)))   grType <- "Metagroup"
    if(is.matrix(incidMatrices)) metagroupsMatrix <- incidMatrices
    if(is.list(incidMatrices) && any(c("metagroupsMatrix", "clustersMatrix") %in% names(incidMatrices)))
    {
        if("metagroupsMatrix" %in% names(incidMatrices)) metagroupsMatrix <- incidMatrices$metagroupsMatrix
        if("clustersMatrix" %in% names(incidMatrices)) metagroupsMatrix <- incidMatrices$clustersMatrix
        if("gtSetsMatrix" %in% names(incidMatrices))  gtSetsMatrix <- incidMatrices$gtSetsMatrix
        if("filteredOut" %in% names(incidMatrices))   filteredOut <- incidMatrices$filteredOut
    }
    if(is.matrix(metagroupsMatrix) && is.null(gtSetsMatrix))
    {
        gtSetsMatrix <- metagroupsMatrix
        filteredOut <- NULL
        
        #warning("Only metagroupsMatrix provided.")
        if(plotTitle=="Functional Network") plotTitle <- "Metagroups Network"
    }    
    if(!is.matrix(metagroupsMatrix))  stop("metagroupsMatrix not valid. 'incidMatrices' should be the result returned by toMatrix().")
    if(!is.matrix(gtSetsMatrix))  stop("gtSetsMatrix not valid. 'incidMatrices' should be the result returned by toMatrix().")

    # plotOutput
    if(!is.character(plotOutput))  stop('plotOutput should be either "static", "dynamic" or "none".') 
    plotOutput <- tolower(plotOutput)
    if(!plotOutput %in% c("static", "dynamic", "none")) stop('plotOutput should be in "static", "dynamic" or "none".') 

    # plotTitle & plotTitleSub
    if(!is.character(plotTitle)) stop("plotTitle should be character.")
    if(!is.null(plotTitleSub) && !is.character(plotTitleSub)) stop("plotTitle should be character.")
    if(is.null(plotTitleSub))
    {
        plotTitleSub <- setNames(c("","Intersection network"), c("default","bipartite"))[plotType]     ### TO DO? (if keep all nodes... also intersection??)
    }
    
    # legendText & legendPrefix
    plotLegend <- TRUE
    if(is.logical(legendText) && legendText==FALSE)
    {
        plotLegend <- FALSE
        legendText <- NULL
    }
    if(!is.null(legendText))
    {
        if(!is.character(legendText)) stop("legendText should be a character vector containing the description of each cluster.")
        if(ncol(metagroupsMatrix) != length(legendText)) stop("The number of clusters/metagroups in the matrix and the legend do not match.")
        if(plotType=="default") legendText <- paste(": ", legendText, sep="")
    }    
    
    if(is.null(legendPrefix))
    {
        data("groupTypes", envir = environment())
        groupTypes<- get("groupTypes", envir  = environment())
        legendPrefix <- groupTypes[grType, "prefix"]
    }
    if(!is.character(legendPrefix)) stop("legendPrefix should be character.")
    
    ## Expression
    if(!is.null(geneExpr) && !is.numeric(geneExpr)) stop('geneExpr should be a numeric vector.')
    if(!is.character(plotExpression)) stop("plotExpression should be either 'border' or 'fill'.")
    plotExpression <- tolower(plotExpression[1])
    if(!plotExpression %in% c("border","fill")) stop("plotExpression should be either 'border' or 'fill'.")
    if(length(vExprColors)!=3) stop("vExprColors should be a character vector of length 3: colors for negative, zero and positive values.")
    if(is.null(names(vExprColors))) names(vExprColors) <- c("neg", "zero", "pos")
    # Other plot options
    if(!is.numeric(vSize))  stop("vSize should be numeric.")
    if(!is.numeric(vLabelCex))  stop("vLabelCex should be numeric.")
    if(!is.logical(keepColors)) stop("keepColors should be TRUE or FALSE")
    
    # Specific options
    if("default" %in% plotType)
    {
        if(!is.null(bgTransparency) && !is.numeric(bgTransparency))  stop("bgTransparency should be numeric.")
        if(!is.logical(weighted)) stop("weighted should be either TRUE or FALSE.")
        
        if(!is.null(vLayout) && (!is.matrix(vLayout) || (dim(vLayout)[2] != 2))) stop("Non-valid layout.")
    }
    
    #####################################################################################################
    ####################################  Plot settings  ################################################
    nGenes <- dim(metagroupsMatrix)[1]
    nMetagroups <- dim(metagroupsMatrix)[2]
    
    # In case of term nodes keep only their description as label
    if(grepl(":", rownames(metagroupsMatrix)[1]))
    {
        clMgMxNames <- clDescriptions(rownames(metagroupsMatrix))
        rownames(metagroupsMatrix) <- paste(clMgMxNames[,"TermDescription"], " (", clMgMxNames[,"Annotation"], ")", sep="")
        
        clGtSetMxNames <- clDescriptions(rownames(gtSetsMatrix))
        rownames(gtSetsMatrix) <- paste(clGtSetMxNames[,"TermDescription"], " (", clGtSetMxNames[,"Annotation"], ")", sep="")
    }
    
    ######## Set cluster color
    if(any(is.na(suppressWarnings(as.numeric(filteredOut))))) keepColors<- FALSE
    if(keepColors==TRUE)
    {
        if(all(!is.na(suppressWarnings(as.numeric(colnames(metagroupsMatrix))))))
        {
            allMgSorted <- as.character(sort(as.numeric(c(colnames(metagroupsMatrix), filteredOut))))
            allMgNotSorted <- as.character(as.numeric(colnames(metagroupsMatrix)))
        } else {
            allMgSorted <- sort(as.character(c(colnames(metagroupsMatrix), filteredOut)))
            allMgNotSorted <- as.character(colnames(metagroupsMatrix))
        }
        colores <- setColors(allMgSorted)[allMgNotSorted]
        trCols <- setColors(allMgSorted, transparency=bgTransparency)[allMgNotSorted]
    }else
    {
        colores <- setColors(colnames(metagroupsMatrix))
        trCols <- setColors(colnames(metagroupsMatrix), transparency=bgTransparency)
    }
    
    # Set colors for Nodes in only a group 
    vColor <- apply(metagroupsMatrix, 1, function(x) {
        if (sum(x) != 1)  return("#FFFFFF")
        else
        {
            return(colores[which(x ==1)])
        }
    })
    # Metagroup background color
    markGroup <- apply(metagroupsMatrix, 2, function(x) which(x==1))
    if(!is.list(markGroup))
    {
        if(!is.matrix(markGroup))  # in case of only one gene/term per metagroup
        {
            markGroup <- t(as.matrix(markGroup)) #  if(ncol(metagroupsMatrix)>1) ?
        }        
        markGroup <- split(markGroup, rep(1:ncol(markGroup), each = nrow(markGroup))) #in case of same number of vertex in each group...
    }
    
    #######################################################
    # Set color for expression
    if(!is.null(geneExpr))
    {
        geneExpr <- geneExpr[rownames(gtSetsMatrix)] # Subset, in case the whole eset was provided
        
        vExpr <- rep("#888888", length(geneExpr)) # Grey
        names(vExpr) <- names(geneExpr)  

        if(plotExpression == "fill")
        {
            vExprColorsRGB <- col2rgb(vExprColors, alpha = FALSE)/255
            vExpr[which(geneExpr == 0)] <- "white"
#             if(any(geneExpr < 0,na.rm=TRUE))   vExpr[which(geneExpr < 0)]  <- color.scale( geneExpr[which(geneExpr < 0)], cs1=c(0,1), cs2=c(0.5,1),cs3=c(0,1),alpha=1, xrange=range(min(geneExpr,na.rm=TRUE),0))
#             if(any(geneExpr > 0,na.rm=TRUE))   vExpr[which(geneExpr > 0)]  <- color.scale( geneExpr[which(geneExpr > 0)], cs1=c(1,1), cs2=c(1,0),cs3=c(1,0), alpha=1, xrange=range(0, max(geneExpr,na.rm=TRUE)))
            if(any(geneExpr < 0,na.rm=TRUE))   
            {
                if(length(table(geneExpr[which(geneExpr < 0)]))==1)
                {
                    vExpr[which(geneExpr < 0)] <- vExprColors["neg"]            
                }else
                {
                    vExpr[which(geneExpr < 0)] <- color.scale(geneExpr[which(geneExpr < 0)], cs1=vExprColorsRGB["red",c("neg","zero")], cs2=vExprColorsRGB["green",c("neg","zero")], cs3=vExprColorsRGB["blue",c("neg","zero")], alpha=1, xrange=range(min(geneExpr,na.rm=TRUE),0))                   
                }
            }
            if(any(geneExpr > 0,na.rm=TRUE))  
            {
                if(length(table(geneExpr[which(geneExpr > 0)]))==1)
                {
                    vExpr[which(geneExpr > 0)] <- vExprColors["pos"]            
                }else
                {
                    vExpr[which(geneExpr > 0)]  <- color.scale( geneExpr[which(geneExpr > 0)], cs1=vExprColorsRGB["red",c("zero","pos")], cs2=vExprColorsRGB["green",c("zero","pos")], cs3=vExprColorsRGB["blue",c("zero","pos")], alpha=1, xrange=range(0, max(geneExpr,na.rm=TRUE)))
                }
            }
                
            vColor <- vExpr
        }
        if(plotExpression == "border")
        {
            # Expresion en borde de nodo. 
            ##### Borde aparte (2 plots: back-expresion, front-mg)
            vExpr[which(geneExpr == 0)]  <- vExprColors["zero"]
            vExpr[which(geneExpr > 0)]  <-  vExprColors["pos"] # "#FF4949"
            vExpr[which(geneExpr < 0)]  <-  vExprColors["neg"] #"#008000"
        }
    } else { 
        vExpr <- "#888888" 
        plotExpression <- FALSE        
    }
    
## RECOLOCAR:     geneExpr[]
# PARA default: V(graphCommonGTsets)$name
# Para bipartite: V(....)$name    

    
    
    ########################################
    # Plots: 
    ret <- NULL
    if("default" %in% plotType)
    {
        ret <- plotFGNet_default(metagroupsMatrix, gtSetsMatrix, vLayout=vLayout, plotOutput=plotOutput, plotExpression=plotExpression, eWidth=eWidth, eColor=eColor, vColor=vColor,
                            vExpr=vExpr, vSize=vSize, vLabelCex=vLabelCex, colores=colores,markGroup=markGroup, trCols=trCols, weighted=weighted,
                            plotTitle=plotTitle, plotTitleSub=plotTitleSub, plotLegend=plotLegend, legendPrefix=legendPrefix, legendText=legendText)
    }
    
    if("bipartite" %in% plotType)
    {
        ret_bipartite <- plotFGNet_bipartite(metagroupsMatrix=metagroupsMatrix, keepAllNodes=keepAllNodes,plotAllMg=plotAllMg, vLayout=vLayout, plotOutput=plotOutput, plotExpression=plotExpression, eWidth=eWidth, eColor=eColor,  vColor=vColor,
                  vExpr=vExpr, vSize=vSize, vLabelCex=vLabelCex, colores=colores, 
                  plotTitle=plotTitle, plotTitleSub=plotTitleSub, plotLegend=plotLegend, legendPrefix=legendPrefix, legendText=legendText)
        
        if(is.null(ret)) # Merge with default
        {
            ret <- ret_bipartite
        }else
        {
            ret$iGraph <- c(ret$iGraph, ret_bipartite$iGraph)
            ret$adjMat <- c(ret$adjMat, ret_bipartite$adjMat)
        }
    }
    invisible(ret)
}

# Used by createHTML and clustersTable
# nChar number of characters to show (trims the result)
# i.e. termsDescriptions <- getTerms(results)
keywordsTerm <- function(termsDescriptions, nChar=30)
{    
    if(!is.list(termsDescriptions)) termsDescriptions <-list(termsDescriptions)
    if(ncol(termsDescriptions[[1]]) > 1) termsDescriptions <- lapply(termsDescriptions, function(x) cbind(x[,"TermDescription", drop=FALSE]))
    
    # Search for a representative term (based only on key words! not function!)
    reprTerms <- rep(NA, length(termsDescriptions))
    for(index in 1:length(termsDescriptions))
    {        
        termsMg <- termsDescriptions[[index]]
        
        rownames(termsMg) <- NULL
        splittedTerms <- unlist(strsplit(termsMg, " "))
        #splittedTerms <- unlist(strsplit(splittedTerms, "-", fixed=TRUE))
        splittedTerms <- unlist(strsplit(splittedTerms, "/", fixed=TRUE))
        splittedTerms <- unlist(strsplit(splittedTerms, ",", fixed=TRUE))
        splittedTerms <- unlist(strsplit(splittedTerms, ".", fixed=TRUE))
        splittedTerms <- unlist(strsplit(splittedTerms, "(", fixed=TRUE))
        splittedTerms <- unlist(strsplit(splittedTerms, ")", fixed=TRUE))
        
        sortedFreq <- sort(table(tolower(splittedTerms)), decreasing=TRUE)
        
        commonWords <- sortedFreq[sortedFreq >= quantile(sortedFreq, 0.9)]
        commonWords <- commonWords[grepl("[[:alnum:]]", names(commonWords))]
        
        selectedTerm <- NULL
        if(any(tolower(termsMg) %in% names(commonWords)))
        {
            selectedTerm <- names(commonWords)[which(names(commonWords) %in% tolower(termsMg))[1]] # Select the one with highest freq.
            
            if(commonWords[1] >= commonWords[selectedTerm]*2) selectedTerm <- NULL     
            selectedTerm <- capitalize(selectedTerm)
        }
        if(is.null(selectedTerm))
        {
            termsWithCommonWords <- sapply(names(commonWords), function(x) grep(x, tolower(termsMg)))
            countTermsWords <- table(unlist(termsWithCommonWords)) #Number of common words per term        
            selectedTerms <- termsMg[as.numeric(names(countTermsWords[countTermsWords == max(countTermsWords)])),] # Terms with most common words
            ncharTerms <- nchar(selectedTerms)
            selectedTerm <- selectedTerms[ncharTerms==min(ncharTerms)][1]
        }
        
        reprTerms[index] <- selectedTerm
        if(nchar(reprTerms[index])>nChar) reprTerms[index] <- paste(substr(reprTerms[index], 1, nChar), "-", sep="")
    }
    if(!is.null(names(termsDescriptions))) names(reprTerms) <- names(termsDescriptions)
    return(reprTerms)
}

\name{FGNet_report}
\alias{FGNet_report}
\alias{report_gtLinker}
\alias{report_david}
\title{
FGNet report
}
\description{
Generates an HTML report with several views of the Functional Network and complementary analyses.
}
\usage{
FGNet_report(feaResults, geneExpr = NULL, plotExpression = "border", 
onlyGoLeaves = TRUE, plotGoTree = TRUE, 
filterAttribute = NULL, filterOperator = NULL, filterThreshold = NULL)
}
\arguments{
  \item{feaResults}{
list or data.frame/matrix. Output from one of the FEA functions.
}
  \item{geneExpr}{
numeric. Named vector with the relative expression value of the gene (node). 0 is taken as reference, positive values will be plotted red, negative values green.
}
  \item{plotExpression}{
character. Determines the way to plot the expression: "border" adds a red or green border to the node, "fill" colors the whole with the expression color instead of the metagroup color.
}
  \item{onlyGoLeaves}{
logical. If TRUE only terminal GO terms (leaves in the ontology tree) will be included in the cluster list.
}
  \item{plotGoTree}{
logical. If TRUE plots containing the terms in their position within the GO ontology (tree) will be generated.
}
  \item{filterAttribute}{
character or data.frame. Attribute to filter the clusters/metagroups. Filtered clusters/metagroups will not be included in the matrices (and subsequent networks).
Its value should be the data.frame column to use for filtering. It can be provided as character (column name) or data.frame (subset of the data.frame with drop=FALSE).
}
  \item{filterOperator}{
character. Logical operator used for filtering. i.e. ">" (bigger than), "<=" (smaller or equal than), "==" (equal), "!=" (different), "\%\%" (included in),... 
The evaluation order is left to right: filterAttribute ">" filterThreshold, will filter out clusters with filter attribute bigger than the threshold.
}
  \item{filterThreshold}{
numeric. Sets the value to compare to.
}
}
\value{
Generates the HTML report in the current directory.
}
\section{Warning}{
Reactome ID change depending on the database version. Links to reactome website are created to ease the analysis, but in case the version used for the enrichment and the website's do not match, broken links or misleading links might appear.  
}

\seealso{
Functional enrichment analysis functions:
\itemize{
    \item{\code{\link[FGNet:fea_gtLinker]{fea_gtLinker()}} & \code{fea_gtLinker_getResults()}
          (Requires internet connection)}
    \item{\code{\link[FGNet:fea_gage]{fea_gage()}}}
    \item{\code{\link[FGNet:fea_topGO]{fea_topGO()}} 
    
   To import results from a previous/external FEA analysis: \code{\link[FGNet:format_david]{format_david()}}, \code{format_results()} and \code{\link[FGNet:readGeneTermSets]{readGeneTermSets()}}.}
}


Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}
\examples{
\dontrun{

# Report with diferent tools:

##########################
# DAVID & TopGO
geneList <- c("YBL084C", "YDL008W", "YDR118W", "YDR301W", "YDR448W", "YFR036W", 
    "YGL240W", "YHR166C", "YKL022C", "YLR102C", "YLR115W", "YLR127C", "YNL172W", 
    "YOL149W", "YOR249C")
geneExpr <- setNames(c(rep(1,10),rep(-1,5)), geneList) 

library(org.Sc.sgd.db)
geneLabels <- unlist(as.list(org.Sc.sgdGENENAME)[geneList])
names(geneExpr) <- geneLabels[names(geneExpr)] 

# DAVID
results_David <- fea_david(geneList, geneLabels=geneLabels, email="example@email.com")
FGNet_report(results_David, geneExpr=geneExpr) 

# TopGO
results_topGO <- fea_topGO(geneList, geneIdType="ENSEMBL", 
    geneLabels=geneLabels, organism="Sc") 
FGNet_report(results_topGO, geneExpr=geneExpr)   

##########################
# Gage
library(gage); data(gse16873)
results_gage <- fea_gage(eset=gse16873, 
    refSamples=grep('HN',colnames(gse16873), ignore.case =T), 
    compSamples=grep('DCIS',colnames(gse16873), ignore.case=T), 
    geneIdType="ENTREZID", organism="Hs", annotations="REACTOME")
FGNet_report(results_gage)

##########################
# Gene-Term Linker: 

# Execute new query:
genesYeast <- c("ADA2", "APC1", "APC11", "APC2", "APC4", "APC5", "APC9", 
     "CDC16", "CDC23", "CDC26", "CDC27", "CFT1", "CFT2", "DCP1", "DOC1", "FIP1", 
     "GCN5", "GLC7", "HFI1", "KEM1", "LSM1", "LSM2", "LSM3", "LSM4", "LSM5", 
     "LSM6", "LSM7", "LSM8", "MPE1", "NGG1", "PAP1", "PAT1", "PFS2", "PTA1", 
     "PTI1", "REF2", "RNA14", "RPN1", "RPN10", "RPN11", "RPN13", "RPN2", "RPN3", 
     "RPN5", "RPN6", "RPN8", "RPT1", "RPT3", "RPT6", "SGF11", "SGF29", "SGF73", 
     "SPT20", "SPT3", "SPT7", "SPT8", "TRA1", "YSH1", "YTH1")
# Optional expression (1=UP, -1=DW):
genesYeastExpr <- setNames(c(rep(1,29), rep(-1,30)), genesYeast)


jobID <- fea_gtLinker(geneList=genesYeast,organism="Sc")

# Load existing query:
jobID <- 3907019

results_gtLinker <- fea_gtLinker_getResults(jobID=jobID)
FGNet_report(results_gtLinker, geneExpr=genesYeastExpr)


}
}

\name{readGeneTermSets}
\alias{readGeneTermSets}
\title{
Read gene-term sets
}
\description{
Reads a file containing gene-term sets (formatted output from FEA) and transform it into clusters/metagroups and geneTermSets tables to imput to FGNet.
}
\usage{
readGeneTermSets(fileName, tool = NULL, simplifyGage = TRUE)
}
\arguments{
  \item{fileName}{
character. File name of the .txt file.
}
  \item{tool}{
character. Tool used for the FEA (row name from \code{data(FEA_tools); FEA_tools})
}
  \item{simplifyGage}{
logical. Only for GAGE: Wether to simplify the results and keep only the essential terms in the clustes.
}
}
\value{
List formated in the same way as the \link[FGNet:fea_gtLinker]{fea} functions. 
}
\seealso{
Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}

}

\name{format_david}
\alias{format_david}
\alias{getResults_david}
\title{
Format DAVID output
}
\description{
Format DAVID 'functional annotation and clustering' output to use with FGNet.
}
\usage{
format_david(fileName, 
jobName = NULL, 
geneLabels = NULL, 
moveFile = FALSE, 
downloadFile=TRUE)
}
\arguments{
  \item{fileName}{
character. URL or local file with the results of a DAVID analysis, for example, performed at DAVID's Website (\url{http://david.abcc.ncifcrf.gov/summary.jsp}).
In case of local file, it should be the absolute path to the .txt file (whole location from root to the file including file name: "C:\\\\Documents\\\\23424203.txt", "/home/user/2342342.txt").
}
  \item{jobName}{
character. Folder name and prefix for the formatted files.
}
\item{geneLabels}{
named character vector. Gene name or label to use in the report/plots instead of the original gene ID. The vector names should be the gene ID and the content of the vector the gene label. The resulting geneTermSets table will contain the original gene ID column (geneIDs) and the label column (Genes).
}
\item{moveFile}{  
logical. If TRUE the original file is moved to the new location. If FALSE, the file is copied.
}
  \item{downloadFile}{
logical. If TRUE, the result files are saved in the current directory (required to generate report).
}
}
\value{
\link[base:invisible]{Invisible} list with the folowing fields:\cr
\code{queryArgs } list with the arguments for the query.

\code{clusters } data.frame containing the clusters and their information:
\itemize{ 
    \item Cluster: Cluster ID.
    \item nGenes: Number of genes in the cluster.
    \item ClusterEnrichmentScore: Score for the cluster.
    \item Genes: Genes in the cluster.
    \item Terms: Terms in the cluster.
    \item keyWordsTerm: Term is the most representative of the terms in the cluster based on keywords.
}
 
\code{geneTermSets } data.frame containing the gene-term sets that support each cluster.
\itemize{ 
    \item Cluster: Number (id) of the cluster the gene-term set belongs to.
    \item ClusterEnrichmentScore: Score for the cluster. Same value for all terms in each cluster.
    \item Category: Type of annotation of the term (i.e. GO, Kegg...)
    \item Terms: Term in the gene-term set.
    \item Genes: Genes in the gene-term set.
    \item GenesIDs: In case GeneLabels was provided, original gene ID.
    \item Other stats: Count, PValue, List.Total, Pop.Hits, Pop.Total, Fold.Enrichment, Bonferroni, Benjamini, FDR.
}
 
\code{fileName} .txt file with the formatted FEA results.
}
\references{
[1] Huang DW, Sherman BT, Lempicki RA (2009) Bioinformatics enrichment tools: paths toward the comprehensive functional analysis of large gene lists. Nucleic Acids Res. 37(1):1-13.
}
\seealso{
Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}
\examples{

# Select file:
txtFile <- "http://david.abcc.ncifcrf.gov/data/download/901234901248.txt"
txtFile <- paste(file.path(system.file('examples', package='FGNet')), 
    "DAVID_Yeast_raw.txt", sep="/")

# Read:
results <- format_david(txtFile, jobName="DavidAnalysis")


# To continue the workflow... (see help for further details)
getTerms(results)
incidMat <- fea2incidMat(results)
functionalNetwork(incidMat)

?FGNet_report

}

\name{fea2incidMat}
\alias{fea2incidMat}
\alias{toMatrix}
\alias{adjMatrix}
\title{
Transforms FEA output into incidence matrices.
}
\description{
Transforms the Funtional Enrichment Analysis (FEA) results into cluster-gene incidence matrices. 
}
\usage{
fea2incidMat(feaResults, key = "Genes", sepChar = NULL, clusterColumn = NULL, 
    filterAttribute = NULL, filterOperator = "<", filterThreshold = 0, 
    removeFilteredGtl = NULL)
}
\arguments{
  \item{feaResults}{
list or data.frame/matrix. Output from one of the FEA functions.
}
  \item{key}{
"Genes" or "Terms". To build gene- or term-based networks.
}
  \item{sepChar}{
character. Character separating genes or terms in the same field. By default: "," for genes and ";" for terms.
}
  \item{clusterColumn}{
character. Name of the column that contains the value to group gene-term sets. Only required if it is different than "Cluster" or "Metagroup".
}
  \item{filterAttribute}{
character or data.frame. Attribute to filter the clusters/metagroups. Filtered clusters/metagroups will not be included in the matrices (and subsequent networks).
Its value should be the data.frame column to use for filtering. It can be provided as character (column name) or data.frame (subset of the data.frame with drop=FALSE).
}
  \item{filterOperator}{
character. Logical operator used for filtering. i.e. ">" (bigger than), "<=" (smaller or equal than), "==" (equal), "!=" (different), "\%\%" (included in),... 
The evaluation order is left to right: filterAttribute ">" filterThreshold, will filter out clusters with filter attribute bigger than the threshold.
}
  \item{filterThreshold}{
numeric. Sets the value to compare to.
}
  \item{removeFilteredGtl}{
logical. Only used by GeneTerm Linker term network. If FALSE, it includes generic terms filtered by GeneTerm Linker from final metagroups. 
}
}
\value{
List: 
\item{clustersMatrix or metagroupsMatrix}{Incidende matrix with the genes or Terms in each cluster or metagroup.}
\item{gtSetsMatrix }{Incidende matrix with the genes or Terms in each gene-term set}
\item{filteredOut }{Clusters or metagroups which where filtered out and therefore not included in the incidence matrices. NULL if none.}

}
\seealso{
Next step in the workflow: 
	\code{\link[FGNet:functionalNetwork]{functionalNetwork()}}
	
%%Previous step in the workflow: FEA

Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}
\examples{
\dontrun{
jobID <- 3907019
results <- fea_gtLinker_getResults(jobID)
incidMat <- fea2incidMat(results)

# Filtering (threshold)
incidMat <- fea2incidMat(results, 
    filterAttribute="Silhouette Width", filterThreshold=0.2)

incidMat$filteredOut
head(incidMat$metagroupsMatrix)
head(incidMat$gtSetsMatrix)

functionalNetwork(incidMat)
    
# Term-based network
incidMatTerms <- fea2incidMat(results, key="Terms")
functionalNetwork(incidMatTerms, plotOutput="dynamic")

# Including generic terms filterd by GtLinker from final metagroups:
incidMatTerms <- fea2incidMat(results, key="Terms",removeFilteredGtl=FALSE)
functionalNetwork(incidMatTerms, plotOutput="dynamic", plotType="bipartite")

# Filtering by keyword
keywords <- c("rna")
selectedGroups <- sapply(getTerms(results),
    function(x) 
    any(grep(paste("(", paste(keywords, collapse="|") ,")",sep=""), tolower(x))))

resultsCbind <- results
resultsCbind$metagroups <- cbind(results$metagroups,
    selectedKeywords=as.numeric(selectedGroups))

matSelectedGroups <- fea2incidMat(resultsCbind,
    filterAttribute="selectedKeywords", filterThreshold=1)

functionalNetwork(matSelectedGroups)
getTerms(results)[selectedGroups]
}
}

\name{fea_gage}
\alias{fea_gage}
\title{
FEA - GAGE
}
\description{
Performs the functional enrichment analysis and clustering through GAGE [1] (GSEA).
}
\usage{
fea_gage(eset, refSamples, compSamples, geneIdType, geneLabels=NULL, 
    organism = "Hs", 
    annotations = c("GO_BP", "GO_MF", "GO_CC", "REACTOME"), 
    geneSets = NULL, 
    sameDirection = FALSE, 
    onlyEssentialTerms = TRUE, 
    compareType = "as.group", 
    jobName = NULL, ...)
}
\arguments{
  \item{eset}{
expressionSet or expression matrix.
}
  \item{refSamples}{
numeric. Index of the samples to use as reference (control).
}
  \item{compSamples}{
numeric. Index of the samples to analyze.
}
  \item{geneIdType}{
character.  Type of gene identifier should be the same as the one provided in the geneSets, or available in the organism package.
}
\item{geneLabels}{
    named character vector. Gene name or label to use in the report/plots instead of the original gene ID. The vector names should be the gene ID and the content of the vector the gene label. The resulting geneTermSets table will contain the original gene ID column (geneIDs) and the label column (Genes).
}
  \item{organism}{
two letter code for the organism. See: \code{data(organisms);organisms}
}
  \item{annotations}{
character vector. Annotation spaces to select from the provided geneSets.
Set to NULL to use the geneSets as is (i.e. geneSets not split/named by annotation)
}
  \item{geneSets}{
geneSets. If NULL geneSets are calculated automatically based on the organism, gene ID and annotations. The geneSets can also be provided from a previous execution or loaded from a .gtm file. i.e.: \code{readList("c2.cp.v4.0.symbols.gmt")}
}
  \item{sameDirection}{
logical. Should all the genes in the geneSet be altered in the same direction (up/down)? 
}
  \item{onlyEssentialTerms}{
logical. Wether to simplify the results and keep only the essential terms in the clusters.
}
  \item{compareType}{
character: 'as.group', 'unpaired', '1ongroup'... See \link[gage:gage]{GAGE} for details.
}
  \item{jobName}{
character. Folder name and prefix for the files.
}
  \item{\dots}{
other arguments to pass to GAGE.
}
}
\value{
\link[base:invisible]{Invisible} list with the folowing fields:\cr
\code{queryArgs } list with the arguments for the query.

\code{clusters } data.frame containing the clusters and their information:
\itemize{ 
    \item Cluster: Cluster ID.
    \item nGenes: Number of genes in the cluster.
    \item dir: Direction in which the term/pathway is altered (Up/Down).
    \item Genes: Genes in the cluster.
    \item Terms: Terms in the cluster.
}
 
\code{geneTermSets } data.frame containing the gene-term sets that support each cluster.
\itemize{ 
\item Cluster: Number (id) of the cluster the gene-term set belongs to.
    \item essentialSet: Logical. Is the pathway selected as essential?
    \item dir: Direction in which the term/pathway is altered (Up/Down).
    \item Terms: Term in the gene-term set.
    \item Genes: Genes in the gene-term set.
    \item GenesIDs: In case GeneLabels was provided, original gene ID.
    \item Other stats provided by \link[gage:gage]{GAGE}: p.geomean, stat.mean, p.val, q.val, set.size
}
\code{fileName}: .txt file with the FEA results.
\code{genesFC}: Fold change.
}
\seealso{
\itemize{
    \item{\code{\link[FGNet:fea_gtLinker]{fea_gtLinker()}} & \code{fea_gtLinker_getResults()}
          (Requires internet connection)}
    \item{\code{\link[FGNet:fea_topGO]{fea_topGO()}} 
    
   To import results from a previous/external FEA analysis: \code{\link[FGNet:format_david]{format_david()}}, \code{format_results()} and \code{\link[FGNet:readGeneTermSets]{readGeneTermSets()}}.}
}


Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}
\references{
[1] Luo W, Friedman MS, Shedden K, Hankenson KD, Woolf PJ (2009) GAGE: generally applicable gene set enrichment for pathway analysis. BMC Bioinformatics. 10:161. URL: \url{http://www.bioconductor.org/packages/release/bioc/html/gage.html}
}

\examples{
\dontrun{
 # Load expressionSet:
library(gage)
data(gse16873)

# Load gene labels?
library(org.Hs.eg.db)
geneSymbols <- select(org.Hs.eg.db,columns="SYMBOL",keytype="ENTREZID", 
    keys=rownames(gse16873))
head(geneSymbols)
table(table(geneSymbols$ENTREZID)) # All need to be unique identifiers

geneLabels <- geneSymbols$SYMBOL
names(geneLabels) <- geneSymbols$ENTREZID
head(geneLabels)

# FEA:
results <- fea_gage(eset=gse16873, 
                    refSamples=grep('HN',colnames(gse16873), ignore.case =T), 
                    compSamples=grep('DCIS',colnames(gse16873), ignore.case=T), 
                    geneIdType="ENTREZID", geneLabels=geneLabels, organism="Hs",
                    annotations="REACTOME")


# To continue the workflow... (see help for further details)
FGNet_report(results)

incidMat <- fea2incidMat(results)
functionalNetwork(incidMat)
}
}

\name{keywordsTerm}
\alias{keywordsTerm}
\title{
Select keyword term
}
\description{
Selects a term as the most representative of the terms in the cluster based on keywords.
}
\usage{
keywordsTerm(termsDescriptions, nChar = 30)
}
\arguments{
  \item{termsDescriptions}{
List with the terms in each cluster. Output from \code{\link[FGNet:getTerms]{getTerms}}.
}
  \item{nChar}{
numeric. Maximum number of chars to show in the term. If the selected term is longer, it will be trimmed.
}
}
%\details{
%% Explain method?
%}
\value{
Character vector with the term selected for each cluster.
}
\seealso{
Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}
\examples{
\dontrun{
# Previous Steps: FEA
results <- fea_gtLinker_getResults(3907019)

# Select keywords
keywordsTerm(getTerms(results), nChar=100)
}
}

\name{FGNet_GUI}
\alias{FGNet_GUI}
\title{
FGNet graphical user interface
}
\description{
Provides a graphical user interface (GUI) to most FGNet functionalities.
}
\usage{
FGNet_GUI(geneList = NULL)
}
\arguments{
  \item{geneList}{
vector. If provided, assigns the value to the genes field. It can be a character vector containing the gene list, or a named numeric vector with the gene expression.
}
}
\details{
To generate the functional network, first execute or import the Functional Analisis of the gene list with one of the tools in Tab "1 - FEA", then generate the network or the report in Tab "2 - Network".
}
\value{
Opens the GUI. No value is returned. The results of the analyses will be saved in the current working directory.
}

\note{

Available for Windows and Linux.
The current version of the GUI is not available for Mac OS X Snow Leopard.

}

\seealso{
Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}
\examples{
\dontrun{


FGNet_GUI()

# To directly input a gene list (i.e. from a previous analysis):
geneList <- c("YBL084C", "YDL008W", "YDR118W", "YDR301W", "YDR448W", "YFR036W", 
    "YGL240W", "YHR166C", "YKL022C", "YLR102C", "YLR115W", "YLR127C", "YNL172W",
    "YOL149W", "YOR249C")
# Optional gene expression
geneExpr <- setNames(c(rep(1,10),rep(-1,5)), geneList)

FGNet_GUI(geneExpr)

}
}

\name{organisms}
\docType{data}
\alias{organisms}
\alias{groupTypes}
\alias{FEA_tools}
\alias{GOEvidenceCodes}
\title{FGNet data}
\description{
FGNet package includes the following data files: organisms, groupTypes and FEA_tools
}
\value{
\itemize{
\item{organisms: Matrix with the supported organisms' name and package.}

\item{groupTypes: Matrix with the group types supported by FGNet (cluster, metagroup and gene-term set).}

\item{FEA_tools:  Matrix with info about the FEA tools supported by FGNet.}

\item{GOEvidenceCodes:  Matrix with info about GO evidence codes. (from \url{http://geneontology.org/page/guide-go-evidence-codes}, on nov. 26, 2014.)}

}
}

\usage{
    data(organisms)
    organisms
    
    data(groupTypes)
    groupTypes
    
    data(FEA_tools)
    FEA_tools
    
    data(GOEvidenceCodes)
    GOEvidenceCodes
}

\name{format_results}
\alias{format_results}
\title{
Format FEA results from external tools. 
}
\description{
Format the functional analysis results from external tools to use with FGNet. 
}
\usage{
format_results(fileName, newFileName = NULL, clusterCol = NULL, 
    geneCol = NULL, geneSep = NULL, termDescCol = NULL, termIDCol = NULL,
    termCatCol = NULL, termCat = NULL, termSep = NULL, 
    tool = "Imported text file", simplifyGage = TRUE, ...)
}
\arguments{
  \item{fileName}{
character. File name with the FEA results.
}
  \item{newFileName}{
character. Name for the formatted files.
}
  \item{clusterCol}{
character. Name of the column to use for clustering.
}
  \item{geneCol}{
character. Name of the column with the genes.
}
  \item{geneSep}{
character. Character separating diferent genes in the same field (i.e. ",", ";", ...)
}
  \item{termDescCol}{
character. Name of the column with the terms description.
}
  \item{termIDCol}{
character. Name of the column with the terms ID.
}
  \item{termCatCol}{
character. Name of the column with the terms type/category.
}
  \item{termCat}{
character. Name of the annotation type if it is common to all gene-term sets. Provide either termCatCol or termCat, not both.
}
  \item{termSep}{
character. Character separating diferent terms in the same field (i.e. ",", ";", ...)
}
  \item{tool}{
character. Tool used for the FEA (row name from \code{data(FEA_tools); FEA_tools})
}
  \item{simplifyGage}{
logical. For internal use, only for GAGE. Determines wether to keep non essential terms in the final clusters.
}
  \item{\dots}{
Further argumets to pass to "read.table"
}
}
\value{
Saves the formatted file and returns an  \link[base:invisible]{invisible} list with the appropiate format to use with \link[FGNet:FGNet_report]{FGNet_report()} and \link[FGNet:fea2incidMat]{fea2incidMat()} (fields "clusters", "geneTermSets" and "fileName").
}
\seealso{
Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}
\examples{

\dontrun{

results <- format_results("/home/user/feaResults.txt", clusterCol="Cluster", 
    geneCol="Genes", termDescCol="Terms", sep="\t")

}
}

\name{plotGoAncestors}
\alias{plotGoAncestors}
\title{
Plot GO term ancestors
}
\description{
Plots the ancestors in the tree ontology for the given GO terms.
}
\usage{
plotGoAncestors(goIds, tColor = NULL, ontology = NULL,
    plotOutput = "static", nCharTerm = 50, nSize = NULL, labelCex = NULL, 
    asp = NULL, fileName = NULL, height = 1000)
}
\arguments{
  \item{goIds}{
character vector. GO IDs of the terms to plot.
}
  \item{tColor}{
character. Color for the term (i.e. based on expression).
}
  \item{ontology}{
character. If character determines which ontology to plot ("BP"", "MF" or "CC"").
}
  \item{plotOutput}{
"static", "dynamic" or "none". "static" will generate a standard R plot. "dynamic" will produce an interactive tkplot. "none" will not plot the network.
}
  \item{nCharTerm}{
numeric. Max term size (number of characters). Longer terms will be trimmed.
}
  \item{nSize}{
numeric. Determines the node size.
}
  \item{labelCex}{
numeric. Determines the node label size.
}
  \item{fileName}{
character. If provided, the plot is saved as png with this fileName.
}
  \item{asp}{
character. If fileName is provided, asp argument for plot.
}
  \item{height}{
numeric.  If fileName is provided, height argument for png().
}
}
\value{
An \link[base:invisible]{invisible} list with the nodes identified as leaves (\code{leaves}) and the graph (\code{iGraph}).
}

\seealso{
Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}

}
\examples{

plotGoAncestors(c("GO:0000152","GO:0043234", "GO:0044446", "GO:0043227"))

# plotGoAncestors(c("GO:0051603", "GO:0019941", "GO:0051128","GO:0044265"), plotOutput="dynamic")


# From analysis:
txtFile <- paste(file.path(system.file('examples', package='FGNet')),
    "DAVID_Yeast_raw.txt", sep="/")
results <- format_david(txtFile, jobName="DavidAnalysis")

plotGoAncestors(getTerms(results, returnValue="GO")$"Cluster 7", ontology="MF")
}

\name{fea_topGO}
\alias{fea_topGO}
\title{
FEA - topGO
}
\description{
Performs the functional enrichment analysis through topGO [1].
}
\usage{
fea_topGO(geneList, geneIdType = "ENSEMBL", geneLabels=NULL, organism = "Hs", 
    annotations = c("GO_BP", "GO_MF", "GO_CC"), evidence=NULL,
    genesUniverse = NULL, refPackage = NULL, 
    geneID2GO = NULL, nodeSize = 5, pValThr = 0.01, testStat = NULL, 
    jobName = NULL)
}
\arguments{
  \item{geneList}{
character vector. List of genes to analyze.
}
  \item{geneIdType}{
character. Type of gene identifier should be available for the organism package.
}
\item{geneLabels}{
    named character vector. Gene name or label to use in the report/plots instead of the original gene ID. The vector names should be the gene ID and the content of the vector the gene label. The resulting geneTermSets table will contain the original gene ID column (geneIDs) and the label column (Genes).
}
  \item{organism}{
two letter code for the organism. See: \code{data(organisms);organisms}
}
  \item{annotations}{
character vector. Annotation spaces for the functional analysis. Accepted values: "GO_BP", "GO_MF", "GO_CC".
}
  \item{evidence}{
character vector. Required evidence code for GO annotations. If NULL no filtering is done (all annotations are used). For full list, see the organism "EVIDENCE" keys: i.e \code{keys(org.Hs.eg.db, keytype="EVIDENCE")}. For non-comprehensive code description: \code{data(GOEvidenceCodes)}.
}
  \item{genesUniverse}{
character vector. List of genes used for background (i.e. all genes available in the chip).
}
  \item{refPackage}{
character. Name of the package to use for calculating the genes universe. A Chip package is recommended. If NULL the genes universe is set as all the genes available in the organism package.
}
  \item{geneID2GO}{
GO gene sets. If NULL it is calculated automatically. %To speed up the execution of multiple queries you can use: \code{geneID2GO <- buildDatabases(orgPackage, geneIdType)$geneID2GO}
}
  \item{nodeSize}{
numeric. Minimum size of GO terms. TopGo authors recommend 5-10 for more stable results, 1 for no prune.
}
  \item{pValThr}{
numeric. P-value threshold.
}
  \item{testStat}{
classicCount from toGO. If NULL: GOFisherTest is used.
}
  \item{jobName}{
character. Folder name and prefix for the files.
}
}

\value{
\link[base:invisible]{Invisible} list with the folowing fields:\cr
\code{queryArgs } list with the arguments for the query.

\code{clusters } Empty list. only for compatibility.
 
\code{geneTermSets } data.frame containing the gene-term sets.
\itemize{ 
    \item Ont: Ontology to wich the term belongs (BP, MF or CC)
    \item Terms: Term in the gene-term set.
    \item Genes: Genes in the gene-term set.
    \item GenesIDs: In case GeneLabels was provided, original gene ID.
    \item Other stats provided by \link[topGO:getSigGroups]{topGO}: Annotated, Significant, Expected, classic.
}
 
\code{fileName} .txt file with the formatted FEA results.
}
\seealso{
Other FEA tools:
\itemize{
    \item{\code{\link[FGNet:fea_gtLinker]{fea_gtLinker()}} & \code{fea_gtLinker_getResults()}
          (Requires internet connection)}
    \item{\code{\link[FGNet:fea_gage]{fea_gage()}}
    
   To import results from a previous/external FEA analysis: \code{\link[FGNet:format_david]{format_david()}}, \code{format_results()} and \code{\link[FGNet:readGeneTermSets]{readGeneTermSets()}}.}
}

Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}

\references{
[1] Adrian Alexa and Jorg Rahnenfuhrer (2010) topGO: Enrichment analysis for Gene Ontology. R package version 2.16.0. URL: \url{http://www.bioconductor.org/packages/release/bioc/html/topGO.html}
}

\examples{
\dontrun{

# Load/format gene list:
geneList <- c("YBL084C", "YDL008W", "YDR118W", "YDR301W", "YDR448W", "YFR036W",
    "YGL240W", "YHR166C", "YKL022C", "YLR102C", "YLR115W", "YLR127C", "YNL172W", 
    "YOL149W", "YOR249C")

library(org.Sc.sgd.db)
geneLabels <- unlist(as.list(org.Sc.sgdGENENAME)[geneList])

geneExpr <- setNames(c(rep(1,10),rep(-1,5)), geneLabels) 

# FEA (using directly the gene names): 
results <- fea_topGO(geneLabels, geneIdType="GENENAME", organism="Sc") 

# FEA (using the gene ID, and replacing it by the label after the FEA): 
results <- fea_topGO(geneList, geneIdType="ENSEMBL", 
    geneLabels=geneLabels, organism="Sc") 

# To continue the workflow... (see help for further details)
FGNet_report(results, geneExpr=geneExpr)

incidMat <- fea2incidMat(results, geneExpr=geneExpr)
functionalNetwork(incidMat)
    
    
}
}

\name{functionalNetwork}
\alias{functionalNetwork}
\alias{intersectionNetwork}
\title{
Creates and plots the functional gene network.
}
\description{
Plots the functional networks. 

The default network links genes to genes, or terms to terms. The bipartite network links genes or terms to their clusters. 
}
\usage{
functionalNetwork(incidMatrices, plotType = c("default", "bipartite")[1], 
    plotOutput = "static", plotTitle = "Functional Network", 
    plotTitleSub = NULL, legendPrefix = NULL, legendText = NULL, 
    geneExpr = NULL, plotExpression = c("border", "fill"), 
    vExprColors=c(neg="#008000", zero="white", pos="#FF2020"),
    vSize = 12, vLabelCex = 2/3, vLayout = NULL, keepColors = TRUE, 
    bgTransparency = 0.4, eColor = "#323232", eWidth=NULL, weighted = FALSE, 
    keepAllNodes = FALSE, plotAllMg = FALSE)
}

\arguments{
  \item{incidMatrices}{
list or matrix. Raw output (list) from \code{\link[FGNet:fea2incidMat]{fea2incidMat}}: a list with slots:  "gtSetsMatrix", "filteredOut" and either "metagroupsMatrix" or "clustersMatrix". If only a matrix is provided, it will be asumed to be the clusters matrix, and all nodes will be connected to every other node in the metagroup.
}
  \item{plotType}{
"default" or "bipartite". 

Default network: Nodes are either genes or terms. Edges join nodes in common gene-term sets. Background and node color represent cluster/metagroup. White nodes are in several  clusters/metagroups.

Bipartite network: Nodes are genes or terms (circles) and their clusters (squares). 
By default it keeps only the genes or terms in more than one cluster or metagroup, which represents a simplified version of the functional network.
Node shape is only available in the "static" output.
}
  \item{plotOutput}{
"static", "dynamic" or "none". "static" will generate a standard R plot. "dynamic" will produce an interactive tkplot (metagroups background cannot be drawn). "none" will not plot the network.
}
  \item{plotTitle}{
character. Title to show on the plot.
}
  \item{plotTitleSub}{
character. Text to show at the bottom of the plot (sub-title).
}
  \item{legendPrefix}{
character. Label to show next to the cluster/metagroup id in the legend. In the bipartite network the legens replaces the cluster node label.
}
  \item{legendText}{
character. Description of each cluster (shown as the legend).  If FALSE, legend is not shown.
}
  \item{geneExpr}{
numeric. Named vector with the relative expression value of the gene (node). 0 is taken as reference, positive values will be plotted red, negative values green.
}
  \item{plotExpression}{
character. Determines the way to plot the expression: "border" adds a red or green border to the node, "fill" colors the whole with the expression color instead of the metagroup color.
}
  \item{vExprColors}{
character. Vector with the colors for expression: first color for negative values, second for zero, and third for positive.
}
  \item{vSize}{
numeric. Vertex size. If named, it allows to set a value for each gene. Name as "default" to set a default value, otherwise the default value is the mean.
}
  \item{vLabelCex}{
numeric. A numerical value giving the amount by which plotting text and symbols should be magnified relative to the default label size. 
}
  \item{vLayout}{
2 x n matrix or character. Where n is the number of nodes in the graph, each column gives the (x, y)-coordinates for the corresponding node. The bipartite network accepts "kk" (Kamada Kawai), "circle", or "sugiyama" (hierarquical).
}
  \item{keepColors}{
logical. If TRUE, it will keep the same colors for all the plots, independently of the filtered groups. Only available if incidMatrices is the raw result from \code{\link[FGNet:fea2incidMat]{fea2incidMat()}}.
}
  \item{bgTransparency}{
numeric. Value between 0 and 1 for the transparency of the metagroups background (only default network).
}
  \item{eColor}{
character. Color for the edges.
}
  \item{eWidth}{
numeric. Edge width. Not to plot edges, set eWidth=0 or eColor=NA.
}
  \item{weighted}{
logical. If TRUE, edges width will be based on the number of shared gene-term sets.
}
  \item{keepAllNodes}{
logical. Only used in bipartite network. If FALSE, nodes in only one cluster are not plotted. If TRUE, all nodes in the clusters are shown.
}
  \item{plotAllMg}{
logical. Only used in bipartite network. If FALSE, non-connected clusters are not plotted. If TRUE, all non-filtered clusters are shown.
}
}
\value{
Plots the functional networks.
 
An \link[base:invisible]{invisible} list with the igraph networks and incidence matrices, to collect it assign it to a variable.
}


\seealso{
Previous step in the workflow: \code{\link[FGNet:fea2incidMat]{fea2incidMat()}}
    
To see the terms included in each cluster or metagroup: \code{\link[FGNet:getTerms]{getTerms()}}

Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}
\examples{
###################################################
# Previous steps
# Set gene list:
genesYeast <- c("ADA2", "APC1", "APC11", "APC2", "APC4", "APC5", "APC9", 
    "CDC16", "CDC23", "CDC26", "CDC27", "CFT1", "CFT2", "DCP1", "DOC1", "FIP1", 
    "GCN5", "GLC7", "HFI1", "KEM1", "LSM1", "LSM2", "LSM3", "LSM4", "LSM5", 
    "LSM6", "LSM7", "LSM8", "MPE1", "NGG1", "PAP1", "PAT1", "PFS2", "PTA1", 
    "PTI1", "REF2", "RNA14", "RPN1", "RPN10", "RPN11", "RPN13", "RPN2", "RPN3", 
    "RPN5", "RPN6", "RPN8", "RPT1", "RPT3", "RPT6", "SGF11", "SGF29", "SGF73", 
    "SPT20", "SPT3", "SPT7", "SPT8", "TRA1", "YSH1", "YTH1")
# Optional gene expression
genesYeastExpr <- setNames(c(rep(1,29), rep(-1,30)), genesYeast) # 1=UP, -1=DW

\dontrun{
# FEA:
# jobID <- query_gtLinker(genesYeast, organism = "Sc")
jobID <- 3907019
results <- fea_gtLinker_getResults(jobID)

###################################################
# Gene-based networks:
incidMat <- fea2incidMat(results, filterAttribute="Silhouette Width")

functionalNetwork(incidMat, geneExpr=genesYeastExpr)
functionalNetwork(incidMat, plotType="bipartite", 
plotOutput="dynamic", vSize=c(default=10, GLC7=20, PTA1=20))

getTerms(results)

# To modify the layout and plot as static network (with metagroup background)...
library(igraph)
# saveLayout <- tkplot.getcoords(1)   # tkp.id (ID of the tkplot window)
# functionalNetwork(incidMat, vLayout=saveLayout, plotType="bipartite")

# Only return the network, without plotting
fNw <- functionalNetwork(incidMat, plotOutput="none") 
class(fNw)
names(fNw)
betweenness(fNw$iGraph$commonClusters)

###################################################
# Term-based network
incidMat_terms <- fea2incidMat(results, key="Terms")
functionalNetwork(incidMat_terms, weighted=TRUE, plotOutput="dynamic")
functionalNetwork(incidMat_terms, plotType="bipartite", plotOutput="dynamic", 
    plotAllMg=TRUE)
functionalNetwork(incidMat_terms, plotType="bipartite", plotOutput="dynamic",
    keepAllNodes=TRUE)

# Including generic terms filterd by GtLinker from final metagroups:
incidMat_terms2 <- fea2incidMat(results, key="Terms", removeFiltered=FALSE)
functionalNetwork(incidMat_terms2, weighted=TRUE)
}
}

\name{clustersDistance}
\alias{clustersDistance}
\alias{plotMetagroupsDistance}
\title{
Plots distances between metagroups.
}
\description{
Plots the distances between metagroups taking into account the number of common genes.
}
\usage{
clustersDistance(incidenceMatices, mgCols = NULL, clustMethod="average")
}
\arguments{
  \item{incidenceMatices}{
  Object returned by  \code{\link[FGNet:fea2incidMat]{fea2incidMat()}}.
}
  \item{mgCols}{
  Colors for the metagroups.
}
  \item{clustMethod}{
  Clustering method. Character string (i.e. "single", "complete", "average") for function \code{\link[stats:hclust]{hclust()}} (argument 'method').
}
}
\value{
 Plot and distance matrix.
}
\seealso{
	Full description of the package:
		\code{\link[FGNet:FGNet-package]{FGNet}}
}
\examples{
\dontrun{
results <- fea_gtLinker_getResults(jobID=1963186, jobName="gtLinker_example")
incidMatrices <- fea2incidMat(results)
clustersDistance(incidMatrices)
}
}

\name{getTerms}
\alias{getTerms}
\title{
Get terms in the metagroups/clusters.
}
\description{
Gets the terms in each metagroup/cluster (simplifyes the raw output from GeneTermLinker or DAVID).
}
\usage{
getTerms(feaResults, returnValue = "description")
}
\arguments{
  \item{feaResults}{
Output returned by any of the \link[FGNet:fea_gtLinker]{fea functions}.
}
  \item{returnValue}{
"description" Returns term description, e.g. "GO" returns GO term IDs.
}
}
\value{
\item{List of matrices}{Each matrix contais the terms in each metagroup. This matrix contains only the term description. To get the term ID, annotation type, number of genes, or any other information, see the raw results returned by getResults.}
}
\seealso{		
Full description of the package:
\code{\link[FGNet:FGNet-package]{FGNet}}
}
\examples{
\dontrun{
results <- fea_gtLinker_getResults(jobID=1963186)
getTerms(results)
}
}

\name{fea_gtLinker}
\alias{fea_gtLinker}
\alias{fea_gtLinker_getResults}
\alias{query_gtLinker}
\alias{getResults_gtLinker}
\title{
FEA - Gene-Term Linker
}
\description{
Performs the functional enrichment analysis and clustering through Gene-Term Linker [1] (requires internet connection).

Since Gene-Term Linker takes a while to analyze the gene list, the process has been splitted in two steps:
\enumerate{
\item{fea_gtLinker(): Submits the query}
\item{fea_gtLinker_getResults(): Retrieves the results of the analysis. It might take a few minutes for the results to become available.}
}
}
\usage{
fea_gtLinker(geneList, organism = "Hs", 
    annotations = c("GO_Biological_Process", "GO_Molecular_Function", 
    "GO_Cellular_Component", "InterPro_Motifs"),
    minSupport = 4, serverWS = "http://gtlinker.cnb.csic.es:8182")

fea_gtLinker_getResults(jobID = NULL, organism = NULL, jobName = NULL, 
    alreadyDownloaded = FALSE, keepTrying = FALSE, 
    serverWeb = "http://gtlinker.cnb.csic.es", 
    serverWS = "http://gtlinker.cnb.csic.es:8182")
}
\arguments{

\bold{fea_gtLinker():}

  \item{geneList}{
character vector. List of genes to analyze.
}
  \item{annotations}{
character vector. Annotation spaces for the functional analysis. \cr
Available values: "GO_Biological_Process", "GO_Molecular_Function", \cr
"GO_Cellular_Component", "InterPro_Motifs".
}
  \item{minSupport}{
numeric. Minimum number of genes per group.
}
\bold{common arguments}:
  \item{serverWS}{
character. GeneTerm Linker webservice server. \cr
Available mirrors: "http://gtlinker.cnb.csic.es:8182" %and "http://cicblade.dep.usal.es:8182".
If you change the webserice server, make sure to use the matching 'serverWeb' in the following step.
}
  \item{organism}{
character. "Hs" (Homo sapiens) or "Sc" (Saccharomyces cerevisiae).
}

\bold{fea_gtLinker_getResults()}:

  \item{jobID}{
numeric. ID of the job/analysis in GeneTerm Linker.
}
  \item{jobName}{
character. Folder name and prefix for the files.
}
  \item{alreadyDownloaded}{
logical. If the files have already been downloaded, these will be read instead of downloaded again.
}
  \item{keepTrying}{
logical. If true, if the job has not finished, it will keep trying to get the results every few seconds.
}
  \item{serverWeb}{
character. GeneTerm Linker web server. It should match the web service or web address in which the analysis was performed. \cr
Available mirrors: "http://gtlinker.cnb.csic.es" % and "http://cicblade.dep.usal.es:8000"
}

}
\value{

\bold{fea_gtLinker()} returns the jobID of the analysis

\bold{fea_gtLinker_getResults()} returns an \link[base:invisible]{invisible} list with the folowing fields:\cr

\code{queryArgs } list with the arguments for the query.

\code{metagroups } data.frame containing the metagroups and their information:
\itemize{ 
    \item Metagroup: Metagroup ID.
    \item Size: Number of gene-term sets supporting the metagroup.
    \item Diameter: Maximum Cosine distance within the GeneTerm-sets of each metagroup (ranges from 0 to 1).
    \item Similarity: 1 - average Cosine distance within the GeneTerm-sets of each metagroup (ranges from 0 to 1). Distance and similarity calculations are done based on the genes present in the metagroups.
    \item Silhouette Width: Measures the compactness and proximity of multiple groups (ranges from 1 to -1). 
Metagroups with negative Silhouette Width usually include diverse annotations and genes with low functional coherence. 
    \item Genes: Genes in the metagroup.
    \item nGenes: Number of genes in the metagroup.
    \item nref_list: Number of annotated genes in the reference list.
    \item pValue: Adjusted p-value.
    \item Terms: Non-generic terms in the metagroup.
 }
\code{geneTermSets }data.frame containing the gene-term sets that support each metagroup.
	\itemize{ 
	\item Metagroup: Id of the metagroup the gene-term set belongs to.
	\item Genes: Genes in the gene-term set.
	\item nGenes: Number of annotated genes in the input list. In brackets: Total number of genes in the input list.
	\item nref_list: Number of annotated genes in the reference list.  In brackets: Total number of genes in the reference list.
	\item pValue: Adjusted p-value.
	\item Terms: Terms in the gene-term set.
 }
 
\code{fileName} .txt file with the formatted FEA results.
}
\references{
[1] Fontanillo C, Nogales-Cadenas R, Pascual-Montano A, De Las Rivas J (2011) Functional Analysis beyond Enrichment: Non-Redundant Reciprocal Linkage of Genes and Biological Terms. PLoS ONE 6(9): e24289. URL: \url{http://gtlinker.cnb.csic.es}
}

\seealso{
Other FEA tools:
\itemize{
    \item{\code{\link[FGNet:fea_gage]{fea_gage()}}}
    \item{\code{\link[FGNet:fea_topGO]{fea_topGO()}} 
    
   To import results from a previous/external FEA analysis: \code{\link[FGNet:format_david]{format_david()}}, \code{format_results()} and \code{\link[FGNet:readGeneTermSets]{readGeneTermSets()}}.}
}

Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}
}
\examples{
\dontrun{
### Execute FEA:
genesYeast <- c("ADA2", "APC1", "APC11", "APC2", "APC4", "APC5", "APC9", 
     "CDC16", "CDC23", "CDC26", "CDC27", "CFT1", "CFT2", "DCP1", "DOC1", "FIP1", 
     "GCN5", "GLC7", "HFI1", "KEM1", "LSM1", "LSM2", "LSM3", "LSM4", "LSM5", 
     "LSM6", "LSM7", "LSM8", "MPE1", "NGG1", "PAP1", "PAT1", "PFS2", "PTA1", 
     "PTI1", "REF2", "RNA14", "RPN1", "RPN10", "RPN11", "RPN13", "RPN2", "RPN3", 
     "RPN5", "RPN6", "RPN8", "RPT1", "RPT3", "RPT6", "SGF11", "SGF29", "SGF73", 
     "SPT20", "SPT3", "SPT7", "SPT8", "TRA1", "YSH1", "YTH1")
# Optional expression (1=UP, -1=DW):
genesYeastExpr <- setNames(c(rep(1,29), rep(-1,30)), genesYeast)

# Submit query
jobID <- fea_gtLinker(geneList=genesYeast,organism="Sc")
jobID


### Get results from FEA:
jobID <- 3907019 # job ID of the query
results <- fea_gtLinker_getResults(jobID=jobID)

# To continue the workflow... (see help for further details))
incidMat <- fea2incidMat(results)
functionalNetwork(incidMat)

# Or full report
FGNet_report(results, geneExpr=genesYeastExpr)
}

}

\name{analyzeNetwork}
\alias{analyzeNetwork}
\title{
Analyze Functional Network
}
\description{
Analyzes the degree and betweenness of the genes in the functional network.
}
\usage{
analyzeNetwork(incidMatrices, fNw = NULL, plotOutput = TRUE, colors = NULL)
}
\arguments{
  \item{incidMatrices}{
list or matrix. Output from \code{\link[FGNet:fea2incidMat]{fea2incidMat}} or the equivalent incidence matrices.
}
  \item{fNw}{
list. Return from \code{\link[FGNet:functionalNetwork]{functionalNetwork}} to avoid recalculating.
}
  \item{plotOutput}{
logical. Wether to plot the degree and betweenness boxplots.
}
  \item{colors}{
vector. Colors for the metagroups
}
}
\value{
List:

\itemize{ 
    \item degree, betweenness: Degree and Betweenness of the nodes in the global network (commonClusters) and within each cluster/metagroup (subsets of commonGtSets network). The degree is given as percentage, normalized based on the total number of nodes of the network. i.e. a value of 90 in a network of 10 nodes, would mean the actual degree of the node is 9: it is conneded to 9 nodes (90\% of 10)).
    \item transitivity: Transitivity of the networks.
    \item betweennessMatrix: Betweenness of each node in each cluster.
    \item hubsList: Nodes selected as potential hubs in the global network and within each cluster/metagroup (nodes with betweenness over 75\% in the given network/subnetwork).
    \item intraHubsCount: Number of times each node was selected as potential intra-cluster hub.
}
}

\seealso{
Overview of the package: \code{\link[FGNet:FGNet-package]{FGNet}}

Package tutorial: \code{vignette("FGNet-vignette")}

}
\examples{
\dontrun{
# Previous Steps
jobID <- 3907019
results <- fea_gtLinker_getResults(jobID)
incidMat <- fea2incidMat(results, filterAttribute="Silhouette Width")


# Plot node degree and betweensess
analyzeNetwork(incidMat)

# Get stats without plotting
nwStats <- analyzeNetwork(incidMat, plotOutput=FALSE)
names(nwStats)
nwStats$hubsTable
}
}

\name{FGNet-package}
\alias{FGNet-package}
\alias{FGNet}
\docType{package}
\title{
Functional gene networks derived from biological enrichment analyses
}
\description{
Build and visualize functional gene and term networks from clustering of enrichment analyses in multiple annotation spaces. The package includes a graphical user interface (GUI) and functions to perform the functional enrichment analysis through DAVID, GeneTerm Linker, gage (GSEA) and topGO.
}
\details{
\tabular{ll}{
Package: \tab FGNet\cr
Type: \tab Package\cr
Version: \tab 3.0\cr
License: \tab GPL (>= 2)\cr
}
}
\author{
Author:  Sara Aibar, Celia Fontanillo and Javier De Las Rivas. Bioinformatics and Functional Genomics Group. Cancer Research Center (CiC-IBMCC, CSIC/USAL). Salamanca. Spain.

If you have any issue, you can contact us at: <jrivas at usal.es> 
}
\seealso{
\code{\link[FGNet:FGNet_GUI]{FGNet_GUI()}} provides a Graphical User Interface (GUI) to most of the functionalities of the package: Performing a Functional Enrichment Analysis (FEA) of a list of genes, and analyzing it through the functional networks. 

1. The Functional Enrichment Analysis can be performed through several tools:

\itemize{
\item{GeneTerm Linker [2]: \code{\link[FGNet:fea_gtLinker]{fea_gtLinker()}} & \code{fea_gtLinker_getResults()}
 (Requires internet connection)}
 \item{\link[topGO:getSigGroups]{topGO} [3]: \code{\link[FGNet:fea_topGO]{fea_topGO()}} (Only supports GO. For offline use requires having installed the required database packages)}
 \item{\link[gage:gage]{GAGE} [4]: \code{\link[FGNet:fea_gage]{fea_gage()}} (GSEA analysis. For offline use requires gene sets or installed database packages)}

There are also a few functions to import the results from a previous FEA analysis: \code{\link[FGNet:format_david]{format_david()}}, \code{format_results()} and \code{\link[FGNet:readGeneTermSets]{readGeneTermSets()}}.    

}

2. \code{\link[FGNet:FGNet_report]{FGNet_report()}}: automatically generates a report with the default network options. It includes the following steps, wich can be executed individually to personalize or explore the networks:
\enumerate{
\item{\code{\link[FGNet:fea2incidMat]{fea2incidMat()}}: Transforms the FEA output into incidence matrices. These function determines wether the network will be gene- or term-based.}
 
\item{\code{\link[FGNet:functionalNetwork]{functionalNetwork()}}: Generates and plots the functional networks. 
These networks can be further explored by \code{\link[FGNet:analyzeNetwork]{analyzeNetwork()}} and \code{\link[FGNet:clustersDistance]{clustersDistance()}}. 

Other auxiliary functions:
\code{\link[FGNet:getTerms]{getTerms()}}, 
\code{\link[FGNet:keywordsTerm]{keywordsTerm()}}, 
\code{\link[FGNet:plotGoAncestors]{plotGoAncestors()}}
}

For more info see the package tutorial: \code{vignette("FGNet-vignette")}
}
}

\references{
	[1] Fontanillo C, Nogales-Cadenas R, Pascual-Montano A, De Las Rivas J (2011) Functional Analysis beyond Enrichment: Non-Redundant Reciprocal Linkage of Genes and Biological Terms. PLoS ONE 6(9): e24289. URL: \url{http://gtlinker.cnb.csic.es}
	
	[2] Huang DW, Sherman BT, Lempicki RA (2009) Bioinformatics enrichment tools: paths toward the comprehensive functional analysis of large gene lists. Nucleic Acids Res. 37(1):1-13. URL: \url{http://david.abcc.ncifcrf.gov/}
    
	[3] Alexa A, and Rahnenfuhrer J (2010) topGO: Enrichment analysis for Gene Ontology. R package version 2.16.0. URL: \url{http://www.bioconductor.org/packages/release/bioc/html/topGO.html}
    
	[4] Luo W, Friedman MS, Shedden K, Hankenson KD, Woolf PJ (2009) GAGE: generally applicable gene set enrichment for pathway analysis. BMC Bioinformatics. 10:161. URL: \url{http://www.bioconductor.org/packages/release/bioc/html/gage.html}
    
    
}
\examples{

\dontrun{
# GUI:
FGNet_GUI()


# 1. FEA:
geneList <- c("YBL084C", "YDL008W", "YDR118W", "YDR301W", "YDR448W", "YFR036W", 
    "YGL240W", "YHR166C", "YKL022C", "YLR102C", "YLR115W", "YLR127C", "YNL172W", 
    "YOL149W", "YOR249C")
    
library(org.Sc.sgd.db)
geneLabels <- unlist(as.list(org.Sc.sgdGENENAME)[geneList])

# Optional: Gene expression 
geneExpr <- setNames(c(rep(1,10),rep(-1,5)), geneLabels)

# Choose FEA tool...
# results <- fea_david(geneList, geneLabels=geneLabels, email="example@email.com")
results <- fea_gtLinker_getResults(jobID=3907019)

# 2 A) Report:
FGNet_report(results, geneExpr=geneExpr)

# 2 B) Step by step:
# 2.1. Create incidence matrices:
incidMat <- fea2incidMat(results)
incidMat_terms <- fea2incidMat(results, key="Terms")

# 2.2. Explore networks:
functionalNetwork(incidMat, geneExpr=geneExpr)
functionalNetwork(incidMat_terms, plotType="bipartite", plotOutput="dynamic")
getTerms(results)

nwStats <- analyzeNetwork(incidMat)
clustersDistance(incidMat)
}
}
\keyword{ package }
\keyword{ interface }
\keyword{ graphs }
\keyword{ dynamic }
\keyword{ visualization }
\keyword{ annotation }
\keyword{ pathways }
\keyword{ GO }
\keyword{ GeneSet enrichment }
\keyword{ Networks }
\keyword{ Functional analysis }
